// DaaView.h : interface of the CDaaView class
//
/////////////////////////////////////////////////////////////////////////////

class CDaaView : public CView
{
protected: // create from serialization only
	CDaaView();
	DECLARE_DYNCREATE(CDaaView)

// Attributes
public:
	CDaaDoc* GetDocument();



// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDaaView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDaaView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDaaView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClose();

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void CDaaView::OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);

	afx_msg void OnViewSpectrum3d();
	afx_msg void OnUpdateViewSpectrum3d(CCmdUI* pCmdUI);
	afx_msg void OnViewSetreference();
	afx_msg void OnUpdateViewSetreference(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewMultidraw(CCmdUI* pCmdUI);
	afx_msg void OnViewMultidraw();

	afx_msg void OnTestStopdraw();
	afx_msg void OnUpdateTestStopdraw(CCmdUI* pCmdUI);
	afx_msg void OnTestViewsamples();
	afx_msg void OnUpdateTestViewsamples(CCmdUI* pCmdUI);

	afx_msg void OnBwMax();
	afx_msg void OnBw30();
	afx_msg void OnBw10();
	afx_msg void OnBw3();
	afx_msg void OnBw1();
	afx_msg void OnUpdateBwMax(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw30(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw10(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw1(CCmdUI* pCmdUI);

	afx_msg void OnFhtWin0();
	afx_msg void OnFhtWin1();
	afx_msg void OnFhtWin2();
	afx_msg void OnFhtWin3();
	afx_msg void OnFhtWin4();
	afx_msg void OnFhtWin5();
	afx_msg void OnFhtWin6();
	afx_msg void OnFhtWin7();
	afx_msg void OnFhtWin8();
	afx_msg void OnFhtWin9();
	afx_msg void OnFhtWin10();
	afx_msg void OnFhtWin11();
	afx_msg void OnFhtWin12();
	afx_msg void OnFhtWin13();
	afx_msg void OnUpdateFhtWin0(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin4(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin5(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin6(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin7(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin8(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin9(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin10(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin11(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin12(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFhtWin13(CCmdUI* pCmdUI);

	afx_msg void OnFilterCH1_Unfiltered();
	afx_msg void OnFilterCH1_LowPass();
	afx_msg void OnFilterCH1_HiPass();
	afx_msg void OnFilterCH2_Unfiltered();
	afx_msg void OnFilterCH2_LowPass();
	afx_msg void OnFilterCH2_HiPass();
	afx_msg void OnFiltersPoles_1();
	afx_msg void OnFiltersPoles_2();
	afx_msg void OnFiltersPoles_4();
	afx_msg void OnFiltersPoles_8();
	afx_msg void OnFiltersPoles_16();
	afx_msg void OnFiltersPoles_32();

	// TODO
	afx_msg void OnUpdateFilterCH1_Unfiltered(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilterCH1_LowPass(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilterCH1_HiPass(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilterCH2_Unfiltered(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilterCH2_LowPass(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilterCH2_HiPass(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFiltersPoles_1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFiltersPoles_2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFiltersPoles_4(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFiltersPoles_8(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFiltersPoles_16(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFiltersPoles_32(CCmdUI* pCmdUI);
	
	afx_msg void OnOpenMixers();
	afx_msg void OnOpenAudioDevices();
	afx_msg void OnRegisterDaaFiles();
	afx_msg void OnRememberAllProps();
	afx_msg void OnUpdateRememberAllProps(CCmdUI* pCmdUI);

	afx_msg void OnHelpHelp();

	afx_msg void OnSetInputDevice(UINT nID);
	afx_msg void OnSetOutputDevice(UINT nID);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DaaView.cpp
inline CDaaDoc* CDaaView::GetDocument()
   { return (CDaaDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
