// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Daa.h"

#include "MainFrm.h"

#include "GlobalParams.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
    /*
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
    */
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// - TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    cs.style = WS_OVERLAPPED | WS_SYSMENU | WS_BORDER | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_SIZEBOX;
    //cs.style |= 0x00008000;

	return CFrameWnd::PreCreateWindow(cs);
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	// --------------------------------------------------- limit only if LButton is pressed
	if ((GetAsyncKeyState(VK_LBUTTON) & 0x8000) != 0)
	{
		lpMMI->ptMinTrackSize.x = 894;
		lpMMI->ptMinTrackSize.y = 659; 
	}
    CFrameWnd::OnGetMinMaxInfo(lpMMI);
}

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg)
{
	// ---------------------------------------------------------------------- 
	//  Prevent the ALT KEY alone to open the MENU and lock dialer movements
	// ---------------------------------------------------------------------- 
	if (pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_MENU)
	{
		pMsg->wParam = 0;
	}
	// ---------------------------------------------------------------------- 
	//  Detect CTRL-X / CTRL-C / CTRL-V
	//  Must detect here because they are not reported in the KeyDown event  
	//  We not test CTRL because in the INDICATOR the letters are removed
	//  and testing it the keyboard on screen does not works
	// ---------------------------------------------------------------------- 
	//if( pMsg->message == WM_KEYDOWN && KeyPressed(VK_CONTROL)) 
	if( pMsg->message == WM_KEYDOWN) 
	{
		if (pMsg->wParam == int('X') ||
			pMsg->wParam == int('C') ||
			pMsg->wParam == int('V'))
		{
			DAA_CTRL_XCV_Keys(pMsg->wParam);
		}
	}
    return CFrameWnd::PreTranslateMessage(pMsg);
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1) return -1;

	// --------------------------------------------------------- get the portion of the screen not obscured by the system taskbar
	CRect r;
	SystemParametersInfo(SPI_GETWORKAREA, 0, &r, 0);
	// --------------------------------------------------------- get the max virtial screen X and Y
	int Xmax = ::GetSystemMetrics(SM_CXVIRTUALSCREEN);
	//int Ymax = ::GetSystemMetrics(SM_CYVIRTUALSCREEN);

	// --------------------------------------------------------- ensure normal values
	if (StartupWindowPosX < 0) StartupWindowPosX = 0;
	if (StartupWindowPosY < 0) StartupWindowPosY = 0;
	if (StartupWindowPosX > Xmax - 50) StartupWindowPosX = Xmax - 50;
	if (StartupWindowPosY > r.Height() - 50) StartupWindowPosY = r.Height() - 50;
	if (StartupWindowSizeX < 873) StartupWindowSizeX = 873;
	if (StartupWindowSizeY < 610) StartupWindowSizeY = 610;
	if (StartupWindowSizeX > 9000) StartupWindowSizeX = 9000;
	if (StartupWindowSizeY > 9000) StartupWindowSizeY = 9000;
	
	// --------------------------------------------------------- calc the x and y corrections
    int dx = ::GetSystemMetrics(SM_CXEDGE) * 2;			//2*2
	   dx += ::GetSystemMetrics(SM_CXSIZEFRAME) * 2;	//8*2
    
	int dy = ::GetSystemMetrics(SM_CYEDGE) * 2;			//2*2
	   dy += ::GetSystemMetrics(SM_CYCAPTION);			//23
	   dy += ::GetSystemMetrics(SM_CYMENU);				//20
	   dy += 2;											//2 ??
	   //dy += ::GetSystemMetrics(SM_CYSIZEFRAME) * 2;	//8*2

	// --------------------------------------------------------- client size correction
	CLIENT_X = StartupWindowSizeX - dx;	// must be 20
	CLIENT_Y = StartupWindowSizeY - dy; // must be 49

	resizedClientX = CLIENT_X;
	resizedClientY = CLIENT_Y;
	
	// --------------------------------------------------------- PreDraw all the DAA
	CDC* pDC = GetDC();
	DAA_CreateInstrument(pDC);
	DAA_RestorePropsFromLastRun();

	// --------------------------------------------------------- Place and show the window
	CRect rect(StartupWindowPosX, StartupWindowPosY,  
			   StartupWindowPosX + StartupWindowSizeX, 
			   StartupWindowPosY + StartupWindowSizeY);

	AfxGetApp()->m_nCmdShow = StartupWindowState;
	SetWindowPos(NULL, rect.left, rect.top, StartupWindowSizeX, StartupWindowSizeY, 0);

	// ----------------------------------------------------------------------------------------------
	//  Using "return 0" all is OK
	// ----------------------------------------------------------------------------------------------
	//  Using "return CFrameWnd::OnCreate(lpCreateStruct);" 
	//  after some resize waves and spectrum are not shown in the right display area 
	// ----------------------------------------------------------------------------------------------
	return 0;
	//return CFrameWnd::OnCreate(lpCreateStruct);
}


BOOL CMainFrame::DestroyWindow() 
{
	// ------------------------------------------------- get window position, size and flags
    WINDOWPLACEMENT wp;
    GetWindowPlacement(&wp);
	// ------------------------------------------------- vars ready to save on "DaaMainSettings.ini"
	StartupWindowState = wp.showCmd;
	StartupWindowPosX = wp.rcNormalPosition.left;
	StartupWindowPosY = wp.rcNormalPosition.top;
	StartupWindowSizeX = wp.rcNormalPosition.right - wp.rcNormalPosition.left;
	StartupWindowSizeY = wp.rcNormalPosition.bottom - wp.rcNormalPosition.top;
	// ------------------------------------------------- 
	return CFrameWnd::DestroyWindow();
}





/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
