
#ifndef INC_UTILITYFUNCTIONS
#define INC_UTILITYFUNCTIONS

extern double FirstSlot;

void WriteSlot(double slot, double value);
float ReadSlot(double slot);

void InitTime();
int GetTime();
void MessageTime(CWnd* wnd);

template <typename T> int sgn(T val);

void SmoothValue_Pow_Adaptive(double& value, double new_value, double speed);
void SmoothValue_Simple(double& value, double new_value, double speed);
void SmoothValue(double& value, double new_value, double speed);

double RoundToNdigits_Floor(double n, int nDigits);
double RoundToNdigits(double n, int nDigits);
double RoundToNdigits2(double n, int nDigits, int nMaxDecimals);
CString MillivoltToString(double mV, int nDigits);
CString MillivoltToString2(double mV, int nDigits);
CString MillisecToString(double mS, int nDigits);
CString MillisecToString2(double mS, int nDigits);
CString HertzToString(double Hz, int nDigits);
CString HertzToString(double Hz, int nDigits, int nDecimals);
CString DecibelToString(double dB);

double mVppToDB(double mVpp);
double VrmsTodB(double Vrms);

bool LButtonPressed();
bool RButtonPressed();
bool KeyPressed(UINT key);

void Print(CDC* pDC, int x, int y, int v);
void Print(CDC* pDC, int x, int y, float v);
void Print(CDC* pDC, int x, int y, double v);
void Print(CDC* pDC, int x, int y, CString str);

COLORREF InterpolateColor(double index,  COLORREF c[], int len);

int CorrectMicrometricMouse(short zDelta);

double CorrectByControKeys(double n);

CString GetTextFromClipBoard(HWND hWnd);
void SendTextToClipBoard(HWND hWnd, CString strData);


// =======================================================================================
//  Calculate exponential value in the range FMIN to FMAX
// =======================================================================================
class CEsponential
{
protected:
    double logFmin;
	double logFmax;

public:
	CEsponential(double fmin, double fmax)
	{
		logFmin = log(fmin);
		logFmax = log(fmax);
	}

	double Calc(double n)
	{
		return exp(logFmin + (logFmax - logFmin) * n);
	}
};


#endif