
#include <afxadv.h>  //Has CRecentFileList class definition
#include "stdafx.h"
#include "MainFrm.h"
#include "DaaDoc.h"
#include "DaaView.h"
#include "GlobalParams.h"
//#include "dos.h"
//#include "mmreg.h"
#include "Daa.h"
#include "FHT.h"
#include "Filters.h"
#include "UtilityFunctions.h"
#include "MemoryMappedFiles.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CDaaApp

BEGIN_MESSAGE_MAP(CDaaApp, CWinApp)
	//{{AFX_MSG_MAP(CDaaApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	
	// ----------------------------------------------------------- overrided
	//ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_OPEN, DaaFileOpen)
	ON_COMMAND_RANGE(ID_FILE_MRU_FILE1, ID_FILE_MRU_FILE4, DaaMRUFileOpen)
	// ---------------------------------------------------------------------
	
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  DaaFileOpen and DaaMRUFileOpen overrided to reopen also the last opened file 
//
//  http://support.microsoft.com/default.aspx?scid=kb;en-us;139828
//  http://support.microsoft.com/kb/243751/en-us
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CDaaApp::DaaFileOpen()
{
   // ---------------------------------------- prompt the user
   CString newName;
   if (DoPromptFileName(newName, AFX_IDS_OPENFILE, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TRUE, NULL))
   {
		// ----------------------------------- Get pTemplate, a pointer to one of the app's document templates
		POSITION template_pos = AfxGetApp()->GetFirstDocTemplatePosition();
		if (NULL!=template_pos) 
		{
			CDocTemplate* pDocTemplate = AfxGetApp()->GetNextDocTemplate(template_pos);
			pDocTemplate->OpenDocumentFile(newName);
		}
	   return true;
   }
   else
   {
	   return false;
   }
}


void CDaaApp::DaaMRUFileOpen(UINT i)
{
    CString strName, strCurDir, strMessage;
    int nIndex = i - ID_FILE_MRU_FILE1;
    if ((*m_pRecentFileList)[nIndex].GetLength() != 0)
	{
		strName = (LPCTSTR)(*m_pRecentFileList)[nIndex];

		// ---------------------- Get pTemplate, a pointer to one of the app's document templates
		POSITION template_pos = AfxGetApp()->GetFirstDocTemplatePosition();
		if (NULL!=template_pos) 
		{
			CDocTemplate* pDocTemplate = AfxGetApp()->GetNextDocTemplate(template_pos);
			if (pDocTemplate->OpenDocumentFile(strName) == NULL)
			{
				m_pRecentFileList->Remove(nIndex);
			}
		}
	}
}




/////////////////////////////////////////////////////////////////////////////
// CDaaApp construction

CDaaApp::CDaaApp()
{
	// //TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


/////////////////////////////////////////////////////////////////////////////
// The one and only CDaaApp object

CDaaApp theApp;

// ========================================================================
//  DAA PROPS
// ========================================================================
int helpindex, oldhelpindex;
CDC MemDC;
CBitmap MemBmp;

CFrame daaFrame, frame1, frame2, frame3, frame4, frame5, frame6;
CDisplay display;
CDialer dialer, dialer1, dialer2, dialer3;
CDialer dialer4, dialer5, dialer6, dialer7;
CDialer dialer8, dialer9, dialer10;
CDialer dialer11, dialer12, dialer13, dialerTrig;
CKey keyTrigSlope, keyTrigBurst; 
CKey keysamp, keycalspectrum, keycal, keycalVolt, keycalOut;
CKey keyAc1, keyAc2, keyNeg1, keyNeg2, keyMul1, keyMul2;
CKeyboard kbInOnOff, kbOutOnOff;
CKeyboard kbChan;
CKeyboard kbWtype, kbAtype, kbRtype, kbRtype2;
CKeyboard kbTrig, kbChtrig;
CKeyboard kbCurs, kbTime, kbVolt;
CKeyboard kbXlog, kbYlog;
CPalette palette;
CLed ledtrig, ledcal;
CIndicator indicator;

int triggerPixelY;
int clickedDialerID;
int StopDelayChanges = 0;
bool displayEdit = false;
double displayEdit_InitialDelaypos;
int	displayEdit_InitialPixel;	
int displayEdit_EditCursor;
bool displayEdit_EditTriggerPos;

// ------------------------------------------------------------------
COLORREF black, panels, wavepanel, col_pressed;
COLORREF col_lighted_border; 
COLORREF grey0, grey1, grey2, grey3, grey4, grey5, grey6, grey7, grey8, grey9, white;
COLORREF dgrid, dback, trace;

COLORREF TraceColors[] = {RGB(255,150,0), RGB(255,255,0), RGB(100,255,100), RGB(100,230,255), RGB(255,255,255)};

CBrush backBrush (RGB (160, 160, 160));

const double DOUBLEMAX = 1e99;
const double DOUBLEMIN = -1e99;
const CString READY_MESSAGE = "Ready -- Use mouse, mouse wheel, arrow keys and pageUp/Down keys -- Change speed with SHIFT, CTRL and ALT -- Set defaults with double click";
					

int RememberAllProps = 0;
double polarity1 = 1;
double polarity2 = 1;

bool WindowMinimized;

// ------------------------------------------------------------------ display width and height
int dispdx;
int dispdy;

// ------------------------------------------------------------------ spectrum grid fontsize, width and height
int fontsize;
int spectrumGridFontSize;
int leftborder; 
int downborder;
int dispx;
int dispy;

// ------------------------------------------------------------------
int sweepLimit;
int sweepPos;
int sweepSample;
double sweepFreq;
int sweepStatus;
int random;
double random2;

int cbufPos;
double delaypos, deltapos;

int pulse_position = 0;

bool calibratedResponse;

bool DisplaySamples;
bool multiDraw;
bool spectrum3D;
bool burstflag;

int BufOutIndex, BufInIndex;
int activeOutBuffers = 0;
int activeInBuffers = 0;

int numCH;

double phase; 
int burstcounter;
int readpos;
int readpos1, readpos2;
int sampPerScreen;
int pulseCbuffPos;
double tglev;

double trigvoid, trigpos, triglev, trigist, trigstab, trigstop;
BOOL trigslope;
BOOL trigburst;
int trigsample;
bool triggered;

double mVdc, mVdcInst;
double mVpp, mVppInst;
double mVpp1, mVpp2;

bool Calibrating = false;
double calib_vmax1, calib_vmin1, calib_vmax2, calib_vmin2;

double vmax1, vmin1, vmax2, vmin2;
double vmax_sweep, vmin_sweep;
double vmidinst1, vmidinst2;
double vmid1, vmid2;
double rmsSum1, rmsSum2, rmsSamplesCounter;
double vrms1, vrms2;

double oldfreq;

double gridLight, osdIntensity, traceIntensity;

double scaleX, scaleY1, scaleY2;
double regX, regY1, regY2, filterFrequency1, filterFrequency2;
double posY1, posY2;
double posY1_discrete, posY2_discrete;

int calY1, calY2;
double CalibrationVoltage = 1.36;
double gain1 = 2;
double gain2 = 2;

double curs1, curs2;
double responsespeed;
int curstype;
int timetype, volttype;
int xlogtype, ylogtype;

int inputDevice;
int outputDevice;
int inputState;
int outputState;

int selectCH, trigCH;
BOOL ac1, ac2, neg1, neg2;
double mul1, mul2;

int wavetype;
int analysisType;
int regulationType;
int trigType;

double freq;
double freqMin;
double freqMax;
double sweepTime;
double start_sampling_ms;
double sampling_ms;

double duty;
double burstCycles;
double pauseCycles;
double dbmin;
double dbmax;
double outlevel;
double deltalevel1;
double deltalevel2;

int    bandwidth;
double  band;

int    fhtwindow;

int Filter_CH1 = 0;
int	Filter_CH2 = 0;
int	Filters_Npoles = 0;

double fmeterTrigDown = 0;
double fmeterTrigUp = 0;
bool fmeterFlag = false;                                                                
int fmeterSamples = 0;             
int fmeterCycles = 0;    
int fmeterResultSamples = 0;
int fmeterResultCycles = 0; 

int initSamples = 0;
int fht_samples = 0;

bool pulseFlag = false;
bool referenceFlag = false;

CEsponential FiltersEsponential(1, 50000);
CFilter_MultiPole_FixedSampling filterCH1;
CFilter_MultiPole_FixedSampling filterCH2;

bool StopLevelCrossed = false;
int StopLevelCircularBufferPos;
double StopLevelRawValue;
double StopLevelRawValueOld;


/////////////////////////////////////////////////////////////////////////////
// CDaaApp INPUT OUTPUT DEVICES
/////////////////////////////////////////////////////////////////////////////

const int IN_DEVICES_SUBMENU = 10;
const int OUT_DEVICES_SUBMENU = 12;

CString ExtractDeviceName(CString s) 
{      
	CString s2 = s;
    int i = s.Find("(") - 1;
    if (i > 1) s2 = s.Mid(0, i);
	s2.TrimLeft();
	s2.TrimRight();
	s.MakeLower();
	if (s.Find("usb") > 0) s2 = s2 + " USB";
    return s2;
}

CString GetInputDeviceName() 
{        
    WAVEINCAPS Caps;
	int nDevs = waveInGetNumDevs();
	if (inputDevice >= nDevs) inputDevice = 0;
	waveInGetDevCaps(inputDevice, &Caps, sizeof(Caps)); 
	CString str = "";
	if (Caps.szPname != NULL) str = Caps.szPname;
	str = ExtractDeviceName(str);
    return str;
}

CString GetOutputDeviceName() 
{        
    WAVEOUTCAPS Caps;
	int nDevs = waveOutGetNumDevs();
	if (outputDevice >= nDevs) outputDevice = 0;
	waveOutGetDevCaps(outputDevice, &Caps, sizeof(Caps)); 
	CString str = "";
	if (Caps.szPname != NULL) str = Caps.szPname;
	str = ExtractDeviceName(str);
    return str;
}

void CDaaApp::AddInputDevicesMenu()
{
	static bool working = false;
	if (working) return;
	working = true;

	m_pMainWnd->GetMenu()->ModifyMenu(IN_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, IN_DEVICES_SUBMENU, "IN: " + GetInputDeviceName());

	CMenu* pSubMenu;
	pSubMenu = m_pMainWnd->GetMenu()->GetSubMenu(IN_DEVICES_SUBMENU);
	while (pSubMenu->GetMenuItemCount() > 0)
	{
		for (int i = 0; i < 99; i++)
		{
			pSubMenu->DeleteMenu(i, MF_BYPOSITION);
		}
	}

	WAVEINCAPS Caps;
	int nDevs = waveInGetNumDevs();
	if (nDevs == 0)
	{
		//pSubMenu->AppendMenu(MF_STRING, ID_INPUT_DEVICES_FIRST, "---");
		m_pMainWnd->GetMenu()->ModifyMenu(IN_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, IN_DEVICES_SUBMENU, "IN: ---");
	}
	else
	{
		for (int i = 0; i < nDevs; i++)
		{
			waveInGetDevCaps(i, &Caps, sizeof(Caps));
			CString str = Caps.szPname;
			str = ExtractDeviceName(str);
			pSubMenu->AppendMenu(MF_STRING, ID_INPUT_DEVICES_FIRST + i, str);
			if (i == inputDevice)
			{
				pSubMenu->CheckMenuItem(i, MF_BYPOSITION | MF_CHECKED);
			}
		}
	}

	working = false;
}

void CDaaApp::AddOutputDevicesMenu()
{
	CMenu* pSubMenu;
	pSubMenu = m_pMainWnd->GetMenu()->GetSubMenu(OUT_DEVICES_SUBMENU);
	while (pSubMenu->GetMenuItemCount() > 0)
	{
		for (int i = 0; i < 99; i++)
		{
			pSubMenu->DeleteMenu(i, MF_BYPOSITION);
		}
	}

	WAVEOUTCAPS Caps;
	int nDevs = waveOutGetNumDevs();
	if (nDevs == 0)
	{
		//pSubMenu->AppendMenu(MF_STRING, ID_OUTPUT_DEVICES_FIRST, "---");
		m_pMainWnd->GetMenu()->ModifyMenu(OUT_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, OUT_DEVICES_SUBMENU, "OUT: ---");
	}
	else
	{
		for (int i = 0; i < nDevs; i++)
		{
			waveOutGetDevCaps(i, &Caps, sizeof(Caps));
			CString str = Caps.szPname;
			str = ExtractDeviceName(str);
			pSubMenu->AppendMenu(MF_STRING, ID_OUTPUT_DEVICES_FIRST + i, str);
			if (i == outputDevice)
			{
				pSubMenu->CheckMenuItem(i, MF_BYPOSITION | MF_CHECKED);
			}
		}
		m_pMainWnd->GetMenu()->ModifyMenu(OUT_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, OUT_DEVICES_SUBMENU, "OUT: " + GetOutputDeviceName());
	}
}

void DAA_SetInputDevice(int n)
{
	int oldInputState = inputState;
	if (oldInputState != 0) DAA_InputOff();
	// -------------------------------------- 
	inputDevice = n;
	if (waveInGetNumDevs() == 0)
	{
		theApp.m_pMainWnd->GetMenu()->ModifyMenu(IN_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, IN_DEVICES_SUBMENU, "IN: ---");
	}
	else
	{
		theApp.m_pMainWnd->GetMenu()->ModifyMenu(IN_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, IN_DEVICES_SUBMENU, "IN: " + GetInputDeviceName());
	}	
	// -------------------------------------- refresh menu
	theApp.m_pMainWnd->DrawMenuBar();
	// -------------------------------------- 
	if (oldInputState) DAA_InputOn();
}

void DAA_SetOutputDevice(int n)
{
	int oldOutputState = outputState;
	if (oldOutputState != 0) DAA_OutputOff();
	// -------------------------------------- 
	outputDevice = n;
	if (waveOutGetNumDevs() == 0)
	{
		theApp.m_pMainWnd->GetMenu()->ModifyMenu(OUT_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, OUT_DEVICES_SUBMENU, "OUT: ---");
	}
	else
	{
		theApp.m_pMainWnd->GetMenu()->ModifyMenu(OUT_DEVICES_SUBMENU, MF_BYPOSITION|MF_STRING, OUT_DEVICES_SUBMENU, "OUT: " + GetOutputDeviceName());
	}	
	// -------------------------------------- refresh menu
	theApp.m_pMainWnd->DrawMenuBar();
	// -------------------------------------- 
	if (oldOutputState) DAA_OutputOn();
}

// ==============================================================================
//  Create and exec a "daa_auto_file.reg" file in the C:\temp folder
// ==============================================================================
//  The final Registry entry are:
//    HKEY_CLASSES_ROOT\.daa
//    "daa_auto_file"
//    HKEY_CLASSES_ROOT\daa_auto_file\shell\open\command
//    "C:\......\DigitalAudioAnalyser\Daa.exe" "%1" 
// ==============================================================================
void DAA_RegisterDaaAutoFile()
{
	// ------------------------------------------------------------ get application path and name
	TCHAR szDirectory[MAX_PATH] = "";
	::GetModuleFileName(NULL, szDirectory, sizeof(szDirectory) - 1);
	CString AppPath(szDirectory);
	// ------------------------------------------------------------ create the .reg file
	CFile f;
	CreateDirectory("C:\\Temp", NULL);
	f.Open("C:\\Temp\\daa_auto_file.reg", CFile::modeCreate | CFile::modeWrite);
	CArchive ar(&f, CArchive::store);
	// ------------------------------------------------------------ create keys
	ar.WriteString("Windows Registry Editor Version 5.00\r\n");
	ar.WriteString("\r\n");
	ar.WriteString("[HKEY_CLASSES_ROOT\\.daa]\r\n");
	ar.WriteString("@=\"daa_auto_file\"\r\n");
	ar.WriteString("\r\n");
	ar.WriteString("[HKEY_CLASSES_ROOT\\daa_auto_file\\shell\\open\\command]\r\n");
	// ------------------------------------------------------------ write the application path and name
	AppPath.Replace("\\", "\\\\");
	ar.WriteString("@=\"\\\""+ AppPath + "\\\" \\\"%1\\\"\"\r\n");
	// ------------------------------------------------------------ close the .reg file
	ar.Close();
	f.Close();
	// ------------------------------------------------------------ execute the .reg file
	ShellExecute(NULL, 
				 "open", 
				 "C:\\Temp\\daa_auto_file.reg", 
				 NULL, 
				 NULL, 
				 SW_SHOWDEFAULT);
}

void DAA_ToggleRememberAllProps()
{
	RememberAllProps = !RememberAllProps;
}

int DAA_GetRememberAllProps()
{
	return RememberAllProps;
}



/////////////////////////////////////////////////////////////////////////////
// CDaaApp INIT INSTANCE
/////////////////////////////////////////////////////////////////////////////

BOOL CDaaApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			 // Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	 // Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();    // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
	CSingleDocTemplate* pDocTemplate;

	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDaaDoc),
		RUNTIME_CLASS(CMainFrame), // main SDI frame window
		RUNTIME_CLASS(CDaaView));
	AddDocTemplate(pDocTemplate);


	// ---------------------------- Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

    //DAA specific
	//if (m_lpCmdLine[0] == '\0')
	//{
	//	cmdInfo.m_strFileName = "Base.daa";
	//  cmdInfo.m_nShellCommand = CCommandLineInfo::FileOpen;
	//  //OpenDocumentFile("Sweep.daa");
	//}

	DAA_InitDefaultValues();
	DAA_ReadMainProps();
	
	// -------------------------------------- Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo)) return FALSE;

	m_pMainWnd->SetWindowText("Theremino System - DAA V4.2");

	// -------------------------------------- add devices menu entries
	AddInputDevicesMenu();
	AddOutputDevicesMenu();
	// -------------------------------------- refresh menu
	theApp.m_pMainWnd->DrawMenuBar();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CDaaApp EXIT INSTANCE
/////////////////////////////////////////////////////////////////////////////

BOOL CDaaApp::ExitInstance()
{
	DAA_End();
	return CWinApp::ExitInstance();
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
/////////////////////////////////////////////////////////////////////////////

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDaaApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}



// ================================================================================================
// ================================================================================================
//  READ WRITE - MAIN PROPS and ALL PROPS
// ================================================================================================
// ================================================================================================
CString DAA_GetDataPath()
{
	// ------------------------------------------------------------- get application path
	TCHAR szDirectory[MAX_PATH] = "";
	::GetModuleFileName(NULL, szDirectory, sizeof(szDirectory) - 1);
	CString s(szDirectory);
	s = s.Left(s.ReverseFind('\\'));
	// ------------------------------------------------------------- add "Settings"
	s += "\\Settings";
	CreateDirectory(s, NULL);
	return s;
}

void DAA_WriteMainProps()
{
	CString s; 
	CFile f;
	f.Open(DAA_GetDataPath() + "\\DaaMainSettings.ini", CFile::modeCreate | CFile::modeWrite);
	CArchive ar(&f, CArchive::store);
	ar.Write(&StartupWindowPosX, sizeof(StartupWindowPosX));
	ar.Write(&StartupWindowPosY, sizeof(StartupWindowPosY));
	ar.Write(&StartupWindowSizeX, sizeof(StartupWindowSizeX));
	ar.Write(&StartupWindowSizeY, sizeof(StartupWindowSizeY));
	ar.Write(&StartupWindowState, sizeof(StartupWindowState));
	ar.Write(&calY1, sizeof(calY1));
	ar.Write(&calY2, sizeof(calY2));
	ar.Write(&deltalevel1,sizeof(deltalevel1));
	ar.Write(&deltalevel2,sizeof(deltalevel2));
	ar.Write(&gain1, sizeof(gain1));
	ar.Write(&gain2, sizeof(gain2));
	ar.Write(&inputDevice, sizeof(inputDevice));
	ar.Write(&outputDevice, sizeof(outputDevice));
	ar.Write(&RememberAllProps, sizeof(RememberAllProps));
	ar.Close();
	f.Close();
}

void DAA_ReadMainProps()
{   
	// ------------------------ Initialization of the default Main-Props
	StartupWindowPosX = 0;
	StartupWindowPosY = 0;
	StartupWindowSizeX = 894; // This must be exact to avoid flickering when starting without MainSettings.INI file 
	StartupWindowSizeY = 659; // This must be exact to avoid flickering when starting without MainSettings.INI file 
	StartupWindowState = 1;
	// ------------------------- default values valid for CM6206 audio card with Level = 95 
	gain1 = 2.34;
	gain2 = 2.34;
	calY1 = 19000;
	calY2 = 19000;
	// ------------------------- default for in out devices and RememberAllProps
	inputDevice = 0;
	outputDevice = 0;
	RememberAllProps = TRUE;

	// ----------------------------------------- Read the Main-Props
	CString s;
	CFile f;
	if (f.Open(DAA_GetDataPath() + "\\DaaMainSettings.ini", CFile::modeRead))
	{
		CArchive ar(&f, CArchive::load);
		ar.Read(&StartupWindowPosX, sizeof(StartupWindowPosX));
		ar.Read(&StartupWindowPosY, sizeof(StartupWindowPosY));
		ar.Read(&StartupWindowSizeX, sizeof(StartupWindowSizeX));
		ar.Read(&StartupWindowSizeY, sizeof(StartupWindowSizeY));
		ar.Read(&StartupWindowState, sizeof(StartupWindowState));
		ar.Read(&calY1, sizeof(calY1));
		ar.Read(&calY2, sizeof(calY2));
		if (calY1 > 32000 || calY1 < -32000) calY1 = 0;
		if (calY2 > 32000 || calY2 < -32000) calY2 = 0;
		ar.Read(&deltalevel1,sizeof(deltalevel1));
		ar.Read(&deltalevel2,sizeof(deltalevel2));

		ar.Read(&gain1, sizeof(gain1));
		ar.Read(&gain2, sizeof(gain2));
		if (gain1 > 200 || gain1 < .02) gain1 = 2;
		if (gain2 > 200 || gain2 < .02) gain2 = 2;
		ar.Read(&inputDevice, sizeof(inputDevice));
		ar.Read(&outputDevice, sizeof(outputDevice));
		ar.Read(&RememberAllProps, sizeof(RememberAllProps));
		ar.Close();
		f.Close();
	}
}

void DAA_WriteAllProps()
{
	CString s;
	CFile f;
	CreateDirectory(DAA_GetDataPath(), NULL);
	f.Open(DAA_GetDataPath() + "\\DaaAllSettings.ini", CFile::modeCreate | CFile::modeWrite);
	CArchive ar(&f, CArchive::store);
	DAA_Save(ar);
	ar.Close();
	f.Close();
}

void DAA_ReadAllProps()
{   
	CFile f;
	if (f.Open(DAA_GetDataPath() + "\\DaaAllSettings.ini", CFile::modeRead))
	{
		CArchive ar(&f, CArchive::load);
		DAA_Load(ar);
		ar.Close();
		f.Close();
	}
	DAA_InitAfterLoad();
}



// ================================================================================================
// ================================================================================================
//  SWEEP
// ================================================================================================
// ================================================================================================
void DAA_ResetSweep(BOOL resetAll)
{
    if (analysisType != ANTYPE_SWEEP) return;

    // IN
    cbufPos = 0;
    vmax_sweep = -DOUBLEMAX;
    vmin_sweep = DOUBLEMAX;
    sweepLimit = 0;  
    sweepPos = -200;

    // OUT
    sweepFreq = freqMin;
    sweepSample = 0;
    phase = 0;

    sweepStatus = 1;
    if (resetAll) sweepStatus = 2;      
}


// ================================================================================================
// ================================================================================================
//  FILL BUFFER
// ================================================================================================
// ================================================================================================
void DAA_FillBuffer()
{
    WAVEHDR* pwh;
    __int16* pbuf;
    int i;

    BufOutIndex++;
    if (BufOutIndex >= N_BUFOUT) BufOutIndex = 0;
   
    pwh = &pwhOut[BufOutIndex];
    pbuf = pbufOut[BufOutIndex];

	double amplitude1 = 32767 * exp((outlevel + deltalevel1) / kdb);
	double amplitude2 = 32767 * exp((outlevel + deltalevel2) / kdb);
              
    // ===================================================== PULSE
    if (analysisType == ANTYPE_PULSE)
    {    
		for	(i = 0; i < OUT_BUF_LEN; i += 2)
		{
			if (pulse_position >= PULSE_TOTAL_SAMPLES) 
			{
				pulse_position = 0;
				pulseFlag = true;
			}

			if (pulse_position < PULSE_SAMPLES)
			{
				pbuf[i]     = __int16((PULSE_SAMPLES - pulse_position) * amplitude1 / PULSE_SAMPLES);
				pbuf[i + 1] = __int16((PULSE_SAMPLES - pulse_position) * amplitude2 / PULSE_SAMPLES);
			}
			else
			{
				pbuf[i]     = 0;
				pbuf[i + 1] = 0;
			}

			// Unsuccessful attempt to limit the raising in the 30 KHz to 100 KHz area
			//if (freqMax > 20000)
			//{
			//	if (pulse_position == 1)
			//	{
			//		pbuf[i] = __int16(pulse * 0.6);
			//	}
			//	else if (pulse_position == 3)
			//	{
			//		pbuf[i] = __int16(pulse * 0.8);
			//	}
			//	else if (pulse_position == 5)
			//	{
			//		pbuf[i] = __int16(pulse * 0.9);
			//	}
			//}

			pulse_position++;
		}	
    }

    // ===================================================== FAST SWEEP
    else if (analysisType == ANTYPE_FASTSW)
    {	
		// --------------------------------------------------- set the max sweep frequency (up to 100 KHz)
		double k = freqMax; 
		// --------------------------------------------------- max sweep frequency not less than 10000 Hz
		if (k < 10000) k = 10000;
		// --------------------------------------------------- calc the coefficient
		k = k * 0.11 * PI / 2.0; 

		for	(i = 0; i < OUT_BUF_LEN; i += 2)
		{
			if (pulse_position >= PULSE_TOTAL_SAMPLES) 
			{
				pulse_position = 0;
				pulseFlag = true;
			}
			//
			if (pulse_position < FASTSWEEP_SAMPLES)
			{
				//double ii = 1 - (pulse_position * 1.0 / FASTSWEEP_SAMPLES);
				double ii = (pulse_position * 1.0 / FASTSWEEP_SAMPLES);
				ii = pow(ii, 15); 
				pbuf[i]     = __int16(sin(ii * k) * amplitude1);
				pbuf[i + 1] = __int16(sin(ii * k) * amplitude2);
			}
			else
			{
				pbuf[i] = 0;
			}
			//
			pulse_position++;
		}	
    }
    else if (analysisType == ANTYPE_SWEEP)
    {	
        if (xlogtype)
        {
			// ===================================================== SWEEP LOG
            int nsamples = int(sweepTime * SAMPLES_PER_SEC);

            double k = log(freqMax / freqMin) / nsamples;

            for	(i = 0; i < OUT_BUF_LEN; i += 2)
	        {
                pbuf[i]     = __int16(wtab[int(phase)] * amplitude1);
				pbuf[i + 1] = __int16(wtab[int(phase)] * amplitude2);

                sweepFreq = freqMin * exp(k * sweepSample);
                         
                phase += sweepFreq;
                sweepSample++;
                
                if (phase >= WTAB_LEN)
                {
                    phase -= WTAB_LEN;
                    
                    // Here starts a new cycle
                    if (sweepFreq > freqMax)
                    {
                        sweepStatus = 1;
                        break;
                    }
                }
	        }
        }
        else
        {   
			// ===================================================== SWEEP LIN
            int nsamples = int(sweepTime * SAMPLES_PER_SEC);
     
            double df = (freqMax - freqMin) / nsamples;

            for	(i = 0; i < OUT_BUF_LEN; i += 2)
	        {
                pbuf[i]     = __int16(wtab[int(phase)] * amplitude1);
				pbuf[i + 1] = __int16(wtab[int(phase)] * amplitude2);
                phase += sweepFreq;
                sweepFreq += df;
    
                if (phase >= WTAB_LEN)
                {
                    phase -= WTAB_LEN;
                    // Here starts a new cycle
                    if (sweepFreq >= freqMax)
                    {
                        sweepStatus = 1;
                        break;
                    }
                }
	        }
        }

        for	(i = i; i < OUT_BUF_LEN; i++)
	    {
            pbuf[i] = 0;    
        }

    }

    // ===================================================== NOISE
    else if (wavetype == WAVETYPE_NOISE)
    {
        double noiseAmplitude1 = exp((outlevel + deltalevel1) / kdb);
		double noiseAmplitude2 = exp((outlevel + deltalevel2) / kdb);
        if (random == 0) random = 1;
        for	(i = 0; i < OUT_BUF_LEN; i += 2)
	    {  
			// --------------------------------------------------------- ( original 1999 random )
            if (random & 0x800000) random = (random << 1) ^ 0x1D872B41;
			else random = (random << 1);
			// --------------------------------------------------------------- alternative method
			//random = 1664525L * random + 1013904223L;
			// ----------------------------------------------------------------------------------

			// ----------------- ensure that random2 float value is not too great ( sound stops )
			if (fabs(random2) > 1e9) random2 = 0;
			else random2 += (random * .0002);
			// ----------------------------------------------------------------------------------
            
			// -------------------------------------------------------------------- set the value
            pbuf[i]     = __int16(__int16(random2) * noiseAmplitude1);
			pbuf[i + 1] = __int16(__int16(random2) * noiseAmplitude2);
			// ---------------------------------------------------------------------------------
        }
    }
    else
    {
        double f = oldfreq;
        double df = (freq - oldfreq) / OUT_BUF_LEN / 2.0;
        oldfreq = freq;

        switch (analysisType)
        {
			// ===================================================== SINE WAVE
            case ANTYPE_WAVE:	
            case ANTYPE_SPECTR: 
                for	(i = 0; i < OUT_BUF_LEN; i += 2)
	            {
                    pbuf[i]     = __int16(wtab[int(phase)] * amplitude1);
					pbuf[i + 1] = __int16(wtab[int(phase)] * amplitude2);
                    phase += f;
                    f += df;
                    if (phase >= WTAB_LEN)
                    {
                        phase -= WTAB_LEN;
                        // Here starts a new cycle and you could make updates
                    }
	            }
			break;

			// ===================================================== SINE WAVE BURST
            case ANTYPE_BURST: 
                for	(i = 0; i < OUT_BUF_LEN; i += 2)
	            {
					if (burstflag)
					{ 
						pbuf[i]     = __int16(wtab[int(phase)] * amplitude1);
						pbuf[i + 1] = __int16(wtab[int(phase)] * amplitude2);
					}
					else 
					{
						pbuf[i] = 0;
						pbuf[i + 1] = 0;
					}
                    phase += f;
                    f += df;
                    if (phase >= WTAB_LEN)
                    {
                        phase -= WTAB_LEN;
                        if (burstflag)
                        {
                            if (burstcounter >= int(burstCycles))
                            {
                                burstcounter = 0;
                                burstflag = FALSE;
                            }
                        }
                        else
                        {
                            if (burstcounter >= int(pauseCycles))
                            {
                                burstcounter = 0;
                                burstflag = TRUE;
                                phase = 0;
                            }
                        }
                        burstcounter++;
                    }
                }
			break;
        }
    }

    // ----------------------------------------------------------- Send the buffer
	int result = waveOutWrite(hwOut, pwh, sizeof(WAVEHDR));
    
    if (result == MMSYSERR_NOERROR) activeOutBuffers++;
}


// ================================================================================================
// ================================================================================================
//  FILL WAVE TABLE 
// ================================================================================================
// ================================================================================================
void DAA_FillWaveTable(int type)
{
    int i;
	double k_pi;
    switch (type)
    {
		// ---------------------------------------------------------- SINE WAVE
		case WAVETYPE_SINE:
			k_pi = (PI * 2) / WTAB_LEN;
			for	(i = 0; i < WTAB_LEN; i++)
			{
				wtab[i] = float(sin(i * k_pi));
			}
		break;
		// ---------------------------------------------------------- TRIANGULAR WAVE
		case WAVETYPE_TRIANG:
			for	(i = 0; i < WTAB_LEN / 4; i++)
			{
				wtab[i] = float(i * 4.0 / WTAB_LEN);
			}
			for	(i = WTAB_LEN / 4; i < WTAB_LEN * 3 / 4; i++)
			{
				wtab[i] = float(2 - i * 4.0 / WTAB_LEN );
			}
			for	(i = WTAB_LEN * 3 / 4; i < WTAB_LEN; i++)
			{
				wtab[i] = float(i * 4.0 / WTAB_LEN - 4);
			}
		break;
		// ---------------------------------------------------------- RAMP POSITIVE
		case WAVETYPE_RAMPp: 
			for	(i = 0; i < WTAB_LEN; i++)
			{
				wtab[i] = float(i * 2.0 / WTAB_LEN - 1);
			}
		break;
		// ---------------------------------------------------------- RAMP NEGATIVE
		case WAVETYPE_RAMPm: 
			for	(i = 0; i < WTAB_LEN; i++)
			{
				wtab[i] = float(1 - i * 2.0 / WTAB_LEN);
			}
		break;
		// ---------------------------------------------------------- SQUARE WAVE
		case WAVETYPE_SQUARE:
			int mid = int(WTAB_LEN * duty / 100);
			for	(i = 0; i < mid; i++)
			{
				wtab[i] = 1;
			}
			for	(i = mid; i < WTAB_LEN; i++)
			{
				wtab[i] = -1;
			}
		break; 
    }
}


// ================================================================================================
// ================================================================================================
//  ADD BUFFER
// ================================================================================================
// ================================================================================================
void DAA_AddBuffer()
{
    BufInIndex++;
    if (BufInIndex >= N_BUFIN) BufInIndex = 0;
    
	int result = waveInAddBuffer(hwIn, &pwhIn[BufInIndex], sizeof(WAVEHDR));
    
    if (result == MMSYSERR_NOERROR) activeInBuffers++;
}


// ================================================================================================
// ================================================================================================
//  CALLBACK - WAVE OUT
// ================================================================================================
// ================================================================================================
void CALLBACK waveOutProc(HWAVEOUT hwOut,
                          UINT uMsg,
                          DWORD dwInstance, 
                          DWORD dwParam1,
                          DWORD dwParam2)
{   
	hwOut; dwInstance; dwParam1; dwParam2;
	//
	switch(uMsg)
    {
	    case WOM_OPEN:
			break;                
	    case WOM_CLOSE:
			break;
	    case WOM_DONE:
            
			activeOutBuffers--;
			
            //if ((analysisType == ANTYPE_FASTSW) || (analysisType == ANTYPE_PULSE)) return;
            if (analysisType == ANTYPE_SWEEP)
            {
                if (sweepStatus == 0)     // 0 = sweeping
                {
                    if (outputState) DAA_FillBuffer();    
                }
            }
            else
            {
                if (outputState) DAA_FillBuffer();
            }
			

			break;
	}  
}	
  

// ================================================================================================
// ================================================================================================
//  CALLBACK - WAVE IN
// ================================================================================================
// ================================================================================================
void CALLBACK waveInProc(HWAVEIN hwIn,
                         UINT uMsg,
                         DWORD dwInstance, 
                         DWORD dwParam1,
                         DWORD dwParam2)
{
	hwIn; dwInstance; dwParam1; dwParam2;
	double v, v1, v2;
	//
	switch(uMsg)
    {
	    case WIM_OPEN:
			break;                
	    case WIM_CLOSE:
			break;
	    case WIM_DATA:

			activeInBuffers--;	

			// --------------------------------------------------------------------- filters inizialization
			if (Filter_CH1 != 0) 
				filterCH1.SetFrequency(FiltersEsponential.Calc(filterFrequency1));
			if (Filter_CH2 != 0) 
				filterCH2.SetFrequency(FiltersEsponential.Calc(filterFrequency2));

            if (inputState)
            {
                if (analysisType == ANTYPE_SWEEP && activeOutBuffers <= 0 && sweepStatus) return;

				// ----------------------------------------------------------------- get pointer to data
                __int16* pbuf = (__int16*)(LPWAVEHDR(dwParam1)->lpData);

                // -----------------------------------------------------------------
				//  CALIBRATION
				// -----------------------------------------------------------------
				if (Calibrating)
				{
					for (int i = 0; i < IN_BUF_LEN; i += 2)
                    {
						// -------------------------------------- read v1 and v2
						v1 = pbuf[i];
						v2 = pbuf[i + 1];
						// -------------------------------------- update vmaxpeak1, vminpeak1, vmaxeak2, vminpeak2 
						if (v1 > calib_vmax1) calib_vmax1 = v1;
                        if (v1 < calib_vmin1) calib_vmin1 = v1;
						if (v2 > calib_vmax2) calib_vmax2 = v2;
                        if (v2 < calib_vmin2) calib_vmin2 = v2;
					}
				}

                else if (analysisType == ANTYPE_SWEEP && outputState && !DisplaySamples)


                // -----------------------------------------------------------------
				//  SWEEP
				// -----------------------------------------------------------------
                {
                    int sweepX;
                    int samplesPerPixel_8 = int(sweepTime * SAMPLES_PER_SEC / dispx) << 8;

					// trigCH CHANNEL 1-2 SELECT
                    for (int i = 0; i < IN_BUF_LEN; i += 2)
                    {
						if (trigCH == 0) v = (pbuf[i] + calY1) * polarity1 * gain1 * Root2f2;
						else    v = (pbuf[i + 1] + calY2) * polarity2 * gain2 * Root2f2;

                        if (v > vmax_sweep) vmax_sweep = v;
                        if (v < vmin_sweep) vmin_sweep = v;

                        if (sweepPos++ >= sweepLimit)
                        {          
                            sweepX = (__int64(sweepPos) << 8) / samplesPerPixel_8 - 1;
                            if (sweepX >= 0)
                            {
								vmax_sweep = (vmax_sweep - vmin_sweep) / 2;

                                if (calibratedResponse) vmax_sweep = vmax_sweep * calibrateTab[sweepX];
                                responseTab[sweepX] = float(vmax_sweep);

                                vmax_sweep = -DOUBLEMAX;
                                vmin_sweep = DOUBLEMAX;
                            }
                            sweepLimit += (samplesPerPixel_8 >> 8);
                        }
                    }

                }

                else

				// ----------------------------------------------------------------- 
				//  NORMAL INPUT for CH1 and CH2
				// -----------------------------------------------------------------
                {
					// -------------------------------------------------------- decrease vmax and vmin 
					vmax1 += (vmid1 - vmax1) / 500;
					vmin1 += (vmid1 - vmin1) / 500;
					vmax2 += (vmid2 - vmax2) / 500;
					vmin2 += (vmid2 - vmin2) / 500;

                    int cbpos = cbufPos;
                    for (int i = 0; i < IN_BUF_LEN; i += 2)
                    {
						// ---------------------------------------------------- read v1 and v2
						v1 = (pbuf[i] + calY1) * polarity1 * gain1;
						v2 = (pbuf[i + 1] + calY2) * polarity2 * gain2;
						// ---------------------------------------------------- filters
						if (Filter_CH1 != 0) v1 = filterCH1.Exec(v1);
						if (Filter_CH2 != 0) v2 = filterCH2.Exec(v2);
						// ---------------------------------------------------- ADD and SUB modes
						if (selectCH == 3 || selectCH == 4)
						{
							double kmul = (scaleY1 / regY1) / (scaleY2 / regY2) * mul1 / mul2;
							if (selectCH == 3) v1 = v1 + v2 * kmul;
							if (selectCH == 4) v1 = v1 - v2 * kmul;
						}
						// ---------------------------------------------------- update circular buffer
						if (ac1) pCbufIn[cbpos++] = float(v1 - vmid1);
						else	 pCbufIn[cbpos++] = float(v1);
						if (ac2) pCbufIn[cbpos++] = float(v2 - vmid2);
						else	 pCbufIn[cbpos++] = float(v2);
						// ---------------------------------------------------- update vmax1, vmin1, vmax2, vmin2 
						if (v1 > vmax1) vmax1 = v1;
                        if (v1 < vmin1) vmin1 = v1;
						if (v2 > vmax2) vmax2 = v2;
                        if (v2 < vmin2) vmin2 = v2;
						// ---------------------------------------------------- update vmid-inst values
						vmidinst1 += (v1 - vmidinst1) * 0.000005;
						vmidinst2 += (v2 - vmidinst2) * 0.000005;
						// ---------------------------------------------------- update RMS-SUM values
						rmsSum1 += pow(v1 - vmid1, 2);
						rmsSum2 += pow(v2 - vmid2, 2);
						rmsSamplesCounter++;  
						// -------------------------------------------------------------------------------- 
						//  FREQUENCY METER on CH1 or CH2
						// --------------------------------------------------------------------------------
						if (curstype == 1 || curstype == 2)
						{
							// ------------------------------------------------ select the Frequency meter channel
							if (curstype == 1) v = v2;
							else v = v1;
							// ------------------------------------------------
							if (fmeterFlag)
							{
								if (v < fmeterTrigDown)
								{
									fmeterFlag = FALSE;
									fmeterCycles ++; 
									if (fmeterSamples > SAMPLES_PER_SEC)
									{
										fmeterResultSamples = fmeterSamples + (i / numCH);
										fmeterResultCycles = fmeterCycles;
										fmeterSamples = -(i / numCH);
										fmeterCycles = 0;
									}
	                                 
								}
							}
							else
							{
								if (v > fmeterTrigUp) fmeterFlag = TRUE;
							}
						}
							
						// -------------------------------------------------------- test the STOP LEVEL
						if (trigType == 5 && analysisType < 2)
						{
							if (trigCH) 
							{
								v = v2;
								if (ac2) v -= vmid2;
							}
							else 
							{
								v = v1;
								if (ac1) v -= vmid1;
							}
							if (sgn(v - StopLevelRawValue) != sgn(StopLevelRawValueOld - StopLevelRawValue))
							{
								if (!StopLevelCrossed)
								{
									StopLevelCrossed = true;
									StopLevelCircularBufferPos = cbpos;
								}
							}
							StopLevelRawValueOld = v;
						}

                    }

					// ------------------------------------------------------------ update vmid1 and vmid2
					vmid1 += (vmidinst1 - vmid1) * 0.005;
					vmid2 += (vmidinst2 - vmid2) * 0.005;
					// ------------------------------------------------------------ update vrms1 and vrms2
					if (rmsSamplesCounter > 192 * 512)
					{
						vrms1 = sqrt(rmsSum1 / rmsSamplesCounter);
						vrms2 = sqrt(rmsSum2 / rmsSamplesCounter);
						rmsSum1 = 0;
						rmsSum2 = 0;
						rmsSamplesCounter = 0;
					}
					// ------------------------------------------------------------ update fmeterSamples
					fmeterSamples += (IN_BUF_LEN / numCH);
					// ------------------------------------------------------------ update cbufPos
					cbufPos += IN_BUF_LEN;

					// TEST THIS  (cbufPos = 0) ??? --- changed 07/07/2019
					//if (cbufPos >= IN_CBUF_LEN) cbufPos = 0;
					if (cbufPos >= IN_CBUF_LEN) cbufPos -= IN_CBUF_LEN;
                }

				// -------------------------------------------------- send a new empty buffer to the audio card
				DAA_AddBuffer();
            }

		break;
	}  
}


void InitVmaxVminVmidAndCircularBuffer()
{
	double fill1 = 0;
	double fill2 = 0;

	if (!ac1) 
	{
		vmax1 = DOUBLEMIN;
		vmin1 = DOUBLEMAX;
	}
		
	if (!ac2) 
	{
		vmax2 = DOUBLEMIN;
		vmin2 = DOUBLEMAX;
	}

	Sleep(100);

	if (!ac1)
	{
		vmid1 = (vmin1 + vmax1) / 2;
		vmidinst1 = vmid1;
		fill1 = vmid1;
	}

	if (!ac2) 
	{
		vmid2 = (vmin2 + vmax2) / 2;
		vmidinst2 = vmid2;
		fill2 = vmid2;
	}
	
	for (int i = 0; i < IN_CBUF_LEN - 1; i += 2)
	{
		pCbufIn[i] = float(fill1);
		pCbufIn[i + 1] = float(fill2);
	}
}

// ================================================================================================
// ================================================================================================
//  CLASS DISPLAY - DRAW
// ================================================================================================
// ================================================================================================
void CDisplay::Draw(CDC* pDC)
{
    if (!dcCreated)
    {
		// ------------------------------------------------------- delete bitmaps and dc objects
		bmpGrid.DeleteObject();
		dcGrid.DeleteDC();
		bmpScreen.DeleteObject();
		dcScreen.DeleteDC();
		// ------------------------------------------------------- create bitmaps and dc
        bmpGrid.CreateCompatibleBitmap(pDC, ddx, ddy);
        dcGrid.CreateCompatibleDC(pDC);
        dcGrid.SelectObject(bmpGrid);
        bmpScreen.CreateCompatibleBitmap(pDC, ddx, ddy);
        dcScreen.CreateCompatibleDC(pDC);
        dcScreen.SelectObject(bmpScreen);
        dcCreated = TRUE;
    }

    if (dcCreated) CreateGrid();

    CPen pen(PS_SOLID, 2, grey5);
    CBrush brush(grey3);
    CPen pen2(PS_SOLID, 2, grey8);
    CBrush brush2(grey6);
    CPen pen3(PS_SOLID, 2, grey6);
    CBrush brush3(grey6);
    CPen pen4(PS_SOLID, 2, black);
    CBrush brush4(grey3);
    CPen pen5(PS_SOLID, 2, black);
    CBrush brush5(grey5);

    CPen* pOldPen = pDC->SelectObject(&pen);
    CBrush* pOldBrush = pDC->SelectObject(&brush); 
    // Shadow
    pDC->RoundRect(x, y, dx + ddx + b + bIn + 6, dy + ddy + b + bIn + 6, 18, 18);
    // External panel
    pDC->SelectObject(pen2);
    pDC->SelectObject(brush2);
    pDC->RoundRect(x, y, dx + ddx + b + bIn, dy + ddy + b + bIn, 12, 12);
    pDC->SelectObject(pen3);
    pDC->SelectObject(brush3);
    pDC->RoundRect(x + 2, y + 2, dx + ddx + b + bIn, dy + ddy + b + bIn, 12, 12);
    // Internal mask
    pDC->SelectObject(pen4);
    pDC->SelectObject(brush4);
    pDC->RoundRect(x + b, y + bUp, dx + ddx + bIn , dy + ddy + bIn, 12, 12);
    // Screen
    pDC->SelectObject(pen5);
    pDC->SelectObject(brush5);
    pDC->RoundRect(dx - 1, dy - 1, dx + ddx + 1, dy + ddy + 1, 1, 1);

    pDC->SelectObject(pOldPen);
    pDC->SelectObject(pOldBrush);
   
    title.Draw(pDC);
}    

// ================================================================================================
// ================================================================================================
//  CLASS DISPLAY : CREATE GRID
// ================================================================================================
// ================================================================================================
void CDisplay::CreateGrid()
{
    referenceFlag = FALSE;

    CDC* pDC = &dcGrid;
    int i, px;

    CPen* pOldPen = pDC->SelectObject(&pens[0]);  
      
    if (analysisType == ANTYPE_SPECTR && spectrum3D && !DisplaySamples)
    {
        pDC->FillSolidRect(0, 0, ddx, ddy, RGB(0,0,0));
    }
    else
    {
        pDC->FillSolidRect(0, 0, ddx, ddy, dback);
    }

    dgrid= RGB(gridLight, 50 + gridLight / 3, 80);
    CPen pengrid;

    if (analysisType >= ANTYPE_SPECTR && !DisplaySamples)
    { 
		CFont font;
        font.CreateFont(spectrumGridFontSize, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, "Tahoma");

        CFont* pOldFont = pDC->SelectObject(&font);
        pDC->SetBkMode (TRANSPARENT);

        int r = int(osdIntensity + 25);
        int g = int(osdIntensity + 55);
        int b = int(osdIntensity + 45);
        COLORREF osdColor = RGB(r, g, b);
        pDC->SetTextColor(osdColor);

        if (analysisType == ANTYPE_SPECTR && spectrum3D)
        {
            pengrid.CreatePen(PS_SOLID, 1, osdColor);
            pDC->SelectObject(pengrid);
        }
        else
        {
            pengrid.CreatePen(PS_SOLID, 1, dgrid);
            pDC->SelectObject(pengrid);
            pDC->MoveTo(leftborder, dispy);
            pDC->LineTo(ddx, dispy);
            pDC->MoveTo(leftborder, 0);
            pDC->LineTo(leftborder, dispy);
        }
        

        CString s;
        double min, max;
       
        // ---------------------------------------------------------- SPECTRUM GRID - X AXIS
        double klog = (dispx - 1) / log(freqMax / freqMin);

		int xclearance = int(spectrumGridFontSize * 1.75);
		int textdx = int(spectrumGridFontSize * 0.95);

		int texty = ddy - int(downborder * .85);

        if (xlogtype && freqMax / freqMin >= 10)
        {
			// ---------------------------------------------------------- X AXIS LOGARITMIC
            double decmin = 100000;
            double decmax = .01;
            while (decmin > freqMin) decmin /= 10; 
            while (decmax < freqMax) decmax *= 10;
            for (double f = decmin; f <= decmax; f *= 10)
            {
                for (i = 1; i < 10; i++)
                {
                    double x = klog * log(f * i / freqMin);

                    if (x >= 0 && x <= dispx)
                    {
                        px = int(leftborder + x +.5);
                        pDC->MoveTo(px, 0);

						int px2 = px - textdx;
					    if (analysisType == ANTYPE_SPECTR && spectrum3D)
						{
							if (px2 > ddx - textdx - xclearance) px2 = ddx - textdx - xclearance;
                            if (px2 < leftborder) px2 = leftborder;
						}
						else
                        {
							if (px2 > ddx - xclearance - textdx) px2 = ddx - xclearance - textdx;
                            if (px2 < leftborder - textdx) px2 = leftborder - textdx;
                        }

                        if (i == 1)
                        {
                            pDC->LineTo(px, ddy - downborder + 4);
                            if (f == .1) pDC->TextOut(px2, texty, " .1 Hz");
                            else if (f == 1) pDC->TextOut(px2, texty, " 1 Hz");
                            else if (f == 10) pDC->TextOut(px2, texty, " 10 Hz");
                            else if (f == 100) pDC->TextOut(px2, texty, "100 Hz");
                            else if (f == 1000) pDC->TextOut(px2, texty, "1 KHz");
                            else if (f == 10000) pDC->TextOut(px2, texty, "10 KHz");
                        }
                        else if (i == 2)
                        {
                            pDC->LineTo(px, ddy - downborder + 4);

							if (klog > spectrumGridFontSize * 6)
                            {
                                if (f == .1) pDC->TextOut(px2, texty, " .2 Hz");
                                else if (f == 1) pDC->TextOut(px2, texty, " 2 Hz");
                                else if (f == 10) pDC->TextOut(px2, texty, " 20 Hz");
                                else if (f == 100) pDC->TextOut(px2, texty, "200 Hz");
                                else if (f == 1000) pDC->TextOut(px2, texty, "2 KHz");
                                else if (f == 10000) pDC->TextOut(px2, texty, "20 KHz");
                            }
                        }
                        else if (i == 5)
                        {
                            pDC->LineTo(px, ddy - downborder + 4);

							if (klog > spectrumGridFontSize * 5)
                            {
                                if (f == .1) pDC->TextOut(px2, texty, " .5 Hz");
                                else if (f == 1) pDC->TextOut(px2, texty, " 5 Hz");
                                else if (f == 10) pDC->TextOut(px2, texty, " 50 Hz");
                                else if (f == 100) pDC->TextOut(px2, texty, "500 Hz");
                                else if (f == 1000) pDC->TextOut(px2, texty, "5 KHz");
								else if (f == 10000) pDC->TextOut(px2, texty, "50 KHz");
                            }
                        }
                        else
                        {
                            if (analysisType == ANTYPE_SPECTR && spectrum3D)
                            {
                                pDC->LineTo(px, ddy - downborder + 2);
                            }
                            else pDC->LineTo(px, ddy - downborder);
                        }
                    }
                }
            }
        }
        else
        {
			// ---------------------------------------------------------- X AXIS LINEAR
            double deltaf = freqMax - freqMin;
            double step = .1;

            if (deltaf > 0)
            {                
                int nstep = dispx / spectrumGridFontSize / 3;

                while (deltaf / step > nstep)
                {
                    step *= 2;
                    if (deltaf / step > nstep) step *= 2.5;
                    if (deltaf / step > nstep) step *= 2;
                }

                max = ceil(freqMax / step + .5) * step;
                min = floor(freqMin / step + .5) * step;
                for (double f = min; f <= max; f += step)
                {
                    if (f >= freqMin && f <= freqMax)
                    {    
                        if (xlogtype) px = leftborder + int(klog * log(f / freqMin));
                        else px = leftborder + int((dispx - 1) * (f - freqMin) / deltaf);

                        pDC->MoveTo(px, 0);
                        pDC->LineTo(px, ddy - downborder + 4);
                       
                        if (px < ddx - xclearance / 2)
                        {
                            if (analysisType == ANTYPE_SPECTR && spectrum3D)
                            {
                                if(px < leftborder + xclearance / 2) px = leftborder + xclearance / 2;
                            }
							else
							{
								if (px > ddx - xclearance) px = ddx - xclearance;
							}

                            if (int(f) == f) s.Format("%1.0f", f);
                            else s.Format("%1.1f", f);
                            pDC->TextOut(px - xclearance / 2, texty, s);
                        }
                    }                  
                }
            }

            int nstep = dispx / spectrumGridFontSize / 6;
            if (deltaf / step < nstep)
            {
                s.Format("%1.1f", freqMax);
                if (freqMax >= 10000) pDC->TextOut(ddx - int(xclearance * 1.7), texty, s);
                else if (freqMax >= 1000) pDC->TextOut(ddx - int(xclearance * 1.5), texty, s);
                else pDC->TextOut(ddx - xclearance, texty, s);
            }        
        }


		// ------------------------------------------------------ SPECTRUM GRID - Y AXIS 
        if (!(analysisType == ANTYPE_SPECTR && spectrum3D))
        {  
            if (ylogtype && !(analysisType == ANTYPE_SPECTR && spectrum3D))
            {
				// ---------------------------------------------- Y AXIS LOGARITMIC
                double deltadb = dbmax - dbmin;
                double step = .1;
                int nstep = dispy / spectrumGridFontSize;
                while (deltadb / step > nstep)
                {
                    step *= 2;
                    if (deltadb / step > nstep) step *= 2.5;
                    if (deltadb / step > nstep) step *= 2;
                }

                max = ceil(dbmax / step + .5) * step;
                min = floor(dbmin / step + .5) * step;
                for (double db = min; db <= max; db += step)
                {
                    if (db >= dbmin && db <= dbmax)
                    {
                        int y = int(dispy - (dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
                        pDC->MoveTo(leftborder - 8, y);
                        pDC->LineTo(ddx, y);
                        if (y > spectrumGridFontSize * 1.85)
                        {
                            if (y > dispy - 2) y = dispy - 2;
                            if (int(db) == db) s.Format("%1.0f", db);
                            else s.Format("%1.1f", db);
                            pDC->TextOut(int(spectrumGridFontSize * 0.28), y - int(spectrumGridFontSize * 0.46), s);
                        }
                    }
                }
                pDC->TextOut(5, 0, "dB");
            }
            else
            {
				// ---------------------------------------------- Y AXIS LINEAR
                double mvmin = 2 * exp(dbmin / kdb) * 1000;
                double mvmax = 2 * exp(dbmax / kdb) * 1000;

                double deltamv = mvmax - mvmin;
                double step = .001;
                int nstep = dispy / spectrumGridFontSize;
                while (deltamv / step > nstep)
                {
                    step *= 2;
                    if (deltamv / step > nstep) step *= 2.5;
                    if (deltamv / step > nstep) step *= 2;
                }

                max = ceil(mvmax / step + .5) * step;
                min = floor(mvmin / step + .5) * step;
                for (double mv = min; mv <= max; mv += step)
                {
                    if (mv >= mvmin && mv <= mvmax)
                    {
                        int y = int(dispy - (dispy * (mv - mvmin) / (mvmax - mvmin)) + .5);
                        pDC->MoveTo(leftborder - 8, y);
                        pDC->LineTo(ddx, y);
                        if (y >= int(dispdy * 0.06))
                        {
                            if (y > int(dispdy * 0.98)) y = int(dispdy * 0.98);
							if (mvmax >= 100)
							{
								if (mv < 10000) s.Format("%0.2f", mv / 1000);
								else if (mv < 1000) s.Format("%0.1f", mv / 1000);
								else if (mv < 100000) s.Format("%0.1f", mv / 1000);
								else s.Format("%0.0f", mv / 1000);
							}
							else
							{
								if (int(mv) == mv) s.Format("%0.0f", mv);
								else if (fabs(int(mv * 10 + .5) - mv * 10) < .0001) s.Format("%0.1f", mv);
								else if (fabs(int(mv * 100 + .5) - mv * 100) < .0001) s.Format("%0.2f", mv);
								else s.Format("%0.3f", mv);
							}
							pDC->TextOut(int(spectrumGridFontSize * 0.28), y - int(spectrumGridFontSize * 0.46), s);
                        }
                    }
                }
				if (mvmax >= 100) pDC->TextOut(int(spectrumGridFontSize * 0.28), 0, "Veff");
                else pDC->TextOut(int(spectrumGridFontSize * 0.14), 0, "mVeff");
            }
        }
    
		
		// ---------------------------------------------------------- SPECTRUM 3D
        if (analysisType == ANTYPE_SPECTR && spectrum3D)
        {
			CFont font;
			font.CreateFont(13, 0, 0, 0, 100, 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, "Tahoma");
			pDC->SelectObject(&font);

            dcScreen.BitBlt(0, dispy, ddx, ddy, &dcGrid, leftborder, dispy, SRCCOPY);
            
            pDC->FillSolidRect(0, 0, 68, 120, RGB(0,0,0));

            for (int i = 0; i < 32; i++)
            {
                pDC->SelectObject(&pens[i]);
                pDC->MoveTo(10, 114 - i * 3);
                pDC->LineTo(30, 114 - i * 3);
                pDC->MoveTo(10, 113 - i * 3);
                pDC->LineTo(30, 113 - i * 3);
                pDC->MoveTo(10, 112 - i * 3);
                pDC->LineTo(30, 112 - i * 3);
            }

            if (ylogtype)
            {
                pDC->TextOut(14, 4, "dB");
                double k = (dbmax - dbmin) / 32; 
                double db;
                for (int i = 0; i <= 32; i+= 4)
                {
                     db = dbmin + k * i;
                     if (db > -100) s.Format("%1.1f", db);
					 else s.Format("%1.0f", db);
                     pDC->TextOut(38, 106 - i * 3, s);
                }
            }
            else
            {
                double mvmin = 2 * exp(dbmin / kdb) * 1000;
                double mvmax = 2 * exp(dbmax / kdb) * 1000;
                if (mvmax >= 100) pDC->TextOut(12, 4, "Veff");
				else  pDC->TextOut(4, 4, "mVeff");
                double k = (mvmax - mvmin) / 32; 
                double mv;
                for (int i = 0; i <= 32; i+= 4)
                {
					mv = mvmin + k * i;
					if (mvmax >= 100)
					{
						if (mv < 10000) s.Format("%0.2f", mv / 1000);
						else if (mv < 1000) s.Format("%0.1f", mv / 1000);
						else if (mv < 100000) s.Format("%0.1f", mv / 1000);
						else s.Format("%0.0f", mv / 1000);
					}
					else
					{
						if (mv >= 1000) s.Format("%1.0f", mv);
						else if (mv >= 10) s.Format("%1.1f", mv);
						else s.Format("%1.3f", mv);
					}
					pDC->TextOut(38, 106 - i * 3, s);
                }
            }
        }
		
		pDC->SelectObject(pOldFont);
    }
    else
    {
		// ddx-1 and ddy-1 to ensure the firs and last row always visible 
		// with all the possible display height  
		float step;
		float px, py;
		// ---------------------------------------------------------- GRID (10 x 8) for WAVE DISPLAY
        pengrid.CreatePen(PS_SOLID, 1, dgrid);
        pDC->SelectObject(pengrid);
		// ---------------------------------------------------------- GRID X
		px = 0;
        step = float((ddx - 1) / 10.0);
        for (i = 1; i < 12; i++)
        {
            pDC->MoveTo(int(px), 0);
            pDC->LineTo(int(px), ddy);
			px += step;
        }
        py = float(ddy / 2.0);
        px = 0;  
        step = float((ddx - 1) / 50.0);
        for (i = 1; i < 50; i++)
        {
            px += step;
            pDC->MoveTo(int(px), int(py - 5));
            pDC->LineTo(int(px), int(py + 5));
        }
		// ---------------------------------------------------------- GRID Y
		py = 0;
        step = float((ddy-1) / 8.0);
        for (i = 1; i < 10; i++)
        {
            pDC->MoveTo(0, int(py));
            pDC->LineTo(ddx, int(py));
			py += step;
        }
        px = float(ddx / 2.0);
        py = 0;
        step = float((ddy-1) / 40.0);
        for (i = 1; i < 40; i++)
        {
            py += step;
            pDC->MoveTo(int(px - 5), int(py));
            pDC->LineTo(int(px + 5), int(py));
        }
    }
      
    pDC->SelectObject(pOldPen);
}


// ================================================================================================
// ================================================================================================
//  CLASS DISPLAY : CLEAR
// ================================================================================================
// ================================================================================================
void CDisplay::Clear()
{
    dcScreen.FillSolidRect(0, 0, ddx, ddy, RGB(0,0,0));
}


// ================================================================================================
// ================================================================================================
//  CLASS DISPLAY : DISPLAY ALL
// ================================================================================================
// ================================================================================================
void CDisplay::DisplayAll(CDC* pDC)
{
    if (analysisType == ANTYPE_SPECTR && spectrum3D && !DisplaySamples)
    {
		// --------------------------------------------------------------------- SPECTRUM 3D
        if (inputState)
        {    
            CRect rect(0, 0, ddx, dispy);
            dcScreen.ScrollDC(1, -1, &rect, &rect, NULL, NULL );
            PlotSpectrum3D(&dcScreen);
        }
        dcScreen.BitBlt(12, 8, 68, 120, &dcGrid, 0, 0, SRCCOPY);    
        pDC->BitBlt(dx, dy, ddx, ddy, &dcScreen, 0, 0, SRCCOPY);
    }
    else
    {
		// --------------------------------------------------------------------- NORMAL DISPLAY
        //if (LButtonPressed() && analysisType == ANTYPE_SWEEP) return;
        //InitTime(); 

        // 7 mS (320 * 240 * 16 bit) 2.9 mS (320 * 240 * 8 bit)
        if (!multiDraw || analysisType != ANTYPE_SWEEP)
		{
			if (dcScreen != NULL) dcScreen.BitBlt(0, 0, ddx, ddy, &dcGrid, 0, 0, SRCCOPY);   
		}
        PlotWave(&dcScreen);
		DisplayReadout(&dcScreen);

        // CURSOR
        /*
        if (pDC->GetWindow())
        {
            CPoint point;
            GetCursorPos(&point);
            pDC->GetWindow()->ScreenToClient(&point);
            point.x -= dx;
            point.y -= dy;
            HICON cursor = theApp.LoadStandardCursor(IDC_ARROW);
            //HCURSOR cursor = LoadCursor(NULL, IDC_ARROW);
            dcScreen.DrawIcon( point, cursor );
        }
        */

        pDC->BitBlt(dx, dy, ddx, ddy, &dcScreen, 0, 0, SRCCOPY);
        //Print(pDC,220,50,GetTime());
    }

	// -------------------------------------- change the speed to the knob "Delay" to follow the "TimeBase"
	dialer9.SetMultiplier(scaleX / 100);

	ledtrig.Update(pDC, triggered);
	indicator.Update(pDC);
}



// ================================================================================================
// ================================================================================================
//   CLASS DISPLAY : PLOT SPECTRUM  3D                                         *
// ================================================================================================
// ================================================================================================

void CDisplay::PlotSpectrum3D(CDC* pDC)
{ 

    CPen penback(PS_SOLID, 1, dback);
    
    CPen* pOldPen = pDC->SelectObject(&pens[0]);
    pDC->MoveTo(0, dispy -1);
    pDC->LineTo(dispx + 1, dispy -1);
    pDC->MoveTo(0, dispy );
    pDC->LineTo(dispx + 1, dispy );
  
    pDC->SelectObject(&penblack);
    pDC->MoveTo(0, 0);
    pDC->LineTo(0, dispy);

    
    pDC->SelectObject(&pens[1]);
    pDC->MoveTo(0, dispy);
    pDC->LineTo(0, dispy - 2);
    pDC->MoveTo(dispx, dispy);
    pDC->LineTo(dispx, dispy - 2);

                                              // InitTime();
    int px;
    int nn;
   
    double k = (freqMax - freqMin) / 20;
    if (xlogtype && freqMin < k) k = freqMin;
    if (k >= 800) nn = 1024;
    else if (k >= 200) nn = 2048;
    else if (k >= 100) nn = 4096;
    else nn = 8192;
	if (SAMPLES_PER_SEC > 50000) nn *= 2;
	if (SAMPLES_PER_SEC > 150000) nn *= 2;

     
                                              // pDC->SetBkMode(OPAQUE);
                                              // pDC->SetBkColor(RGB(0,0,0));
                                              // Print (pDC, 250, dispy, nn);
   
    FHT(nn, fhtwindow);
                                              // Print(pDC, 10, dispy, GetTime());
    int ix = 0;
    int y, oldy;
    int p, oldp = 0;
    double vv = 0;
    
    if (ylogtype)
    {
        double db;
                   
        for (px = 0; px < dispx; px ++) 
        {
            vv = responseTab[ix++];
            if (vv > -1) break;
        }
        db = kdb * log(vv / 32768.0);
        y = int((16 * (db - dbmin) / (dbmax - dbmin)) + .5);
        if (y < 0) y = 0;
        oldy = y;
        pDC->MoveTo(0, dispy - y);

        for (px; px < dispx; px ++)
        {        
            vv = responseTab[ix++];
            if (vv > -1)
            {
                db = kdb * log(vv / 32768.0);
                y = int((16 * (db - dbmin) / (dbmax - dbmin)) + .5);
                if (y < 0) y = 0;

                p = y + oldy;
                oldy = y;

                if (p > 31) p = 31;
                if (p != oldp)
                {
                    pDC->SelectObject(&pens[p]);
                    oldp = p;
                }
  
                pDC->LineTo(px, dispy - y);
            }
        }
    }
    else
    {
        double kv = 2.0 / 32768;
        double vmin = 2 * exp(dbmin / kdb);
        double vmax = 2 * exp(dbmax / kdb);
        for (px = 0; px < dispx; px ++) 
        {
            vv = responseTab[ix++];
            if (vv > -1) break;
        }
        y = int((16 * (vv * kv - vmin) / (vmax - vmin)) + .5);
        if (y < 0) y = 0;
        oldy = y;
        pDC->MoveTo(0, dispy - y);

        for (px; px < dispx; px ++)
        {        
            vv = responseTab[ix++];
            if (vv > -1)
            {
                y = int((16 * (vv * kv - vmin) / (vmax - vmin)) + .5);
                if (y < 0) y = 0;

                p = y + oldy;
                oldy = y;

                if (p > 31) p = 31;
                if (p != oldp)
                {
                    pDC->SelectObject(&pens[p]);
                    oldp = p;
                }

                pDC->LineTo(px, dispy - y);
            }
        }
    }
    pDC->SelectObject(pOldPen);
}


// ================================================================================================
// ================================================================================================
//   CLASS DISPLAY : PLOT SWEP WAVE
// ================================================================================================
// ================================================================================================

void CDisplay::PlotSweepWave(CDC* pDC)
{
    int ix = 0;
    int y;

    if (ylogtype)
    {
        double db;       
        double v = responseTab[ix++];
        db = kdb * log(v / 32768.0);
        y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
        //if (y < -1) y = -1;
        pDC->MoveTo(leftborder, dispy - y);

        for (int px = leftborder; px < ddx; px ++)
        {        
            v = responseTab[ix++];         
            if (v)
            {
                db = kdb * log(v / 32768.0);
                y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
                //if (y < -1) y = -1;
                pDC->LineTo(px, dispy - y);
            }
        }
    }
    else
    {
        double kv = 2.0 / 32768;
        double vmin = 2 * exp(dbmin / kdb);
        double vmax = 2 * exp(dbmax / kdb);
        double v = responseTab[ix];
        y = int((dispy * (v * kv - vmin) / (vmax - vmin)) + .5);
        pDC->MoveTo(leftborder, dispy - y);

        for (int px = leftborder; px < ddx; px ++)
        {        
            v = responseTab[ix++];
            if (v)
            {
                y = int((dispy * (v * kv - vmin) / (vmax - vmin)) + .5);
                pDC->LineTo(px, dispy - y);
            }
        }
    }
}


// ================================================================================================
// ================================================================================================
//  CLASS DISPLAY : PLOT WAVE
// ================================================================================================
// ================================================================================================

void CDisplay::PlotWave(CDC* pDC)
{ 
	if (pDC->m_hDC == 0) return;

	// ============================================================== TRACE INTENSITY and COLORS
	int n = sizeof(TraceColors) / sizeof(TraceColors[0]);
	trace = InterpolateColor(traceIntensity / 256, TraceColors, n);
    CPen pentrace(PS_SOLID, 1, trace);
    CPen* pOldPen = pDC->SelectObject(&pentrace);

    //InitTime();
    //Print(pDC,100,4,activeInBuffers);
    //Print(pDC,150,4,activeOutBuffers);

   	// ============================================================== calc the global "fht_samples"
	if (analysisType == ANTYPE_SPECTR)
    {
        double k = (freqMax - freqMin) / 20;
        if (xlogtype && freqMin < k) k = freqMin;
        if (k >= 800) fht_samples = 1024;
        else if (k >= 200) fht_samples = 2048;
        else if (k >= 100) fht_samples = 4096;
        else fht_samples = 8192;
		if ( SAMPLES_PER_SEC > 50000 ) fht_samples = fht_samples * 2;
		if ( SAMPLES_PER_SEC > 150000) fht_samples = fht_samples * 2;
    }
	else if (analysisType == ANTYPE_FASTSW) 
    {
		fht_samples = FASTSWEEP_FHT_SAMPLES;
    }
	else if (analysisType == ANTYPE_PULSE) 
    {
		fht_samples = PULSE_FHT_SAMPLES;
    }

	// ------------------------------------------------------------------- display y / 2
    py = ddy / 2;
	// ------------------------------------------------------------------- posY snapped to 40 discrete positions
	// (ddy-1) ensures the zero marker always visible 
	// also changing display size 
	// and also when the zero marker is at the extreme low or high row 
	py1 = int(py - (ddy-1) * int(posY1 * 40) / 40.0);
    py2 = int(py - (ddy-1) * int(posY2 * 40) / 40.0); 
	// ------------------------------------------------------------------- posY_discrete prepared for MouseMove readout
	posY1_discrete = double(py1) / ddy;
	posY2_discrete = double(py2) / ddy;

	// -------------------------------------------------------------------
	//  0.001 because scaleY1 and scaleY2 are in millivolt
	//  65536 because adc samples are 16 bit 
	ky1 = float(ddy / (scaleY1 * mul1 / regY1 * 4 * 0.001) / 65536);
    ky2 = float(ddy / (scaleY2 * mul2 / regY2 * 4 * 0.001) / 65536);

	// ------------------------------------------------------------------- polarity
	if (neg1) polarity1 = -1; else polarity1 = 1;
	if (neg2) polarity2 = -1; else polarity2 = 1;

    // ------------------------------------------------------------------- step and sampPerScreen
    double step = (ddx - 2) * (100 / scaleX) * (regX / SAMPLES_PER_SEC);
    sampPerScreen = int(numCH * ddx / step);


	// ------------------------------------------------------------------- trigpos snapped to 100 discrete positions
	trigpos = int(trigpos * 100) / 100.0;

    triggered = FALSE;

	// ------------------------------------------------------------------- IF INPUT ON
    if (inputState)
    { 
		// ============================================================================================
		//  INIT THE READPOS TO THE LEFT OF THE SCREEN
		// ============================================================================================
		readpos = cbufPos - int(sampPerScreen * (1 - trigpos)) - 4;
        while (readpos < 0) readpos += IN_CBUF_LEN; 


		// ============================================================================================
		//  TRIGGERS
		// ============================================================================================
        if (trigType && analysisType < ANTYPE_SPECTR) 
        {
            //int samplesmax = sampPerScreen * 10;
			int samplesmax = sampPerScreen * 50;

            if (samplesmax > IN_CBUF_LEN) samplesmax = IN_CBUF_LEN;

            if (numCH == 2) readpos &= 0xFFFFFFFE;

			// -------------------------------------------------------------- init tgist and readpos+1
			double tgist = 0;

            if (trigCH == 0)
            {
				tgist = trigist * (vmax1 - vmin1) * .2; 
            }
            else
            {
				tgist = trigist * (vmax2 - vmin2) * .2; 
                readpos += 1;
            }          
            //Print(pDC,100,40,tgist);

			
			// ============================================================================================
			//  TRIGGER EXECUTION
			// ============================================================================================
			
			px = 0;

			// ------------------------------------------------------ BURST TRIGGER
            if (trigburst)
            {
                double v, min, max;

				int numsamp = 2 + int((trigstab * 0.3 * sampPerScreen));
				//int numsamp = 2 + int((trigstab * 0.5 * sampPerScreen));
                //Print(pDC,100,4, numsamp);
				//Print(pDC,100,4, samplesmax);

				// -------------------------------------------------- TRIGGER AUTOMATIC LEVEL for BURST
				if (trigCH) 
				{
					double delta = 1.2;
					if (vmid2 < 0) delta = -1;
					tglev = vmin2 + (triglev + delta + 2) / 2.1 * (vmax2 - vmin2) / 2;
					if (ac2) tglev -= vmid2;
				}
				else 
				{
					double delta = 1.2;
					if (vmid1 < 0) delta = -1;
					tglev = vmin1 + (triglev + delta + 2) / 2.1 * (vmax1 - vmin1) / 2;
					if (ac1) tglev -= vmid1;
				}

                if (!trigslope)
                {
                    // ---------------------------------------------- POSITIVE BURST TRIGGER (burst start)
                    do
                    {
                        min = DOUBLEMAX;
                        max = -DOUBLEMAX;
                        for (int i = 0; i < numsamp; i++)
                        {
                            v = pCbufIn[readpos];
                            if (v > max) max = v;
                            if (v < min) min = v;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        px += numsamp;
                    }while (((max - min) < tgist) && (px < samplesmax));

                    do
                    {
                        min = DOUBLEMAX;
                        max = -DOUBLEMAX;
                        for (int i = 0; i < numsamp; i++)
                        {
                            v = pCbufIn[readpos];
                            if (v > max) max = v;
                            if (v < min) min = v;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        px += numsamp;
                    }while (((max - min) > tgist) && (px < samplesmax));
              
                    if (tglev < (max - min) / 2)
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] <= tglev) break;
                            readpos += numCH;
                            if (readpos >= IN_CBUF_LEN) readpos -= IN_CBUF_LEN;
                        }
                    }
                    else
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] >= tglev) break;
                            readpos += numCH;
                            if (readpos >= IN_CBUF_LEN) readpos -= IN_CBUF_LEN;
                        }
                    }

                }
                else
                {
                    // ---------------------------------------------- NEGATIVE BURST TRIGGER (burst end)
                    do
                    {
                        min = DOUBLEMAX;
                        max = -DOUBLEMAX;
                        for (int i = 0; i < numsamp; i++)
                        {
                            v = pCbufIn[readpos];
                            if (v > max) max = v;
                            if (v < min) min = v;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        px += numsamp;
                    }while (((max - min) > tgist) && (px < samplesmax));

                   
                    if (tglev < (max - min) / 2)
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] <= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                    }
                    else
                    {
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] >= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                    }
                }

            }
            else
            {

                // -------------------------------------------------- NORMAL TRIGGER
                int tgstab = int((1 - trigstab) * 100);
                if (tgstab > 95) tgstab = 100000;
                //Print(pDC,100,4, tgstab);

				// -------------------------------------------------- TRIGGER AUTOMATIC LEVEL for NORMAL WAVES
				if (trigCH) 
				{
					if (!trigslope) tglev = vmin2 + (triglev + 1) * (vmax2 - vmin2) / 2 * (1 - trigist * 0.2);
					else			tglev = vmax2 - (triglev + 1) * (vmax2 - vmin2) / 2 * (1 - trigist * 0.2); 
					if (ac2) tglev -= vmid2;
				}
				else 
				{
					if (!trigslope) tglev = vmin1 + (triglev + 1) * (vmax1 - vmin1) / 2 * (1 - trigist * 0.2);
					else			tglev = vmax1 - (triglev + 1) * (vmax1 - vmin1) / 2 * (1 - trigist * 0.2);
					if (ac1) tglev -= vmid1;
				}

                do                                                  
                {
                    if (!trigslope)
                    {
						// ------------------------------------------ TRIGGER positive with isteresis
						for (px = px; px < samplesmax; px++)
                        {
                            if (pCbufIn[readpos] > tglev + tgist) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] <= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
						}
                    }
                    else
                    {
						// ------------------------------------------ TRIGGER negative with isteresis
						for (px = px; px < samplesmax; px++)
                        {
                            if (pCbufIn[readpos] < tglev - tgist) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                        for (px = px; px < samplesmax; px++)
                        { 
                            if (pCbufIn[readpos] >= tglev) break;
                            readpos -= numCH;
                            if (readpos < 0) readpos += IN_CBUF_LEN;
                        }
                    }
                }
                while (abs(pCbufIn[readpos] - tglev) > tgstab && px < samplesmax);

            }
            triggered = (px < samplesmax);
        }
        trigsample = readpos;

    }

	// -------------------------------------------------------------------- delay to readpos
	readpos = trigsample + int(delaypos * numCH); 
	if (readpos > IN_CBUF_LEN) readpos = IN_CBUF_LEN;
	if (readpos < -IN_CBUF_LEN) readpos = -IN_CBUF_LEN;
			
	// -------------------------------------------------------------------- trigpos to readpos
    readpos -= int(sampPerScreen * trigpos);
    while (readpos < 0) readpos += IN_CBUF_LEN;

    //Print(pDC, 100, 100,  sweepStatus);
    //Print(pDC, 100, 100,  activeInBuffers);
    //Print(pDC, 100, 150,  activeOutBuffers);


    // ============================================================================================
    //  SWEEP CONTROL
    // ============================================================================================
    if (analysisType == ANTYPE_SWEEP)
    {
        if (outputState && inputState && sweepStatus &&
            activeInBuffers <= 0 && activeOutBuffers <= 0)
        {
            if (!LButtonPressed() || !(regulationType == REGTYPE_FMAX || 
									   regulationType == REGTYPE_FMIN || 
									   regulationType == REGTYPE_TIME))
            {             
                if (multiDraw) PlotSweepWave(pDC);

                // IF SWEEP MULTIDRAW must press the right mouse button to start the sweep
                if (RButtonPressed() || !multiDraw)
                { 

                    if (sweepStatus == 2) ResetFhtBuffers();

                    DAA_ResetSweep(FALSE);
           
                    waveInReset(hwIn);
            
                    /*
                    int nbi = int(ceil(sweepTime * SAMPLES_PER_SEC / IN_BUF_LEN));
                    if (nbi > N_BUFIN) nbi = N_BUFIN;
                    */
                    for (int i = 0; i < N_BUFIN; i++) DAA_AddBuffer();

                        //waveOutReset(hwOut);
                    waveOutPause(hwOut);
                    int nbo = int(ceil(sweepTime * SAMPLES_PER_SEC / OUT_BUF_LEN / 2));
                    if (nbo > N_BUFOUT) nbo = N_BUFOUT;
                    for (int i = 0; i < nbo; i++) DAA_FillBuffer(); 
                    
					waveInStart(hwIn);
                    waveOutRestart(hwOut);       
                    
					sweepStatus = 0;
                }
            }
        }
        readpos = 200 * numCH;
    }


    // ============================================================================================
    //  FASTSWEEP and PULSE control  (search the pulse start position)
    // ============================================================================================
    if ((analysisType == ANTYPE_FASTSW) || (analysisType == ANTYPE_PULSE))
	{
		// ---------------------------------------------------------- if the trigCH is not AC then prepare a vmid for it
		float vmidch = 0;
		if (trigCH == 0 && !ac1) vmidch = float(vmid1);
		if (trigCH == 1 && !ac2) vmidch = float(vmid2);
		// ---------------------------------------------------------- start from cbufpos - PULSE_TOTAL_SAMPLES * 2
		// PULSE CHANNEL 1-2 SELECT using the trigCH value (0 or 1)
		readpos = cbufPos - PULSE_TOTAL_SAMPLES * 2 * numCH + trigCH;
		while (readpos < 0) readpos += IN_CBUF_LEN;
		// ---------------------------------------------------------- search forward the maximum sample
		float v; 
		float vmax = 0;
		for (int i = 0; i < PULSE_TOTAL_SAMPLES; i ++)
        {
			if ((readpos += numCH) >= IN_CBUF_LEN) readpos -= IN_CBUF_LEN;
            v = pCbufIn[readpos] - vmidch;
			v = abs(v);
			if (v > vmax)
			{
				vmax = v;
				pulseCbuffPos = readpos;
			}
        }
		// ---------------------------------------------------------- search backward for 50mS below 10% of max
		int counter = 0;
		int countmax = int(SAMPLES_PER_SEC * 0.05);
		readpos = pulseCbuffPos;
		for (int i = 0; i < PULSE_TOTAL_SAMPLES; i ++)
		{
			if ((readpos -= numCH) < 0) readpos += IN_CBUF_LEN;
			v = pCbufIn[readpos] - vmidch;
			v = abs(v);
			if (v > vmax * 0.1)
			{
				pulseCbuffPos = readpos;
				counter = 0;
			}
			else
			{
				if (counter++ > countmax) break;
			}
		}
		readpos = pulseCbuffPos;
		// ---------------------------------------------------------- go another little time before
		if (analysisType == ANTYPE_FASTSW)
		{
			pulseCbuffPos = readpos - numCH * int(SAMPLES_PER_SEC * 0.05);	 // 50 mS
		}
		else
		{
			pulseCbuffPos = readpos - numCH * int(SAMPLES_PER_SEC * 0.0002); // 200 uS
		}
		// ---------------------------------------------------------- Set the start positions
		if (DisplaySamples)
        { 
			readpos = pulseCbuffPos;
            readpos += numCH * int(SAMPLES_PER_SEC * start_sampling_ms / 1000);
            readpos -= int(sampPerScreen * trigpos);
			while (readpos < 0) readpos += IN_CBUF_LEN;
        }
	}

    
    // ============================================================================
    //  DISPLAY - WAVES / SWEEP / PULSES
    // ============================================================================
    if (numCH == 2) readpos &= 0xFFFFFFFE;

	// ---------------------------------------------------- select the waves and spectrum visualizations
    int selection = selectCH;
    if (!DisplaySamples)
    {
        if (analysisType == ANTYPE_SWEEP) selection = 10;
		if ( (analysisType == ANTYPE_SPECTR)||
			 (analysisType == ANTYPE_FASTSW)||
			 (analysisType == ANTYPE_PULSE) ) selection = 11;
    }

	// ------------------------------------------------------------------------------ 
	//  To save processor time do not display waves if the window is minimized 
	//  But spectrum (11) must do the FHT to calc the new values for the Slots
	//  (the spectrum display is not suppressed but it is very fast)
	// ------------------------------------------------------------------------------ 
	if (WindowMinimized && selection < 11) selection = -1;

	// ---------------------------------------------------- select the visualizations
    switch (selection)
    {

		// ============================================================================
		//  DISPLAY WAVE - CH1 / CH2 / ADD / SUB
		// ============================================================================
		case 0:
		case 1: 
		case 2:
		case 3:
		case 4:
		{
			// ---------------------------------------------------------- prepare readpos1 and readpos2
			readpos1 = readpos;
			if (selectCH >= 2)
			{
				readpos2 = readpos + int(scaleX * -deltapos * numCH);
				if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
				if (readpos2 < 0) readpos2 = 0;
			}
			else
			{
				readpos2 = readpos;
			}
			if (numCH == 2) readpos2 += 1;

			// ---------------------------------------------------------- 
			int oldy1 = int(py1 - pCbufIn[readpos1] * ky1);
			int oldy2 = int(py2 - pCbufIn[readpos2] * ky2);
			float v1, v2;
			int oldx = 0;
			int xx;
			bool show1 = (selectCH != 1);
			bool show2 = (selectCH == 1 || selectCH == 2);

			if (scaleX < 2)
			{
				// ------------------------------------------------------ from 1 mS to 0.1 mS plot all the samples (SLOW)
				for (px = step; px < ddx + step; px += step)
				{
					if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
					if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

					v1 = -pCbufIn[readpos1];
					v2 = -pCbufIn[readpos2]; 

					v1 = py1 + v1 * ky1;
					v2 = py2 + v2 * ky2;

					xx = int(px);
					if (show1)
					{
						pDC->MoveTo(oldx, oldy1);
						pDC->LineTo(xx, int(v1));
					}
					if (show2)
					{
						pDC->MoveTo(oldx, oldy2);
						pDC->LineTo(xx, int(v2));
					}

					oldy1 = int(v1);
					oldy2 = int(v2);
					oldx = xx;
				}
			}
			else
			{
				// ------------------------------------------------------ from 1 S to 2 mS plot every new pixel (FAST)
				int pix = 0;
				int oldpix = -1;
				double min1 = DOUBLEMAX;
				double max1 = -DOUBLEMAX;
				double min2 = DOUBLEMAX;
				double max2 = -DOUBLEMAX;
				int ymin1 = 0; 
				int ymax1 = 0;
				int ymin2 = 0;
				int ymax2 = 0;
				int oldymin1 = -99999;
				int oldymax1 = 99999;
				int oldymin2 = -99999;
				int oldymax2 = 99999;

				for (px = 0; px < ddx; px += step)
				{
					if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
					if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

					v1 = -pCbufIn[readpos1];
					v2 = -pCbufIn[readpos2];
	                      
					if (v1 > max1) max1 = v1;
					if (v1 < min1) min1 = v1;
					if (v2 > max2) max2 = v2;
					if (v2 < min2) min2 = v2;

					pix = int(px);
					if (pix > oldpix)
					{  
						ymin1 = int(py1 + min1 * ky1);
						ymax1 = int(py1 + max1 * ky1);
						ymin2 = int(py2 + min2 * ky2);
						ymax2 = int(py2 + max2 * ky2);

						if (show1)
						{
							// ---------------------------------------------- fill little gaps when changing pixel
							if (ymax1 >= oldymax1)
							{
								pDC->MoveTo(pix, oldymax1);           
								pDC->LineTo(pix, ymax1); 
							}
							if (ymin1 <= oldymin1)
							{
								pDC->MoveTo(pix, oldymin1);           
								pDC->LineTo(pix, ymin1); 
							}
							// ---------------------------------------------- draw a line or a single pixel
							if (ymax1 > ymin1)
							{
								pDC->MoveTo(pix, ymin1);           
								pDC->LineTo(pix, ymax1 + 1); 
							}
							else
							{
								pDC->SetPixelV(pix, ymin1, trace);       
							}
						}

						if (show2)
						{
							// ---------------------------------------------- fill little gaps when changing pixel
							if (ymax2 >= oldymax2)
							{
								pDC->MoveTo(pix, oldymax2);           
								pDC->LineTo(pix, ymax2); 
							}
							if (ymin2 <= oldymin2)
							{
								pDC->MoveTo(pix, oldymin2);           
								pDC->LineTo(pix, ymin2); 
							}
							// ---------------------------------------------- draw a line or a single pixel
							if (ymax2 > ymin2)
							{
								pDC->MoveTo(pix, ymin2);           
								pDC->LineTo(pix, ymax2 + 1); 
							}
							else
							{
								pDC->SetPixelV(pix, ymin2, trace);       
							}
						}

						oldymin1 = ymin1;
						oldymax1 = ymax1;
						oldymin2 = ymin2;
						oldymax2 = ymax2;
						min1 = DOUBLEMAX;
						max1 = -DOUBLEMAX;
						min2 = DOUBLEMAX;
						max2 = -DOUBLEMAX;
						oldpix = pix;
					}
				}
			}
		}
		break;

	
		// ============================================================================
		//  DISPLAY WAVE - XY
		// ============================================================================
		case 5:
		{
			readpos1 = readpos;
			readpos2 = readpos + int(scaleX * -deltapos * numCH);
			if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
			if (readpos2 < 0) readpos2 = 0;
			if (numCH == 2) readpos2 += 1;

			int px1 = ddx / 2 + int((ddy / 2 - py1)* ddx / ddy * 8.0 / 10.0);

			float v1, v2;
			v1 = pCbufIn[readpos1];
			v2 = -pCbufIn[readpos2];
			pDC->MoveTo(int(v1 * ky1 + px1), int(v2 * ky2 + py2));

			if (scaleX < 2)
			{
				// ------------------------------------------------------ from 1 mS to 0.1 mS plot all the samples (SLOW)
				for (px = step; px < ddx; px += step)
				{
					if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
					if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

					v1 = pCbufIn[readpos1];
					v2 = -pCbufIn[readpos2];
					pDC->LineTo(int(v1 * ky1 + px1), int(v2 * ky2 + py2));
				}
			}
			else
			{
				// ------------------------------------------------------ from 1 S to 2 mS plot every new pixel (FAST)
				int pix = 0;
				int oldpix = -1;
	            
				for (px = step; px < ddx; px += step)
				{
					if ((readpos1 += numCH) >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
					if ((readpos2 += numCH) >= IN_CBUF_LEN) readpos2 -= IN_CBUF_LEN;

					v1 = pCbufIn[readpos1];
					v2 = -pCbufIn[readpos2];
	                     
					pix = int(px);
					if (pix > oldpix)
					{              
						pDC->LineTo(int(v1 * ky1 + px1), int(v2 * ky2 + py2));                                      
						oldpix = pix;
					}
				}
			}
		}
		break;


		// ============================================================================
		//  DISPLAY - SWEEP
		// ============================================================================
		case 10:
		{
			if (analysisType == ANTYPE_SWEEP && multiDraw && LButtonPressed()) dcScreen.BitBlt(0, 0, ddx, ddy, &dcGrid, 0, 0, SRCCOPY);
			if (sweepStatus > 1 && inputState && outputState);
			else if (!multiDraw) PlotSweepWave(pDC);  
		}
		break;


		// ============================================================================
		//  DISPLAY - SPECTRUM, FAST SWEEP & PULSE
		// ============================================================================
		case 11:
		{
			// ------------------------------------------ Execute the Fast Hartley Transform 
			// InitTime();
			static double oldfreqmax = 0;
			static double oldfreqmin = 0;
			if (inputState)// || freqMin != oldfreqmin || freqMax != oldfreqmax)
			{
				oldfreqmax = freqMax;
				oldfreqmin = freqMin;

				if (analysisType == ANTYPE_SPECTR)
				{
					FHT(fht_samples, fhtwindow);
				}
				else if (((analysisType == ANTYPE_FASTSW) || (analysisType == ANTYPE_PULSE)) && outputState ) 
				{
					if (pulseFlag)
					{
						FHT(fht_samples, fhtwindow);
						pulseFlag = FALSE;
					}
				}
				else
				{
					FHT(fht_samples, fhtwindow);
				}
			}
			else
			{
				if (freqMin != oldfreqmin || freqMax != oldfreqmax)
				{
					ResetFhtBuffers();
				}
			}
			// Print (pDC, 250, 2, GetTime());

			// ------------------------------------------ Display the spectrum
			int ix = 0;
			int y;
			double vv = 0;
	        
			if (ylogtype)
			{
				double db;
	                       
				for (px = leftborder; px < ddx; px ++) 
				{
					vv = responseTab[ix++];
					if (vv > -1) break;
				}
				db = kdb * log(vv / 32768.0);
				y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
				if (y < 0) y = 0;
				pDC->MoveTo(leftborder, dispy - y);

				for (px; px < ddx; px ++)
				{        
					vv = responseTab[ix++];
					if (vv > -1)
					{
						db = kdb * log(vv / 32768.0);
						y = int((dispy * (db - dbmin) / (dbmax - dbmin)) + .5);
						if (y < 0) y = 0;    
						pDC->LineTo(int(px), dispy - y);
					}
				}
			}
			else
			{
				double kv = 2.0 / 32768;
				double vmin = 2 * exp(dbmin / kdb);
				double vmax = 2 * exp(dbmax / kdb);
				for (px = leftborder; px < ddx; px ++) 
				{
					vv = responseTab[ix++];
					if (vv > -1) break;
				}
				y = int((dispy * (vv * kv - vmin) / (vmax - vmin)) + .5);
				if (y < 0) y = 0;
				pDC->MoveTo(leftborder, dispy - y);

				for (px; px < ddx; px ++)
				{        
					vv = responseTab[ix++];
					if (vv > -1)
					{
						y = int((dispy * (vv * kv - vmin) / (vmax - vmin)) + .5);
						if (y < 0) y = 0;
						pDC->LineTo(int(px), dispy - y);
					}
				}
			}

		}
		break;

    }
	pDC->SelectObject(pOldPen); 
}
   


// ================================================================================================
// ================================================================================================
//  CLASS DISPLAY : READOUT
// ================================================================================================
// ================================================================================================

void CDisplay::DisplayReadout(CDC* pDC)
{
	if (pDC->m_hDC == 0) return;
	// ----------------------------------------------------- OSD readout color
	int r = int(osdIntensity + 25);
    int g = int(osdIntensity + 55);
    int b = int(osdIntensity + 45);
    COLORREF osdColor = RGB(r, g, b);
    CPen penZeroLevel(PS_SOLID, 1, osdColor);
	CPen* pOldPen = pDC->SelectObject(&penZeroLevel);
	pDC->SetBkMode (TRANSPARENT);
    pDC->SetTextColor(osdColor);
	// ----------------------------------------------------- fontsize depending positions
	int toptext = int(fontsize * 0.2);
	int bottomtext2 = int(dispdy - fontsize * 2.1);
	int bottomtext1 = int(dispdy- fontsize * 1.2);
	// ----------------------------------------------------- font
	CFont font;
	font.CreateFont(fontsize, 0, 0, 0, 580, 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, "Arial");
	CFont font2;
	font2.CreateFont(int(fontsize * 0.8), 0, 0, 0, 580, 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, "Arial");
    CFont* pOldFont = pDC->SelectObject(&font);

    // ============================================================================
    //   READOUT - SCOPE                 
    // ============================================================================
    if (osdIntensity > 110 && analysisType < ANTYPE_SPECTR || DisplaySamples)
    {
        CString s = "";
		
		// -------------------------------------------------------------- READOUT - ZERO LEVEL INDICATORS
		if (analysisType < ANTYPE_SPECTR || DisplaySamples)
		{
			int size = int(dispdx * 0.01);
			for (int i = 0; i <= 20; i++)
			{
				int x = int(i * dispdx / 20);
				if (selectCH == 0 || selectCH > 1)
				{
					pDC->MoveTo(x-size, py1);           
					pDC->LineTo(x+size, py1);
				}
				if (selectCH == 1 || selectCH == 2 || selectCH == 5)
				{
					pDC->MoveTo(x-size, py2);           
					pDC->LineTo(x+size, py2);
				}
			}
		}

        // -------------------------------------------------------------- READOUT - VOLT-METER & FREQUENCY-METER
        if ((curstype == 1 || curstype == 2) && inputState)
        {

			// ---------------------------------------------------------- READOUT - CH1 - CH2 and % of CH2
			if (selectCH == 3 || selectCH == 4)
			{
                if (ky1 != ky2)
                {
                    double rapp = 100 * (scaleY1 / regY1) / (scaleY2 / regY2) * mul1 / mul2;
                    if (rapp < 100 && regY1 != regY2) s.Format("%2.3f%% of ", rapp);
                    else s.Format("%2.1f%% of ", rapp); 
					if (selectCH == 3) s = "CH1 + " + s + "CH2";// + s;
					else if (selectCH == 4) s = "CH1 - " + s + "CH2";// + s;
					pDC->TextOut(int(fontsize * 0.5), toptext + int(fontsize * 1.2), s);
                }
				else
				{
					if (selectCH == 3) s = "CH1+CH2";// + s;
					else s = "CH1-CH2";// + s;
					pDC->TextOut(int(fontsize * 0.5), toptext, s);
				}
			}
			else if (curstype == 1) pDC->TextOut(int(fontsize * 1), toptext, "CH 2");
            else pDC->TextOut(int(fontsize * 1), toptext, "CH 1");


			// ---------------------------------------------------------- READOUT - Vrms / Vdc 
			if (volttype)
            {
				if (curstype == 1) mVdcInst = vrms2 / 32.768;
				else mVdcInst = vrms1 / 32.768;
				SmoothValue(mVdc, mVdcInst, 5);

				s = MillivoltToString2(mVdc, 3) + "rms";
				pDC->TextOut(int(fontsize * 6), toptext, s);
				if (FirstSlot > 0) WriteSlot(FirstSlot, mVdc / 1000);
			}
			else
			{
				if (curstype == 1) mVdcInst = vmid2 / 32.768;
				else mVdcInst = vmid1 / 32.768;
				SmoothValue(mVdc, mVdcInst, 5);

				s = MillivoltToString(mVdc, 4) + "dc";
				pDC->TextOut(int(fontsize * 6), toptext, s);
				if (FirstSlot > 0) WriteSlot(FirstSlot, mVdc / 1000);
			}

			// ---------------------------------------------------------- READOUT - dB / Vpp 
            if (volttype)
            {
				// ----------------------------------------------- from Vrms
				double db = VrmsTodB(vrms1 / 32.768);
				if (curstype == 1) db = VrmsTodB(vrms2 / 32.768);
				// -----------------------------------------------
				s = DecibelToString(db);
				pDC->TextOut(int(fontsize * 14), toptext, s);
				if (FirstSlot > 0) WriteSlot(FirstSlot + 1, db);
            }
            else
            {
				if (curstype == 1) mVppInst = (vmax2 - vmin2) / 32.768; 
				else mVppInst = (vmax1 - vmin1) / 32.768; 
				SmoothValue_Pow_Adaptive(mVpp, mVppInst, .1);
				// ----------------------------------------------
				s = MillivoltToString(mVpp, 3) + "pp";
				pDC->TextOut(int(fontsize * 14), toptext, s);
				if (FirstSlot > 0) WriteSlot(FirstSlot + 1, mVpp / 1000);
            }
            
			// ---------------------------------------------------------- READOUT - Frequency
            if (fmeterResultCycles)
            {
                double time = (double(fmeterResultSamples) / double(SAMPLES_PER_SEC)) / double(fmeterResultCycles);

                if (timetype)
                {  
					s = HertzToString(1.0 / time, 5, 2);
					if (FirstSlot > 0) WriteSlot(FirstSlot + 2, 1.0 / time);
                }
                else
                {      
					s = MillisecToString(time * 1000, 4);
					if (FirstSlot > 0) WriteSlot(FirstSlot + 2, time);
                }
                pDC->TextOut(dispdx - int(fontsize * 5.2), toptext, s);
            } 

			if (curstype == 1)
			{
				fmeterTrigUp = vmin2 + (vmax2 - vmin2) * 7 / 10;
				fmeterTrigDown = vmin2 + (vmax2 - vmin2) * 3 / 10;
			}
			else
			{
				fmeterTrigUp = vmin1 + (vmax1 - vmin1) * 7 / 10;
				fmeterTrigDown = vmin1 + (vmax1 - vmin1) * 3 / 10;
			}

        }
        else if (curstype == 3)
        {
			float v1, v2, vs;
            int x1, x2, intp;
			int y1 = 0;
			int y2 = 0;
            double p;
           
            // -------------------------------------------------------------------------------------- 
			//   READOUT - CURSORS - CH1 / CH1+2 / ADD / SUB
			// --------------------------------------------------------------------------------------
            if (selectCH == 0 || selectCH == 2 || selectCH == 3 || selectCH == 4)                 
            {
                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v1 = -pCbufIn[readpos1];     
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = -pCbufIn[readpos1]; 
                v1 += int((vs - v1) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;        
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v2 = -pCbufIn[readpos1];    
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = -pCbufIn[readpos1];
                v2 += int((vs - v2) * (p - intp) / numCH);

                y1 = py1 + int(v1 * ky1);
                y2 = py1 + int(v2 * ky1);

                if (curs1 == 0) {v1 = 0; y1 = py1;}
                if (curs2 == 0) {v2 = 0; y2 = py1;}

                x1 = int(ddx * curs1);
                x2 = int(ddx * curs2);
       
                pDC->MoveTo(x1 - 5, y1);           
                pDC->LineTo(x1 + 5, y1);
                pDC->MoveTo(x1, y1 + 5);           
                pDC->LineTo(x1, y1 - 5);

                pDC->MoveTo(x2 - 5, y2);           
                pDC->LineTo(x2 + 5, y2);
                pDC->MoveTo(x2, y2 + 5);           
                pDC->LineTo(x2, y2 - 5);

				if (curs1 == 0) {x1 += int(fontsize * 0.3); y1 += int(fontsize * .8);}
                if (curs2 == 0) {x2 += int(fontsize * 0.3); y2 += int(fontsize * .8);}
                pDC->TextOut(x1 - int(fontsize * 0.25), y1 - int(fontsize * 1.8), "1");
                pDC->TextOut(x2 - int(fontsize * 0.25), y2 - int(fontsize * 1.8), "2");

                mVppInst = -(v2 - v1) / 32.768;
				SmoothValue(mVpp1, mVppInst, 5);

                if (volttype)
                {
					double db = mVppToDB(abs(mVpp1));
                    s.Format(" %2.1f dB", db);
					if (FirstSlot > 0) WriteSlot(FirstSlot, db);
                }
                else
                {
                    if (abs(mVpp1) >= 100) s.Format("%1.3f V", mVpp1 / 1000);
                    else s.Format("%2.1f mV", mVpp1);
					if (FirstSlot > 0) WriteSlot(FirstSlot, mVpp1 / 1000);
                }

				// --------------------------------------------------------------- OSD - CH1 - CH2 and % of CH2
				CString s2 = "";
                if (ky1 != ky2)
                {
                    double rapp = 100 * (scaleY1 / regY1) / (scaleY2 / regY2) * mul1 / mul2;
                    if (rapp < 100 && regY1 != regY2) s2.Format("%2.3f%% of ", rapp);
                    else s2.Format("%2.1f%% of ", rapp);   
                }
				if (selectCH == 3) s = "CH1 + " + s2 + "CH2  = " + s;
                else if (selectCH == 4) s = "CH1 - " + s2 + "CH2  = " + s;
				else s = "CH1  " + s;
				pDC->TextOut(fontsize, toptext, s);
            }

            // --------------------------------------------------------------------------------------
			//  READOUT - CURSORS - CH 2
			// --------------------------------------------------------------------------------------
            if (selectCH == 1 || selectCH == 2)
            {
                readpos2 = readpos;
                if (selectCH == 2)
                {
                    readpos2 += int(scaleX * -deltapos * numCH);
                    if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
					if (readpos2 < 0) readpos2 = 0;
                }

                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v1 = -pCbufIn[readpos1];    
                readpos1 = readpos2 + intp + numCH;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN; 
                vs = -pCbufIn[readpos1]; 
                v1 += int((vs - v1) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;         
                v2 = -pCbufIn[readpos1];        
                readpos1 = readpos2 + intp + numCH; 
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = -pCbufIn[readpos1]; 
                v2 += int((vs - v2) * (p - intp) / numCH);


                y1 = py2 + int(v1 * ky2);
                y2 = py2 + int(v2 * ky2);

                
                if (curs1 == 0) {v1 = 0; y1 = py2;}
                if (curs2 == 0) {v2 = 0; y2 = py2;}

                x1 = int(ddx * curs1);
                x2 = int(ddx * curs2);
       
                pDC->MoveTo(x1 - 5, y1);           
                pDC->LineTo(x1 + 5, y1);
                pDC->MoveTo(x1, y1 + 5);           
                pDC->LineTo(x1, y1 - 5);

                pDC->MoveTo(x2 - 5, y2);           
                pDC->LineTo(x2 + 5, y2);
                pDC->MoveTo(x2, y2 + 5);           
                pDC->LineTo(x2, y2 - 5);
                       
				if (curs1 == 0) {x1 += int(fontsize * 0.3); y1 += int(fontsize * .8);}
                if (curs2 == 0) {x2 += int(fontsize * 0.3); y2 += int(fontsize * .8);}
                pDC->TextOut(x1 - int(fontsize * 0.25), y1 - int(fontsize * 1.8), "1");
                pDC->TextOut(x2 - int(fontsize * 0.25), y2 - int(fontsize * 1.8), "2");

                mVppInst = -(v2 - v1) / 32.768;
				SmoothValue(mVpp2, mVppInst, 5);

                if (volttype)
                {
					double db = mVppToDB(abs(mVpp2));
                    s.Format(" %2.1f dB", db);
					if (FirstSlot > 0) WriteSlot(FirstSlot + 1, db);
                }
                else
                {
                    if (abs(mVpp2) >= 100) s.Format("%1.3f V", mVpp2 / 1000);
                    else s.Format("%2.1f mV", mVpp2);
					if (FirstSlot > 0) WriteSlot(FirstSlot + 1, mVpp2 / 1000);
                }
                pDC->TextOut(int(fontsize * 10), toptext, "CH2  " + s);
            }

            // --------------------------------------------------------------------------------------
			//  READOUT - CURSORS - XY
			// --------------------------------------------------------------------------------------
            if (selectCH == 5)                
            {
                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v1 = -pCbufIn[readpos1];         
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = -pCbufIn[readpos1];  
                v1 += int((vs - v1) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos + intp;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v2 = -pCbufIn[readpos1];            
                readpos1 = readpos + intp + numCH;       
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = -pCbufIn[readpos1];     
                v2 += int((vs - v2) * (p - intp) / numCH);

                float v3, v4;          
                readpos2 = readpos + int(scaleX * -deltapos * numCH);
                if (readpos2 < 0) readpos2 += IN_CBUF_LEN;
				if (readpos2 < 0) readpos2 = 0;
               
                p = sampPerScreen * curs1;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                v3 = -pCbufIn[readpos1];    
                readpos1 = readpos2 + intp + numCH;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN; 
                vs = -pCbufIn[readpos1]; 
                v3 += int((vs - v3) * (p - intp) / numCH);
                
                p = sampPerScreen * curs2;
                intp = int(p);
                if (numCH == 2) intp &= 0xFFFFFFFE;
                readpos1 = readpos2 + intp;
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;         
                v4 = -pCbufIn[readpos1];        
                readpos1 = readpos2 + intp + numCH; 
                if (numCH == 2) readpos1 ++;
                if (readpos1 >= IN_CBUF_LEN) readpos1 -= IN_CBUF_LEN;
                vs = -pCbufIn[readpos1]; 
                v4 += int((vs - v4) * (p - intp) / numCH);

                // ----------------------------------------------------------------------
				int px1 = ddx / 2 + int((ddy / 2 - py1)* ddx / ddy * 8.0 / 10.0);

                x1 = px1 - int(v1 * ky1);
                x2 = px1 - int(v2 * ky1);
                y1 = py2 + int(v3 * ky2);
                y2 = py2 + int(v4 * ky2);
                
                mVppInst = -(v2 - v1) / 32.768;
				SmoothValue(mVpp1, mVppInst, 5);
                      
                if (volttype)
                {
					double db = mVppToDB(abs(mVpp1));
					s.Format(" %2.1f dB", db);
					if (FirstSlot > 0) WriteSlot(FirstSlot, db);
                }
                else
                {
                    if (abs(mVpp1) >= 100) s.Format("%1.3f V", mVpp1 / 1000);
                    else s.Format("%2.1f mV", mVpp1);
					if (FirstSlot > 0) WriteSlot(FirstSlot, mVpp1 / 1000);
                }
                pDC->TextOut(fontsize, toptext, "dX  " + s);

                mVppInst = -(v4 - v3) / 32.768;
				SmoothValue(mVpp2, mVppInst, 5);
        
                if (volttype)
                {
					double db = mVppToDB(abs(mVpp2));
					s.Format(" %2.1f dB", db);
					if (FirstSlot > 0) WriteSlot(FirstSlot + 1, db);
                }
                else
                {
                    if (abs(mVpp2) >= 100) s.Format("%1.3f V", mVpp2 / 1000);
                    else s.Format("%2.1f mV", mVpp2);
					if (FirstSlot > 0) WriteSlot(FirstSlot + 1, mVpp2 / 1000);
                }
                pDC->TextOut(int(fontsize * 10), toptext, "dY  " + s);
                
       
                pDC->MoveTo(x1 - 5, y1);           
                pDC->LineTo(x1 + 5, y1);
                pDC->MoveTo(x1, y1 + 5);           
                pDC->LineTo(x1, y1 - 5);

                pDC->MoveTo(x2 - 5, y2);           
                pDC->LineTo(x2 + 5, y2);
                pDC->MoveTo(x2, y2 + 5);           
                pDC->LineTo(x2, y2 - 5);
                       
                if (curs1 == 0) {x1 += int(fontsize * 0.3); y1 += int(fontsize * .8);}
                if (curs2 == 0) {x2 += int(fontsize * 0.3); y2 += int(fontsize * .8);}
                pDC->TextOut(x1 - int(fontsize * 0.25), y1 - int(fontsize * 1.8), "1");
                pDC->TextOut(x2 - int(fontsize * 0.25), y2 - int(fontsize * 1.8), "2");
            }
     

            // ---------------------------------------------------------- READOUT - CURSORS - TIME & FREQ
            double time = scaleX / regX * fabs(curs2 - curs1) / 100.0;
     
            if (timetype)
            {   
                if (time <= 0.00001) s = "1/dT = ? Hz";
                else s.Format("1/dT = %1.1f Hz", 1 / time);
				if (FirstSlot > 0) WriteSlot(FirstSlot + 2, 1 / time);
            }
            else
            {           
                s.Format("dT = %1.3f mS", time * 1000);
				if (FirstSlot > 0) WriteSlot(FirstSlot + 2, time);
            }
            pDC->TextOut(int(dispdx - fontsize * 8), toptext, s);
        }

        // -------------------------------------------------------------- READOUT - LOWER ROW - CH1 V/div
        if (selectCH != 1)
        {
			double mv = scaleY1 * mul1 / regY1;
			if (mv >= 1000)
			{
				mv /= 1000;
				if (mv != int(mv)) s.Format("%3.2f V", mv);
				else s.Format("%3.0f V", mv);
			}
			else
			{
				if (mv != int(mv)) s.Format("%3.1f mV", mv);
				else s.Format("%3.0f mV", mv);
			}
			pDC->TextOut(int(fontsize * 0.5), bottomtext1,  s);
            s = "DC ";
			if (ac1) s = "AC ";
            if (neg1) s += "Neg ";
			if (Filter_CH1 == 1) s += "LP " + HertzToString(filterCH1.GetFrequency(), 3);
			else if (Filter_CH1 == 2) s += "HP " + HertzToString(filterCH1.GetFrequency(), 3);
            else if (regY1 != 1) s += "Uncal";
			pDC->SelectObject(&font2);
            pDC->TextOut(int(fontsize * 0.5), bottomtext2, s);
			pDC->SelectObject(&font);
		}
		// -------------------------------------------------------------- READOUT - LOWER ROW - CH2 V/div
        if (selectCH > 0)
        {
			double mv = scaleY2 * mul2 / regY2;
			if (mv >= 1000)
			{
				mv /= 1000;
				if (mv != int(mv)) s.Format("%3.2f V", mv);
				else s.Format("%3.0f V", mv);
			}
			else
			{
				if (mv != int(mv)) s.Format("%3.1f mV", mv);
				else s.Format("%3.0f mV", mv);
			}
            pDC->TextOut(int(fontsize * 7), bottomtext1,  s);
            s = "DC ";
			if (ac2) s = "AC ";
            if (neg2) s += "Neg ";
            if (Filter_CH2 == 1) s += "LP " + HertzToString(filterCH2.GetFrequency(), 3);
			else if (Filter_CH2 == 2) s += "HP " + HertzToString(filterCH2.GetFrequency(), 3);
            else if (regY2 != 1) s += "Uncal";
			pDC->SelectObject(&font2);
            pDC->TextOut(int(fontsize * 7), bottomtext2, s);
			pDC->SelectObject(&font);
        }

		// -------------------------------------------------------------- READOUT - LOWER ROW - DELAY
        if (delaypos != 0 && analysisType < ANTYPE_SPECTR)
        {
            double delay = delaypos * 1000.0 / SAMPLES_PER_SEC;
			s = MillisecToString(delay, 4);
            pDC->TextOut(dispdx - int(fontsize * 16.5), bottomtext1, "Dly " + s);
			if (inputState && delay != 0) pDC->TextOut(dispdx - int(fontsize * 16.5), bottomtext1 - int(fontsize * 1.1), "WARNING - Delay with Input ON");
        }

		// -------------------------------------------------------------- READOUT - LOWER ROW - DELTA
        if (deltapos != 0 && selectCH >= 2)
        {
            double delta = scaleX * deltapos * 1000.0 / SAMPLES_PER_SEC;			
			s = MillisecToString(delta, 4);
            pDC->TextOut(dispdx - int(fontsize * 10), bottomtext1, "dT " + s);
        }

		// -------------------------------------------------------------- READOUT - LOWER ROW - TIMEBASE
        double sx = 1000 * scaleX / regX;
        if (sx != int(sx))
        {
            if (sx < 1000) s.Format("%3.1f uS", sx);
            else s.Format("%3.1f mS", sx / 1000);
            pDC->TextOut(dispdx - int(fontsize * 4), bottomtext1, s);
        }
        else
        {
            if (sx < 1000) s.Format("%3.0f uS", sx);
            else s.Format("%3.0f mS", sx / 1000);
            pDC->TextOut(dispdx - int(fontsize * 4), bottomtext1, s);
        }
        if (regX != 1) pDC->TextOut(dispdx - int(fontsize * 4), bottomtext2, "Uncal");
   
        

		// -------------------------------------------------------------- TRIGGER and STOP MARKERS 
		CPen penTrig(PS_SOLID, 3, osdColor);
		pDC->SelectObject(&penTrig);

        if (selectCH < 5)
        {
			// ---------------------------------------------------------- READOUT - TRIGGER MARKER  
			int trigx, trigy;
            trigx = int(ddx * trigpos);
        
			if (inputState && trigType > 0)
			{
				if (trigCH) trigy = int(py2 - tglev * ky2);
				else trigy = int(py1 - tglev * ky1);
			}
			else
			{
				if (trigCH) trigy = int(py2);
				else trigy = int(py1);
			}

			triggerPixelY = trigy; 

			int y1 = int(fontsize / 2);
			int y2 = int(fontsize / 5);
			int x1 = int(fontsize / 5);
			if (trigslope)
			{
				if (inputState && trigType > 0 && trigType < 5)
				{
					pDC->MoveTo(trigx, trigy - y1);
					pDC->LineTo(trigx, trigy + y1);
					pDC->LineTo(trigx + x1, trigy + y2);
					pDC->MoveTo(trigx, trigy + y1); 
					pDC->LineTo(trigx - x1, trigy + y2);
				}
				else
				{
					pDC->MoveTo(trigx, trigy - y1*2);
					pDC->LineTo(trigx, trigy + y1*2);
				}
			}
			else
			{
				if (inputState && trigType > 0 && trigType < 5)
				{
					pDC->MoveTo(trigx, trigy + y1);           
					pDC->LineTo(trigx, trigy - y1);
					pDC->LineTo(trigx + x1, trigy - y2);
					pDC->MoveTo(trigx, trigy - y1); 
					pDC->LineTo(trigx - x1, trigy - y2);
				}
				else
				{
					pDC->MoveTo(trigx, trigy + y1*2);           
					pDC->LineTo(trigx, trigy - y1*2);
				}
			}

			// ---------------------------------------------------------- READOUT - STOP LEVEL MARKER
			if (trigType == 5)
			{
				if (trigCH) 
				{
					StopLevelRawValue = (32768 * trigstop + calY2) * polarity2 * gain2;
					trigy = int(py2 - StopLevelRawValue * ky2);
				}
				else
				{
					StopLevelRawValue = (32768 * trigstop + calY1) * polarity1 * gain1;
					trigy = int(py1 - StopLevelRawValue * ky1);
				}
				pDC->MoveTo(trigx - fontsize, trigy);           
				pDC->LineTo(trigx + fontsize, trigy);

				s = MillivoltToString(StopLevelRawValue / 32.768, 4);
				pDC->TextOut(trigx + int(fontsize * 1.4), trigy - y1, "Stop level " + s);
			}
		}

	}

	// ============================================================================
    //   READOUT - SPECTRUM ANALYSIS AND SWEEP 
    // ============================================================================
    if ((osdIntensity > 110) && 
		(analysisType >= ANTYPE_SPECTR) && 
		!DisplaySamples && 
		!(multiDraw & (analysisType == ANTYPE_SWEEP)))
    {
		
		if (curs1)
		{
			// -------------------------------------------------------------------- READOUT - SPECTRUM CURSOR DATA
			CString s;
			double freq;

			// -------------------------------------------------------------------- READOUT - SPECTRUM Vpp and dB
			int p = int(dispx * curs1);
			int x = leftborder + p;

			double vv;
			do
			{
				vv = responseTab[p];
				if (vv >= 0) break;
				p++; 
			}while (p < dispx);

			mVppInst = Root2x2 * vv / 32.768;
			SmoothValue(mVpp, mVppInst, 5);

			s = MillivoltToString(mVpp, 3) + "pp";
			pDC->TextOut(leftborder + fontsize, toptext, s);
			if (FirstSlot > 0) WriteSlot(FirstSlot, mVpp / 1000);

			double db = mVppToDB(mVpp);
			if (mVpp > 0) s = DecibelToString(db);
			else s = "- oo dB";
			pDC->TextOut(leftborder + fontsize * 10, toptext, s);
			if (FirstSlot > 0) WriteSlot(FirstSlot + 1, db);

			// -------------------------------------------------------------------- READOUT - SPECTRUM Hz and mS
			if (xlogtype) freq = freqMin * exp(curs1 * log(freqMax / freqMin));
			else freq = freqMin + curs1 * (freqMax - freqMin);

			if (timetype)
			{               
				s.Format("%1.1f Hz", freq);
				pDC->TextOut(dispdx - int(fontsize * 5.5), toptext, s);
				if (FirstSlot > 0) WriteSlot(FirstSlot + 2, freq);
			}
			else
			{           
				s.Format("%1.3f mS", 1000 / freq);
				pDC->TextOut(dispdx - int(fontsize * 5.5), toptext, s);
				if (FirstSlot > 0) WriteSlot(FirstSlot + 2, 1 / freq);
			}

			// -------------------------------------------------------------------- READOUT - SPECTRUM VERTICAL CURSOR
			pDC->MoveTo(x, 14);           
			pDC->LineTo(x, dispy - 2);
		}
		
		// ------------------------------------------------------------------------ READOUT - SPECTRUM CURSOR DATA
		CString s = "";
		if (trigCH == 0)
		{
			if (Filter_CH1 == 1) s += "CH1 filtered - LP " + HertzToString(filterCH1.GetFrequency(), 3);
			else if (Filter_CH1 == 2) s += "CH1 filtered - HP " + HertzToString(filterCH1.GetFrequency(), 3);
			else s = "CH1";
		}
		else
		{
			if (Filter_CH2 == 1) s += "CH2 filtered - LP " + HertzToString(filterCH2.GetFrequency(), 3);
			else if (Filter_CH2 == 2) s += "CH2 filtered - HP " + HertzToString(filterCH2.GetFrequency(), 3);
			else s = "CH2";
		}

		pDC->SelectObject(&font2);
		pDC->TextOut(int(fontsize * 2.3), bottomtext2 + int(fontsize * 0.15), s);
		pDC->SelectObject(&font);
	}


	// ------------------------------------------------------------------------ READOUT - SAMPLE AREA INDICATOR 
	if (DisplaySamples && (analysisType >= ANTYPE_SPECTR))
	{
		if (analysisType == ANTYPE_SPECTR) pDC->TextOut(fontsize / 2, fontsize * 2, "Spectrum samples");
		if (analysisType == ANTYPE_SWEEP)  pDC->TextOut(fontsize / 2, fontsize * 2, "Sweep samples");
		if (analysisType == ANTYPE_FASTSW) pDC->TextOut(fontsize / 2, fontsize * 2, "FastSweep samples");
		if (analysisType == ANTYPE_PULSE)  pDC->TextOut(fontsize / 2, fontsize * 2, "Pulse samples");

		int trigx = int(ddx * trigpos);
		int w = 0; 
		if (analysisType == ANTYPE_SPECTR) w = int(fht_samples * 1000 / SAMPLES_PER_SEC * dispdx / 10 * regX / scaleX);
		if (analysisType == ANTYPE_FASTSW) w = int(fht_samples * 1000 / SAMPLES_PER_SEC * dispdx / 10 * regX / scaleX);
		if (analysisType == ANTYPE_PULSE) w = int(sampling_ms * dispdx / 10 * regX / scaleX);

		if (analysisType != ANTYPE_SWEEP) 
		{
			int y = int(dispdy * 5 / 8);
			pDC->MoveTo(trigx, y);           
			pDC->LineTo(trigx + w, y);
			pDC->MoveTo(trigx, y-5);           
			pDC->LineTo(trigx, y+6);
			pDC->MoveTo(trigx+w, y-5);           
			pDC->LineTo(trigx+w, y+6);
		}
	}

	pDC->SelectObject(pOldFont);
    pDC->SelectObject(pOldPen);   
}


// ================================================================================================
// ================================================================================================
//   DAA - INIT DEFAULTS
// ================================================================================================
// ================================================================================================ 
void DAA_InitDefaultValues()
{		   
    freq = 100;
    freqMin = 10;
    freqMax = 22000;
    sweepTime = 5;
    start_sampling_ms = 0;
    sampling_ms = out_pulse_millisec;

    duty = 50;
    burstCycles = 10;
    pauseCycles = 10;
    dbmin = -50;
    dbmax = 0;
    outlevel = 0;
	deltalevel1 = 0;
	deltalevel2 = 0;
    
    scaleX = 2;  
    scaleY1 = 1000;
    scaleY2 = 1000;
    regX = 1;
    regY1 = 1;
    regY2 = 1;
    posY1 = -0.5;
    posY2 = 0;

    selectCH = 2;
	ac1 = FALSE;
	ac2 = FALSE;
	neg1 = FALSE;
	neg2 = FALSE;
	mul1 = 1;
	mul2 = 1;

    trigCH = 0;

    inputState = 0;
    outputState = 0;

    wavetype = WAVETYPE_SINE;
    analysisType = ANTYPE_WAVE;
    regulationType = 0;
    
    gridLight = 150;
    osdIntensity = 180;
    traceIntensity = 255;

    trigType = 2;
    trigvoid = 0;
    trigpos = .1;
    triglev = 0;
    trigist = 0.19;
    trigstab = 0;
    trigslope = FALSE;
    trigburst = FALSE;

    curs1 = 0;
    curs2 = 0;
    responsespeed = .5;
    curstype = 2;
    timetype = 1;
    volttype = 0;
    xlogtype = 1;
    ylogtype = 1;

    delaypos = 0;
    deltapos = 0;
    clickedDialerID = 0;   
    numCH = 2;

    bandwidth = 0;
	fhtwindow = 12;

	Filter_CH1 = 0;
	Filter_CH2 = 0;
	Filters_Npoles = 2;

    DisplaySamples = FALSE;
    multiDraw = FALSE;
    spectrum3D = FALSE;

    // --------------------------------------------- init tables
    DAA_SetBandwidth(bandwidth);
	DAA_SetFhtWindow(fhtwindow);
    DAA_FillWaveTable(wavetype);
    InitTime();
}

// ================================================================================================
// ================================================================================================
//   DAA - END
// ================================================================================================
// ================================================================================================ 
void DAA_End()
{
	if (RememberAllProps) DAA_WriteAllProps();
    DAA_WriteMainProps();
    DAA_InputOff();
	InitTime();
	while (GetTime() < 200000);
    DAA_OutputOff();
}

// ================================================================================================
// ================================================================================================
//   DAA - INIT OBJECTS
// ================================================================================================
// ================================================================================================ 
void DAA_InitObjects()
{
    /* 
    LPLOGPALETTE lpLogPal;
	lpLogPal = (LPLOGPALETTE) new BYTE[sizeof(LOGPALETTE) + ((32) * sizeof(PALETTEENTRY))];
	lpLogPal->palVersion = 0x0300;
	lpLogPal->palNumEntries = 32;  
    int i = 0;
    lpLogPal->palPalEntry[i].peRed = GetRValue(pressed);
    lpLogPal->palPalEntry[i].peGreen = GetGValue(pressed);
    lpLogPal->palPalEntry[i].peBlue = GetBValue(pressed);
    lpLogPal->palPalEntry[i].peFlags = NULL;
    i++;
    lpLogPal->palPalEntry[i].peRed = GetRValue(dback);
    lpLogPal->palPalEntry[i].peGreen = GetGValue(dback);
    lpLogPal->palPalEntry[i].peBlue = GetBValue(dback);
    lpLogPal->palPalEntry[i].peFlags = NULL;

    palette.CreatePalette(lpLogPal);
    delete lpLogPal;
    */

     
    // -------------------------------------------------------------- MAIN FRAME
    daaFrame.Init(2, 2, CLIENT_X - 4, CLIENT_Y - 39, 16, black, grey6);


    // -------------------------------------------------------------- LEFT PANEL
    int panelX = 10;
    int panelY = 8;

    frame1.Init(panelX, panelY, 60, CLIENT_Y - 223, 16, grey3, panels);

    dialer1.Init(panelX + 29, panelY + 40, 19, 12, 4);
    dialer1.InitRange(0, 230, 1, 1, 1, &gridLight);
    dialer1.InitScale(40, 320, 2);
    dialer1.InitTitle(-16, -34, 0, 14, 0, "Arial", grey1, grey1, true, "SCALE");
	dialer1.InitScaleText(-7, 9, -1, 0, 11, 0, "Arial", grey1, grey1, true, "MIN,MAX");
	dialer1.allowMicrometricMouse = TRUE;

    dialer2.Init(panelX + 29, panelY + 118, 19, 12, 4);
    dialer2.InitRange(100, 200, 1, 1, 1, &osdIntensity);
    dialer2.InitScale(40, 320, 2);
    dialer2.InitTitle(-23, -34, 0, 14, 0, "Arial", grey1, grey1, true, "READOUT");
	dialer2.InitScaleText(-7, 9, -1, 0, 11, 0, "Arial", grey1, grey1, true, "OFF,MAX");
	dialer2.allowMicrometricMouse = TRUE;

    dialer3.Init(panelX + 29, panelY + 196, 19, 12, 4);
    dialer3.InitRange(0, 255, 1, 1, 1, &traceIntensity);
    dialer3.InitScale(40, 320, 2);
    dialer3.InitTitle(-16, -34, 0, 14, 0, "Arial", grey1, grey1, true, "TRACE");
	dialer3.InitScaleText(-7, 9, -1, 0, 11, 0, "Arial", grey1, grey1, true, "MIN,MAX");
	dialer3.allowMicrometricMouse = TRUE;

    keysamp.Init(panelX + 32, panelY + 255, 16, 14, 1, 0);
    keysamp.InitText("SAMPLES", -18, -13, 0, 11, 0, grey2, grey2, false, "Arial");
    keysamp.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, white, black);

	keycalspectrum.Init(panelX + 32, panelY + 289, 16 , 14, 1, 0);
    keycalspectrum.InitText("CALIB.SPEC.", -25, -13, 0, 11, 0, grey2, grey2, false, "Arial");
    keycalspectrum.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, white, black);

	ledcal.Init(panelX + 10, panelY + 312, 13, 13, 2);
    ledcal.InitColors(grey5, RGB(255, 60, 60), RGB(60, 255, 60), RGB(60,60,60), RGB(220,220,140));
    ledcal.InitReflex(6,5,1,1);
	ledcal.InitText("CALIBRATE", -2, 21, 0, 11, 0, grey2, grey2, false, "Arial");

    keycal.Init(panelX + 32, panelY + 345, 16, 14, 1, 0);
    keycal.InitText("ZERO", -24, 4, 0, 11, 0, grey2, grey2, false, "Arial");
    keycal.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, white, black);

	keycalVolt.Init(panelX + 32, panelY + 362, 16, 14, 1, 0);
    keycalVolt.InitText("VOLT", -24, 4, 0, 11, 0, grey2, grey2, false, "Arial");
    keycalVolt.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, white, black);


    // -------------------------------------------------------------- ON-OFF PANEL
    panelX = 10;
    panelY = CLIENT_Y - 209;

    kbInOnOff.Init(panelX, panelY, 37, 20, 2, 2, TRUE, 1);
    kbInOnOff.InitFrame(10, 26, 9, 90, 16);
    kbInOnOff.InitColors(grey3, panels);
    kbInOnOff.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbInOnOff.InitKeyFont("Arial", true, 0, 12, 0, grey0, grey0);
	kbInOnOff.keyPressed = inputState;
    kbInOnOff.AddKey("OFF", 10, 6);
    kbInOnOff.AddKey("ON", 12, 6);
    kbInOnOff.InitTitle(7, -17, 0, 14, 0, "Arial", grey1, grey1, true, "INPUT");
   
    kbOutOnOff.Init(panelX, panelY, 37, 20, 2, 2, TRUE, 1);
    kbOutOnOff.InitFrame(10, 105, 0, 0, 0);
    kbOutOnOff.InitColors( grey3, panels);
    kbOutOnOff.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbOutOnOff.InitKeyFont("Arial", true, 0, 12, 0, grey0, grey0);
	kbOutOnOff.keyPressed = outputState;
    kbOutOnOff.AddKey("OFF", 10, 6);
    kbOutOnOff.AddKey("ON", 12, 6);
    kbOutOnOff.InitTitle(1, -17, 0, 14, 0, "Arial", grey1, grey1, true, "OUTPUT");

    // -------------------------------------------------------------- CHANNEL 1 & 2 PANEL
    panelX = 75;
    panelY = CLIENT_Y - 209;

    frame2.Init(panelX, panelY, 368, 166, 16, grey3, panels);
    frame2.InitTitle(10, 80, 0, 16, 0, "Arial", grey3, grey3, true,
    "CH1                                                                          CH2");

    dialer4.Init(panelX + 116, panelY + 97, 40, 33, 4);
    dialer4.InitRange(1, 100000, 1, 1, 1, &scaleY1);
	dialer4.InitScale(40, 320, 16);
	dialer4.InitScaleText(-10, -4, 10, 0, 11, 0, "Tahoma", grey1, grey1, true,
                          "100,50V,20V,10V,  5V,  2V,  1V,  0.5,  0.2,  0.1,  50m,  20m,  10m,  5m,  2m,  1m");
    dialer4.InitScaleValues("100000,50000,20000,10000,5000,2000,1000,500,200,100,50,20,10,5,2,1");
    dialer4.InitTitle(-16, 48, 0, 16, 0, "Arial", grey1, grey1, true, "V / Div");  
    dialer4.InitDual(26, 17, 5);
    dialer4.InitRangeDual(1, 2, 1, .001, .001, &regY1);
    dialer4.InitScaleDual(30, 325, 1);

    dialer5.Init(panelX + 249, panelY + 97, 40, 33, 4);
    dialer5.InitRange(1, 100000, 1, 1, 1, &scaleY2);
	dialer5.InitScale(40, 320, 16);
	dialer5.InitScaleText(-10, -4, 10, 0, 11, 0, "Tahoma", grey1, grey1, true,
                          "100,50V,20V,10V,  5V,  2V,  1V,  0.5,  0.2,  0.1,  50m,  20m,  10m,  5m,  2m,  1m");
    dialer5.InitScaleValues("100000,50000,20000,10000,5000,2000,1000,500,200,100,50,20,10,5,2,1");
    dialer5.InitTitle(-16, 48, 0, 16, 0, "Arial", grey1, grey1, true, "V / Div");
    dialer5.InitDual(26, 17, 5);
    dialer5.InitRangeDual(1, 2, 1, .001, .001, &regY2);
    dialer5.InitScaleDual(30, 325, 1);

    dialer6.Init(panelX + 36, panelY + 29, 21, 14, 4);
    dialer6.InitRange(-2, 2, 1.4, .0002, .001, &posY1);
    dialer6.InitTitle(-20, 26, 0, 14, 0, "Tahoma", grey3, grey3, true, "Ypos");
	dialer6.SetMouseWheelParams(0.125, FALSE);
    
    dialer7.Init(panelX + 328, panelY + 29, 21, 14, 4);
    dialer7.InitRange(-2, 2, 1.4, .0002, .001, &posY2);
    dialer7.InitTitle(-4, 26, 0, 14, 0, "Tahoma", grey3, grey3, true, "Ypos");
	dialer7.SetMouseWheelParams(0.125, FALSE);
    
    kbChan.Init(panelX + 93, panelY + 19, 26, 14, 2, 1, FALSE, 1);
    kbChan.InitFrame(0, 0, 0, 0, 0);
    kbChan.InitColors(grey3, panels);
    kbChan.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbChan.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbChan.keyPressed = selectCH;
    kbChan.AddKey("CH1", 5, -14);
    kbChan.AddKey("CH2", 5, -14);
    kbChan.AddKey("1+2", 7, -14);
    kbChan.AddKey("ADD", 5, -14);
    kbChan.AddKey("SUB", 6, -14);
    kbChan.AddKey("X-Y", 8, -14);

	keyAc1.pressed = ac1;
	keyAc1.Init(panelX + 10, panelY + 108, 25, 14, 1, 0);
    keyAc1.InitText("AC", 6, 2, 0, 11, 0, grey0, grey0, true, "Tahoma");
    keyAc1.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

	keyNeg1.pressed = neg1;
	keyNeg1.Init(panelX + 10, panelY + 125, 25, 14, 1, 0);
    keyNeg1.InitText("Neg", 5, 2, 0, 11, 0, grey0, grey0, true, "Tahoma");
    keyNeg1.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

	keyMul1.pressed = (mul1 != 1);
	keyMul1.Init(panelX + 10, panelY + 142, 25, 14, 1, 0);
    keyMul1.InitText("x100", 4, 3, 0, 11, 0, grey0, grey0, true, "Tahoma");
    keyMul1.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

	keyAc2.pressed = ac2;
	keyAc2.Init(panelX + 330, panelY + 108, 25, 14, 1, 0);
    keyAc2.InitText("AC", 6, 2, 0, 11, 0, grey0, grey0, true, "Tahoma");
    keyAc2.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

	keyNeg2.pressed = neg2;
	keyNeg2.Init(panelX + 330, panelY + 125, 25, 14, 1, 0);
    keyNeg2.InitText("Neg", 5, 2, 0, 11, 0, grey0, grey0, true, "Tahoma");
    keyNeg2.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

	keyMul2.pressed = (mul2 != 1);
	keyMul2.Init(panelX + 330, panelY + 142, 25, 14, 1, 0);
    keyMul2.InitText("x100", 4, 3, 0, 11, 0, grey0, grey0, true, "Tahoma");
    keyMul2.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

    // -------------------------------------------------------------- TRIGGER PANEL 
    panelX = CLIENT_X - 306;
    panelY = 8;

    DAA_SetTrigType(trigType);
    dialerTrig.Init(panelX + 100, panelY + 114, 25, 16, 5);
	dialerTrig.allowMicrometricMouse = TRUE;
   
    kbTrig.Init(panelX, panelY, 17, 16, 1, 1, TRUE, 1);
    kbTrig.InitFrame(42, 29, 76, 10, 16);
    kbTrig.InitColors(grey3, panels);
    kbTrig.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbTrig.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbTrig.keyPressed = trigType;
    kbTrig.AddKey("OFF",   -33, 5);
    kbTrig.AddKey("X POS", -33, 5);
    kbTrig.AddKey("LEVEL", -33, 5);
    kbTrig.AddKey("NOISE", -33, 5);
    kbTrig.AddKey("STAB", -33, 5);
	kbTrig.AddKey("STOP", -33, 5);
    kbTrig.frame.InitTitle(32, 6, 0, 15, 0, "Arial", grey1, grey1, true, "TRIGGER");
  
    ledtrig.Init(panelX + 10, panelY + 9, 15, 11, 1);
    ledtrig.InitColors(grey5, RGB(60, 255, 60), 0, RGB(60,60,60), RGB(240,240,160));
    ledtrig.InitReflex(5,4,1,1);
    ledtrig.square = TRUE;

    kbChtrig.Init(panelX + 75, panelY + 26, 25, 14, 1, -1, FALSE, 1);
    kbChtrig.InitFrame(0, 0, 0, 0, 0);
    kbChtrig.InitColors(grey3, panels);
    kbChtrig.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbChtrig.InitKeyFont("Tahoma", true, 0, 12, 0, grey0, grey0);
    kbChtrig.keyPressed = trigCH;
    kbChtrig.AddKey("CH1", 3, 2);
    kbChtrig.AddKey("CH2", 3, 2);
    
    keyTrigSlope.pressed = trigslope;
    keyTrigSlope.Init(panelX + 110, panelY + 48, 16, 14, 1, 0);
    keyTrigSlope.InitText("SLOPE", -36, 3, 0, 12, 0, grey0, grey0, false, "Tahoma");
    keyTrigSlope.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

    keyTrigBurst.pressed = trigburst;
    keyTrigBurst.Init(panelX + 110, panelY + 65, 16, 14, 1, 0);
    keyTrigBurst.InitText("BURST", -36, 3, 0, 12, 0, grey0, grey0, false, "Tahoma");
    keyTrigBurst.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);

    // -------------------------------------------------------------- ANALYSIS PANEL
    kbAtype.Init(kbTrig.frame.x + kbTrig.frame.w + 5, 8, 17, 16, 1, 1, TRUE, 1);
    kbAtype.InitFrame(45, 29, 8, 10, 16);
    kbAtype.frame.InitTitle(8, 6, 0, 15, 0, "Arial", grey1, grey1, true, "ANALYSIS");
    kbAtype.InitColors(grey3, grey6);
    kbAtype.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbAtype.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbAtype.keyPressed = analysisType;
    kbAtype.AddKey("WAVE",  -38, 5);
    kbAtype.AddKey("BURST", -38, 5);
    kbAtype.AddKey("Spectr.", -38, 5);
    kbAtype.AddKey("Sweep", -38, 5);
    kbAtype.AddKey("FastSw.", -38, 5);
    kbAtype.AddKey("Pulse", -38, 5);
    
    // -------------------------------------------------------------- WAVE PANEL
    kbWtype.Init(kbAtype.frame.x + kbAtype.frame.w + 5, 8, 17, 16, 1, 1, TRUE, 1);
    kbWtype.InitFrame(51, 29, 8, 10, 16);
    kbWtype.frame.InitTitle(6, 6, 0, 15, 0, "Arial", grey1, grey1, true, "WAVEFORM");
    kbWtype.InitColors(grey3, wavepanel);
    kbWtype.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbWtype.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbWtype.keyPressed = wavetype;
    kbWtype.AddKey("SINE",   -43, 5);
    kbWtype.AddKey("TRIANG", -43, 5);
    kbWtype.AddKey("RAMP +", -43, 5);
    kbWtype.AddKey("RAMP -", -43, 5);
    kbWtype.AddKey("SQUARE", -43, 5);
    kbWtype.AddKey("NOISE", -43, 5);
    
    // -------------------------------------------------------------- REGULATIONS PANEL
    panelX = kbTrig.frame.x;
    panelY = kbTrig.frame.y + kbTrig.frame.h + 5;
    
    DAA_SetRegulationType(NULL, regulationType);
	indicator.Init(panelX + 162, panelY + 38);
    dialer.Init(panelX + 214, panelY + 140, 64, 48, 9);
   
    kbRtype.Init(panelX, panelY, 46, 20, 2, 2, TRUE, 1);
    kbRtype.InitFrame(18, 34, 229, 10+6, 16);
    kbRtype.InitColors(grey3, panels);
    kbRtype.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbRtype.InitKeyFont("Tahoma", true, 0, 12, 0, grey0, grey0);
	kbRtype.keyPressed = regulationType;
    kbRtype.AddKey("FREQ", 6, 6);
    kbRtype.AddKey("FMAX", 6, 6);
    kbRtype.AddKey("FMIN", 6, 6);
    kbRtype.AddKey("DBMAX", 6, 6);
    kbRtype.AddKey("DBMIN", 6, 6);
	kbRtype.AddKey("SLOT", 6, 6);
	kbRtype.AddKey("CALIB", 6, 6);

    kbRtype2.Init(panelX + 64, panelY, 46, 20, 2, 2, TRUE, 1);
    kbRtype2.InitFrame(16, 34, 0, 0, 0);
    kbRtype2.InitColors(grey6, grey6);
    kbRtype2.InitKeyColors(grey4, grey4, col_lighted_border, grey6, grey5, col_pressed, grey3, grey7, grey8, black);
    kbRtype2.InitKeyFont("Tahoma", true, 0, 12, 0, grey0, grey0);
	kbRtype2.keyPressed = regulationType - REGTYPE_KB2_FIRST;
    kbRtype2.AddKey("DUTY",  6, 6);
    kbRtype2.AddKey("BURST", 6, 6);
    kbRtype2.AddKey("PAUSE", 6, 6);
    kbRtype2.AddKey("BEGIN", 6, 6);
    kbRtype2.AddKey("END", 6, 6);
	kbRtype2.AddKey("TIME", 6, 6);
    kbRtype2.AddKey("OUTLEV", 6, 6);

	keycalOut.Init(panelX + 134, panelY + 197, 16, 14, 1, 0);
    keycalOut.InitText("CAL.", 1, -11, 0, 11, 0, grey2, grey2, false, "Arial");
    keycalOut.InitColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, white, black);
	
    kbRtype.frame.InitTitle(20, 6, 0, 15, 0, "Arial", grey1, grey1, true, "SETTINGS");
    
	// -------------------------------------------------------------- SET LIGHTED KEYS
	DAA_SetLightedKeys(NULL);

    // -------------------------------------------------------------- TIME BASE PANEL
    panelX = frame2.x + frame2.w + 5;
    panelY = CLIENT_Y - 209;

    frame3.Init(panelX , panelY, 200, 166, 16, grey3, panels);
    frame3.InitTitle(12, 8, 0, 15, 0, "Arial", grey1, grey1, true, "TIME BASE");

    dialer8.Init(panelX + 73, panelY + 97, 40, 33, 4);
    dialer8.InitRange(.1, 1000, 1, 1, 1, &scaleX);
    dialer8.InitScale(40, 320, 13);
    dialer8.InitScaleText(-12, -4, 10, 0, 11, 0, "Tahoma", grey1, grey1, true,
                          " 1S, 500, 200, 100,  50,  20,  10,   5,    2,    1,   .5,   .2,   .1");
    dialer8.InitScaleValues("1000,500,200,100,50,20,10,5,2,1,.5,.2,.1");
    dialer8.InitTitle(-20, 48, 0, 16, 0, "Arial", grey1, grey1, true, "mS / Div");
    dialer8.InitDual(26, 17, 5);
    dialer8.InitRangeDual(1, 2, 1, .001, .001, &regX);
    dialer8.InitScaleDual(30, 325, 1);

    dialer9.Init(panelX + 162, panelY + 30, 22, 14, 4);
    dialer9.InitRange(-IN_CBUF_LEN / 2, IN_CBUF_LEN / 2, 2.5, .005, 1, &delaypos); 
    dialer9.InitTitle(-18, 28, 0, 16, 0, "Arial", grey3, grey3, false, "Delay");
	dialer9.SetNotZeroWarning();
	dialer9.SetMouseWheelParams(20000, TRUE);
	dialer9.allowMicrometricMouse = TRUE;

    dialer10.Init(panelX + 162, panelY + 117, 22, 14, 4);
    dialer10.InitRange(0, 6000, 2.5, .01, 1, &deltapos); 
    dialer10.InitTitle(-30, 28, 0, 16, 0, "Arial", grey3, grey3, false, "Delta time");
	dialer10.SetNotZeroWarning();
	dialer10.SetMouseWheelParams(20000, TRUE);
	dialer10.allowMicrometricMouse = TRUE;


    // -------------------------------------------------------------- METER PANEL
    panelX = frame3.x + frame3.w + 5;
    panelY = CLIENT_Y - 209;

    frame4.Init(panelX , panelY, 133, 166, 16, grey3, panels);
    frame4.InitTitle(12, 6, 0, 15, 0, "Arial", grey1, grey1, true, "METER");
   
    kbCurs.Init(panelX + 42, panelY + 26, 16, 14, 1, -1, TRUE, 1);
    kbCurs.InitFrame(0, 0, 0, 0, 0);
    kbCurs.InitColors(grey3, panels);
    kbCurs.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbCurs.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbCurs.keyPressed = curstype;
    kbCurs.AddKey("OFF",  -30, 3);
    kbCurs.AddKey("CH 2", -30, 3);
    kbCurs.AddKey("CH 1", -30, 3);
    kbCurs.AddKey("CURS", -30, 3);

    kbTime.Init(panelX + 106, panelY + 26, 14, 13, 1, -1, TRUE, 1);
    kbTime.InitFrame(0, 0, 0, 0, 0);
    kbTime.InitColors(grey3, panels);
    kbTime.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbTime.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbTime.keyPressed = timetype;
    kbTime.AddKey("TIME", -27, 2);
    kbTime.AddKey("FREQ", -30, 2);
    
    kbVolt.Init(panelX + 106, panelY + 58, 14, 13, 1, -1, TRUE, 1);
    kbVolt.InitFrame(0, 0, 0, 0, 0);
    kbVolt.InitColors(grey3, panels);
    kbVolt.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbVolt.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbVolt.keyPressed = volttype;
    kbVolt.AddKey("VOLT", -28, 2);
    kbVolt.AddKey("Rms/dB", -37, 2);
   
    dialer11.Init(panelX + 36, panelY + 118, 22, 14, 4);
    dialer11.InitRange(0, 1, 2, .00001, .0001, &curs1);
    dialer11.InitTitle(-24, 28, 0, 16, 0, "Arial", grey3, grey3, true, "Cursor 1");
	dialer11.SetMouseWheelParams(0.01, FALSE);
	dialer11.allowMicrometricMouse = TRUE;

    dialer12.Init(panelX + 97, panelY + 118, 22, 14, 4);
    dialer12.InitRange(0, 1, 2, .00001, .0001, &curs2);
    dialer12.InitTitle(-24, 28, 0, 16, 0, "Arial", grey3, grey3, true, "Cursor 2");
	dialer12.SetMouseWheelParams(0.01, FALSE);
	dialer1.allowMicrometricMouse = TRUE;

    // -------------------------------------------------------------- SPECTRUM PANEL
    panelX = frame4.x + frame4.w + 5;
    panelY = CLIENT_Y - 209;
                                                          
    frame5.Init(panelX , panelY, 73, 166, 16, grey3, grey6);
    frame5.InitTitle(8, 6, 0, 14, 0, "Arial", grey1, grey1, true, "SPECTRUM");
  
    kbXlog.Init(panelX + 47, panelY + 26, 14, 13, 1, -1, TRUE, 1);
    kbXlog.InitFrame(0, 0, 0, 0, 0);
    kbXlog.InitColors(grey3, panels);
    kbXlog.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbXlog.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbXlog.keyPressed = xlogtype;
    kbXlog.AddKey("X LIN", -34, 2);
    kbXlog.AddKey("X LOG", -34, 2);
    
    kbYlog.Init(panelX + 47, panelY + 58, 14, 13, 1, -1, TRUE, 1);
    kbYlog.InitFrame(0, 0, 0, 0, 0);
    kbYlog.InitColors(grey3, panels);
    kbYlog.InitKeyColors(grey4, grey4, grey4, grey7, grey7, grey7, grey3, grey7, grey8, black);
	kbYlog.InitKeyFont("Tahoma", false, 0, 12, 0, grey0, grey0);
    kbYlog.keyPressed = ylogtype;
    kbYlog.AddKey("Y LIN", -34, 2);
    kbYlog.AddKey("Y LOG", -34, 2);
    
    dialer13.Init(panelX + 37, panelY + 118, 22, 14, 4);
    dialer13.InitRange(.005, 1, 1, 1, .0001, &responsespeed);
    dialer13.InitTitle(-18, 28, 0, 16, 0, "Arial", grey3, grey3,true, "Speed");
    dialer13.InitScale(30, 330, 2);
	dialer13.allowMicrometricMouse = TRUE;

	// -------------------------------------------------------------- STATUS-BAR                                         
    frame6.Init(-4, CLIENT_Y - 34, 
		        CLIENT_X + 8, 19, 16, RGB(255,255,230), RGB(236,233,216));
	frame6.InitTitle(10, 2, 0, 16, 100, "Tahoma", grey1, grey1, true, READY_MESSAGE);
}

// ================================================================================================
// ================================================================================================
//   DAA - DELETE OBJECTS
// ================================================================================================
// ================================================================================================ 
void DAA_DeleteObjects()
{
	kbWtype.DeleteAllKeys();
	kbAtype.DeleteAllKeys();
	kbRtype.DeleteAllKeys();
	kbRtype2.DeleteAllKeys();
	kbTrig.DeleteAllKeys();
	kbChan.DeleteAllKeys();
	kbChtrig.DeleteAllKeys();
	kbCurs.DeleteAllKeys();
	kbInOnOff.DeleteAllKeys();
	kbOutOnOff.DeleteAllKeys();
	kbTime.DeleteAllKeys();
	kbVolt.DeleteAllKeys();
	kbXlog.DeleteAllKeys();
	kbYlog.DeleteAllKeys();
}


// ================================================================================================
// ================================================================================================
//   DAA - CREATE INSTRUMENT
// ================================================================================================
// ================================================================================================ 
void DAA_CreateInstrument(CDC* pDC)
{
	// ------------------------------------------------------------ init objects
	display.InitPositionAndSize();
	DAA_DeleteObjects();
    // ------------------------------------------------------------ colors
    black = 0;
    panels = RGB(195,195,195);
    wavepanel = RGB(170,190,110);
    col_pressed = RGB(255,180,100);
	col_lighted_border = RGB(250,170,150);
	grey0 = RGB(20,20,20);
	grey1 = RGB(40,40,40);
	grey2 = RGB(60,60,60);
    grey3 = RGB(80,80,80);
    grey4 = RGB(110,110,100); 
    grey5 = RGB(140,140,140);  
    grey6 = RGB(180,180,180); 
    grey7 = RGB(200,200,200); 
    grey8 = RGB(230,230,230);
	grey9 = RGB(240,240,240);
    white = RGB(255,255,255);
    dback = RGB(30,90,120);
    trace = RGB(240,255,230);
    dgrid = RGB(20,60,90);

    if (pDC->GetDeviceCaps(BITSPIXEL) <= 8)
    {
        ClipCursor(NULL);
        theApp.m_pMainWnd->MessageBox("DAA can run in this video mode but HiColor is better",
                                    "Warning from DAA", MB_SYSTEMMODAL);

        panels = pDC->GetNearestColor(panels);
        wavepanel = panels;
        col_pressed = pDC->GetNearestColor(col_pressed);
		grey0 = pDC->GetNearestColor(grey0);
        grey1 = pDC->GetNearestColor(grey1);
        grey2 = pDC->GetNearestColor(grey2);
        grey3 = pDC->GetNearestColor(grey3);
        grey4 = pDC->GetNearestColor(grey4);
        grey5 = pDC->GetNearestColor(grey5);
		grey6 = pDC->GetNearestColor(grey6);
		grey7 = pDC->GetNearestColor(grey7);
        grey8 = pDC->GetNearestColor(grey8);
		grey9 = pDC->GetNearestColor(grey9);
        //white = pDC->GetNearestColor(white);
        //dback = pDC->GetNearestColor(dback);
    }

	// ------------------------------------------------------------ init all the controls
    DAA_InitObjects();

    // ------------------------------------------------------------ delete memory bitmap and DC
	MemBmp.DeleteObject();
	MemDC.DeleteDC();
	// ------------------------------------------------------------ create memory bitmap and DC
    MemBmp.CreateCompatibleBitmap(pDC, CLIENT_X, CLIENT_Y);
    MemDC.CreateCompatibleDC(pDC);
    MemDC.SelectObject(MemBmp);

	// ------------------------------------------------------------ background ( border ) color
	MemDC.FillSolidRect(0, 0, CLIENT_X, CLIENT_Y, RGB(160,160,160));

    // ------------------------------------------------------------ draw all to memory dc
    daaFrame.Draw(&MemDC);

    frame1.Draw(&MemDC);
    dialer1.Draw(&MemDC);
    dialer2.Draw(&MemDC);
    dialer3.Draw(&MemDC);
	keysamp.Draw(&MemDC);
	keycalspectrum.Draw(&MemDC);
    keycal.Draw(&MemDC); 
	keycalVolt.Draw(&MemDC); 
    ledcal.Draw(&MemDC);

    kbInOnOff.Draw(&MemDC);
    kbOutOnOff.Draw(&MemDC);

    display.Draw(&MemDC);

    frame2.Draw(&MemDC);
    kbChan.Draw(&MemDC);
	keyAc1.Draw(&MemDC);
	keyAc2.Draw(&MemDC);
	keyNeg1.Draw(&MemDC);
	keyNeg2.Draw(&MemDC);
	keyMul1.Draw(&MemDC);
	keyMul2.Draw(&MemDC);
    dialer4.Draw(&MemDC);
    dialer5.Draw(&MemDC);
    dialer6.Draw(&MemDC);
    dialer7.Draw(&MemDC);

    kbTrig.Draw(&MemDC);
    keyTrigSlope.Draw(&MemDC);
    keyTrigBurst.Draw(&MemDC);
    ledtrig.Draw(&MemDC);
    dialerTrig.Draw(&MemDC);
    kbChtrig.Draw(&MemDC);

    kbWtype.Draw(&MemDC);
    kbAtype.Draw(&MemDC);

    kbRtype.Draw(&MemDC);
    kbRtype2.Draw(&MemDC);
	keycalOut.Draw(&MemDC);
    dialer.Draw(&MemDC);
    DAA_DrawIndicator(&MemDC, regulationType);

    frame3.Draw(&MemDC);
    dialer8.Draw(&MemDC);
    dialer9.Draw(&MemDC);
    dialer10.Draw(&MemDC);

    frame4.Draw(&MemDC);
    kbCurs.Draw(&MemDC);
    kbTime.Draw(&MemDC);
    kbVolt.Draw(&MemDC);
    dialer11.Draw(&MemDC);
    dialer12.Draw(&MemDC);

    frame5.Draw(&MemDC);
    kbXlog.Draw(&MemDC);
    kbYlog.Draw(&MemDC);
    dialer13.Draw(&MemDC);

	frame6.Draw(&MemDC);
}

// ================================================================================================
// ================================================================================================
//   DAA - RESTORE PROPS FROM LAST RUN
// ================================================================================================
// ================================================================================================ 
void DAA_RestorePropsFromLastRun()
{
	if (RememberAllProps) DAA_ReadAllProps();
}

// ================================================================================================
// ================================================================================================
//   DAA - DRAW
// ================================================================================================
// ================================================================================================ 
void DAA_Draw(CDC* pDC)
{   
    //CPalette* pPaletteOld = pDC->SelectPalette( &palette, TRUE );
	//pDC->RealizePalette();

    kbInOnOff.Update(&MemDC);
    kbOutOnOff.Update(&MemDC);
    kbChan.Update(&MemDC);
	keyAc1.Draw(&MemDC);
	keyAc2.Draw(&MemDC);
	keyNeg1.Draw(&MemDC);
	keyNeg2.Draw(&MemDC);
	keyMul1.Draw(&MemDC);
	keyMul2.Draw(&MemDC);
    kbChtrig.Update(&MemDC);
    kbTrig.Update(&MemDC);
    kbAtype.Update(&MemDC);
    kbWtype.Update(&MemDC);
    kbCurs.Update(&MemDC);
    kbTime.Update(&MemDC);
    kbVolt.Update(&MemDC);
    kbXlog.Update(&MemDC);
    kbYlog.Update(&MemDC);
    kbRtype.Update(&MemDC);
    kbRtype2.Update(&MemDC);
	keyTrigSlope.Draw(&MemDC);
	keyTrigBurst.Draw(&MemDC);
	keysamp.Draw(&MemDC);
	keycalspectrum.Draw(&MemDC);
	keycal.Draw(&MemDC);
	keycalVolt.Draw(&MemDC);
	keycalOut.Draw(&MemDC);
    DAA_DrawUpdatedDialers(&MemDC);
    DAA_DrawIndicator(&MemDC, regulationType);
    display.DisplayAll(&MemDC); 

	// ------------------------------------------------------------ copy MemDC to client pDC 
	pDC->StretchBlt(0, 0, resizedClientX, resizedClientY, 
		            &MemDC, 0, 0, CLIENT_X, CLIENT_Y, SRCCOPY);

    //pDC->SelectPalette(pPaletteOld, FALSE);
}


// ================================================================================================
// ================================================================================================
//   DAA - STAUS BAR INFO
// ================================================================================================
// ================================================================================================ 
void DAA_ShowStatusBarInfo(CDC* pDC, CPoint point)
{
	CString s;
	if (analysisType < ANTYPE_SPECTR)
	{
		// ------------------------------------------------------------ normalized X and Y of the mouse
		float x = display.NormX(point);
		float y = display.NormY(point);
		// ------------------------------------------------------------
		double mv1 = 8 * (posY1_discrete + y - 1) * scaleY1 / regY1;
		double mv2 = 8 * (posY2_discrete + y - 1) * scaleY2 / regY2;
		double millisec = 10 * x * scaleX / regX;
		// ------------------------------------------------------------
		if (selectCH== 3) s = "  CH1 + CH2 = " + MillivoltToString(mv1, 3) + "        ";
		else if (selectCH == 4) s += "  CH1 - CH2 = " + MillivoltToString(mv1, 3) + "        ";
		else
		{
			s = "  CH1 = " + MillivoltToString(mv1, 3) + "        ";
			s += " CH2 = " + MillivoltToString(mv2, 3) + "        ";
		}
		if (selectCH != 5) s += "TIME = " + MillisecToString2(millisec, 3) + "        ";
	}
	else
	{
		if (spectrum3D)
		{
			s = "Spectrum 3D";
		}
		else if (DisplaySamples)
		{
			s = "Spectrum samples";
		}
		else
		{
			// ------------------------------------------------------------ normalized X and Y of the mouse
			float x = display.NormX_Spectrum(point);
			float y = display.NormY_Spectrum(point);
			// ------------------------------------------------------------ 
			double hertz;
			if (xlogtype) hertz = freqMin * exp(x * log(freqMax / freqMin));
			else hertz = freqMin + x * (freqMax - freqMin);
			// ------------------------------------------------------------ 
			double decibel;
			double millivolt; 
			if (ylogtype)
			{
				decibel = dbmax -(1 - y) * (dbmax - dbmin);
				millivolt = 1000 * Root2x2 * exp(decibel / kdb);
			}
			else
			{
				double mvmin = exp(dbmin / kdb) * 1000 * Root2x2;
				double mvmax = exp(dbmax / kdb) * 1000 * Root2x2;
				millivolt =  mvmax -(1 - y) * (mvmax - mvmin);
				decibel = kdb * log(millivolt / (1000 * Root2x2));
			}
			if (decibel >= dbmin && hertz >= freqMin)
			{
				s = "Spectrum parameters :     ";
				s +=  MillivoltToString(millivolt, 3) + "pp      ";
				s += DecibelToString(decibel) + "        ";
				s += HertzToString(hertz, 3) + "        ";
			}
		}
	}
	frame6.SetText(pDC, s);
}


// ================================================================================================
// ================================================================================================
//   DAA - LBUTTON DOWN
// ================================================================================================
// ================================================================================================ 
void CorrectMeterAndTriggerChannels(CDC* pDC)
{
	if (analysisType >= 2) return;	
	if (selectCH == 3 || selectCH == 4)		
	{	
		if (kbChtrig.keyPressed == 1) kbChtrig.PressKey(pDC, 0);
		if (kbCurs.keyPressed == 1) kbCurs.PressKey(pDC, 2);
	}
	if (selectCH == 0)		
	{
		if (kbChtrig.keyPressed == 1) kbChtrig.PressKey(pDC, 0);
		if (kbCurs.keyPressed == 1) kbCurs.PressKey(pDC, 2);
	}
	if (selectCH == 1)		
	{
		if (kbChtrig.keyPressed == 0) kbChtrig.PressKey(pDC, 1);
		if (kbCurs.keyPressed == 2) kbCurs.PressKey(pDC, 1);
	}
	trigCH = kbChtrig.keyPressed;
	curstype = kbCurs.keyPressed;
}

void DAA_LButtonDown(CDC* pDC, CPoint point)
{    
    RECT rect;
    CWnd* pWnd = pDC->GetWindow();
    pWnd->GetClientRect(&rect);
    pWnd->ClientToScreen(&rect);

	// removed in version 3.0
    //ClipCursor(&rect);
    
	if (display.ClickInside(point))
	{
		// ------------------------------------------------------- set inital values
		StopDelayChanges = 0;
		displayEdit = true;
		displayEdit_InitialDelaypos = delaypos;
		displayEdit_InitialPixel = point.x;
		displayEdit_EditCursor = 0;
		displayEdit_EditTriggerPos = 0;
		// ------------------------------------------------------- test mouse position
		if (analysisType >= 2)
		{
			// --------------------------------------------------- if Spectrum then edit cursor1
			displayEdit_EditCursor = 1;
		}
		else if (abs(display.NormX(point) - trigpos) < 0.11 && 
				abs(triggerPixelY - (point.y - display.GetBorderUp())) < 30) 
		{		
			// --------------------------------------------------- if near to trigger then move trigger position
			displayEdit_EditTriggerPos = true;
		}
		else if (curstype == 3)
		{
			// --------------------------------------------------- if Wave and Cursors then test if near to a cursor
			double pos = display.NormX(point);
			if (abs(pos - curs1) < 0.05 && abs(pos - curs1) <= abs(pos - curs2)) displayEdit_EditCursor = 1;
			if (abs(pos - curs2) < 0.05 && abs(pos - curs2) <= abs(pos - curs1)) displayEdit_EditCursor = 2;
		}
		// ------------------------------------------------------- do an initial MouseMove
		DAA_MouseMove(pDC, point);
	}
    else if (dialer.ClickInside(pDC, point))
	{
		if (indicator.editing)
		{
			dialer.SetValue(atof(indicator.strValue));
			indicator.editing = false;
		}
		clickedDialerID = 1;
	}
    else if (dialer1.ClickInside(pDC, point)) clickedDialerID = 2;
    else if (dialer2.ClickInside(pDC, point)) clickedDialerID = 3;
    else if (dialer3.ClickInside(pDC, point)) clickedDialerID = 4;
    else if (dialer4.ClickInside(pDC, point)) clickedDialerID = 5;
    else if (dialer5.ClickInside(pDC, point)) clickedDialerID = 6;
    else if (dialer6.ClickInside(pDC, point)) clickedDialerID = 7;
    else if (dialer7.ClickInside(pDC, point)) clickedDialerID = 8;
    else if (dialer8.ClickInside(pDC, point)) clickedDialerID = 9;
	else if (dialer9.ClickInside(pDC, point)) {clickedDialerID = 10; StopDelayChanges = 0;}
    else if (dialer10.ClickInside(pDC, point)) clickedDialerID = 11;
    else if (dialer11.ClickInside(pDC, point)) clickedDialerID = 12;
    else if (dialer12.ClickInside(pDC, point)) clickedDialerID = 13;
    else if (dialer13.ClickInside(pDC, point)) clickedDialerID = 14;
    else if (dialerTrig.ClickInside(pDC, point)) clickedDialerID = 15;
    //if (clickedDialerID) ShowCursor(FALSE);

    else if (kbWtype.ClickInside(pDC, point))
    {
        wavetype = kbWtype.keyPressed;
        DAA_FillWaveTable(wavetype);
        display.DisplayAll(pDC);  
        DAA_SetLightedKeys(pDC);
        DAA_ResetSweep(TRUE);
        calibratedResponse = FALSE;
        ledcal.Update(pDC, 0);
    }
    else if (kbAtype.ClickInside(pDC, point))
    {
        analysisType = kbAtype.keyPressed;
		CorrectMeterAndTriggerChannels(pDC);
		keycalspectrum.PressKey(pDC, 0);
		keysamp.PressKey(pDC, 0);
		DisplaySamples = FALSE;
        DAA_SetLightedKeys(pDC);    
        if (analysisType == ANTYPE_SPECTR && spectrum3D && !DisplaySamples) display.Clear();
        if (analysisType >= ANTYPE_SPECTR && inputState) ResetFhtBuffers();
        display.CreateGrid();
        DAA_ResetSweep(TRUE);
        calibratedResponse = FALSE;
        ledcal.Update(pDC, 0);
    }
    else if (kbRtype.ClickInside(pDC, point))
    {
		indicator.editing = false;
        kbRtype2.ReleaseAllKeys(pDC);
        regulationType = kbRtype.keyPressed;
        DAA_SetRegulationType(pDC, regulationType);
        dialer.Update(pDC);
        DAA_DrawIndicator(pDC, regulationType);
    }
    else if (kbRtype2.ClickInside(pDC, point))
    {
		indicator.editing = false;
        kbRtype.ReleaseAllKeys(pDC);
        regulationType = kbRtype2.keyPressed + REGTYPE_KB2_FIRST;
        DAA_SetRegulationType(pDC, regulationType);
        dialer.Update(pDC);
        DAA_DrawIndicator(pDC, regulationType);
    }
	else if (kbTrig.ClickInside(pDC, point))
    {
        trigType = kbTrig.keyPressed;
        DAA_SetTrigType(trigType);
        dialerTrig.Update(pDC);
    }
    else if (kbChan.ClickInside(pDC, point)) 
	{
		selectCH = kbChan.keyPressed;
		CorrectMeterAndTriggerChannels(pDC);
	}	
	else if (keyAc1.ClickInside(pDC, point))  
	{
		ac1 = keyAc1.pressed; 
		InitVmaxVminVmidAndCircularBuffer();
	}
	else if (keyAc2.ClickInside(pDC, point))  
	{
		ac2 = keyAc2.pressed; 
		InitVmaxVminVmidAndCircularBuffer();
	}
	else if (keyNeg1.ClickInside(pDC, point)) 
	{
		neg1 = keyNeg1.pressed; 
		if (neg1) polarity1 = -1; else polarity1 = 1;
		InitVmaxVminVmidAndCircularBuffer();
	}
	else if (keyNeg2.ClickInside(pDC, point)) 
	{
		neg2 = keyNeg2.pressed; 
		if (neg2) polarity2 = -1; else polarity2 = 1;	
		InitVmaxVminVmidAndCircularBuffer();
	}
	else if (keyMul1.ClickInside(pDC, point)) 
	{
		mul1 = 1; 
		if(keyMul1.pressed) mul1 = 100;
	}
	else if (keyMul2.ClickInside(pDC, point)) 
	{
		mul2 = 1; 
		if(keyMul2.pressed) mul2 = 100;
	}
	else if (kbChtrig.ClickInside(pDC, point)) 
	{
		if ((selectCH == 3 || selectCH == 4) && analysisType < 2 && kbChtrig.keyPressed == 1) 
		{	
			theApp.m_pMainWnd->MessageBox("In ADD and SUB modes, the CH2 is not valid", "Warning from DAA", MB_SYSTEMMODAL);
			kbChtrig.PressKey(pDC, kbChtrig.OldKeyPressed);
		}
		trigCH = kbChtrig.keyPressed;
	}

    else if (keyTrigSlope.ClickInside(pDC, point)) trigslope = keyTrigSlope.pressed;
    else if (keyTrigBurst.ClickInside(pDC, point)) trigburst = keyTrigBurst.pressed;

	// ------------------------------------------------------------------- DISPLAY SAMPLES
	else if (keysamp.ClickInside(pDC, point))
	{
		if (analysisType >= ANTYPE_SPECTR)
        {
			if (!DisplaySamples)
			{
				DisplaySamples = TRUE;
				calibratedResponse = FALSE;
				ledcal.Update(pDC, 0); 
			}
			else
			{
				DisplaySamples = FALSE;
				if (analysisType == ANTYPE_SPECTR && spectrum3D) display.Clear();
			}
			keycalspectrum.pressed = FALSE;
			keycalspectrum.Draw(pDC);
			display.CreateGrid();
		}
		else
		{
			keysamp.PressKey(pDC, 0);
		}
	}
	// -------------------------------------------------------------- CALIBRATION - SPECTRUM
    else if (keycalspectrum.ClickInside(pDC, point))
	{
		if (analysisType >= ANTYPE_SPECTR && !DisplaySamples)
        {
            if (calibratedResponse)
            {            
                for (int i = 0; i <= dispx; i++) calibrateTab[i] = 1; 
                DAA_ResetSweep(TRUE);
                calibratedResponse = FALSE;
                ledcal.Update(pDC, 0);
				keycalspectrum.PressKey(pDC, 0);
            }
            else
            {           
                float midvalue = 0;
                for (int i = 0; i < dispx / 2; i++)
                {
                    if (responseTab[dispx / 2 + i] > 0)
                    {
                        midvalue = responseTab[dispx / 2 + i];
                        break;
                    }
                    if (responseTab[dispx / 2 - i] > 0)
                    {
                        midvalue = responseTab[dispx / 2 - i];
                        break;
                    }
                }
                if (midvalue > 0)
                {
                    for (int i = 0; i <= dispx; i++)
                    {
                        if (responseTab[i] > 0) calibrateTab[i] = midvalue / responseTab[i];
                    }
                    DAA_ResetSweep(TRUE);
                    calibratedResponse = TRUE;
                    ledcal.Update(pDC, 2);
                }
            }
        }
		else
		{
			keycalspectrum.PressKey(pDC, 0);
		}
	}

	// -------------------------------------------------------------- CALIBRATION - ZERO
    else if (keycal.ClickInside(pDC, point))
    {
        if (inputState)
        {     
            // ------------------------------------------------------ set zero for CH1 and CH2
			Calibrating = true;
			double sum1 = 0;
			double sum2 = 0;
            for (int i = 0; i < 10; i++)
            {
				calib_vmax1 = -DOUBLEMAX;
				calib_vmin1 = DOUBLEMAX;
				calib_vmax2 = -DOUBLEMAX;
				calib_vmin2 = DOUBLEMAX;
                ledcal.Update(pDC, 2);
                Sleep(150);                
                ledcal.Update(pDC, 0);
                Sleep(150); 
				sum1 += (calib_vmax1 + calib_vmin1) / 2;
			    sum2 += (calib_vmax2 + calib_vmin2) / 2;  
            }
			if (selectCH != 1) calY1 = int(-sum1 / 10);
			if (selectCH != 0) calY2 = int(-sum2 / 10);  
			Calibrating = false;
			// ------------------------------------------------------ save calibrations to Main Props
            InitTime();
            DAA_WriteMainProps();
            while (GetTime() < 50000);
        }
        keycal.PressKey(pDC, 0);
    }

	// -------------------------------------------------------------- CALIBRATION - VOLTAGE
	else if (keycalVolt.ClickInside(pDC, point))
    {
		if (inputState)
        {     
            // ------------------------------------------------------ set gain for CH1 and CH2
			Calibrating = true;   
			double sum1 = 0;
			double sum2 = 0;
            for (int i = 0; i < 10; i++)
            {
				calib_vmax1 = -DOUBLEMAX;
				calib_vmin1 = DOUBLEMAX;
				calib_vmax2 = -DOUBLEMAX;
				calib_vmin2 = DOUBLEMAX;
                ledcal.Update(pDC, 1);
                Sleep(150);               
                ledcal.Update(pDC, 0);
				Sleep(150); 
				sum1 += (calib_vmax1 + calib_vmin1) / 2;
				sum2 += (calib_vmax2 + calib_vmin2) / 2;
            }
			if (selectCH != 1) gain1 = CalibrationVoltage / (abs((sum1 / 10.0 + calY1)) / 65536.0) / 2.0;
			if (selectCH != 0) gain2 = CalibrationVoltage / (abs((sum2 / 10.0 + calY2)) / 65536.0) / 2.0;
			
			// -----------------------------------
			//  Normal values
			// -----------------------------------
			// LEVEL 100 = 1.223   1.564
			// LEVEL  95 = 2.336   2.346
			// LEVEL   0 = 86.44   88.91
			// GND - GND = >1000 .. >1000
			// ----------------------------------- if gain is abnormal set default calibrations
			if (gain1 > 10000 || gain2 > 10000)
			{
				CString message;
				/*message = "No-voltage, incorrect or deliberate calibration.\n\n";
				message += "Using default calibration setting.\n\n";
				message += "These settings are approximatively valid for:\n";
				message += " - Audiocard based on CM6206\n";
				message += " - Audiocard input bias = 1.36 volt\n";
				message += " - Line Input level = 95";
				theApp.m_pMainWnd->MessageBox(message, "Warning from DAA", MB_SYSTEMMODAL);
				gain1 = 2.34;
				gain2 = 2.34;
				calY1 = 19000;
				calY2 = 19000;*/

				message = "No-voltage, incorrect or deliberate calibration.\n\n";
				message += "Using default calibration setting.\n\n";
				message += "These settings are approximatively valid for:\n";
				message += "Line Input levels near to maximum (90 to 100%)";
				theApp.m_pMainWnd->MessageBox(message, "Warning from DAA", MB_SYSTEMMODAL);
				gain1 = 2.34;
				gain2 = 2.34;
				calY1 = 0;
				calY2 = 0;

				vmax1 = 0;
				vmin1 = 0;
				vmax2 = 0;
				vmin2 = 0;
				vmid1 = 0;
				vmid2 = 0;
			}

			// -------------------------------------------------------------------------------------------------
			//  IMPORTANT - This MUST be after the MessageBox, otherwise vmax and vmin could become NAN numbers
			// ------------------------------------------------------------------------------------------------- 
			Calibrating = false;

			// ------------------------------------------------------ save calibrations to Main Props
            InitTime();
            DAA_WriteMainProps();
            while (GetTime() < 50000);
        }
		keycalVolt.PressKey(pDC, 0);
	}

	// -------------------------------------------------------------- CALIBRATION - OUTPUT
	else if (keycalOut.ClickInside(pDC, point))
    {
		if (inputState && outputState && regulationType == REGTYPE_OUTLEV 
			           && analysisType == ANTYPE_WAVE && wavetype == WAVETYPE_SINE)
        {    
			Calibrating = true;
			double testlevel = -6;
			double oldfreq = freq;
			double oldlevel = outlevel;
			freq = 100;
			outlevel = testlevel;
			deltalevel1 = 0;
			deltalevel2 = 0;
			// ------------------------------------------------------ Fill and wait more than 171 mS (with out buffers 32*1024 / 192000) 
			DAA_FillWaveTable(wavetype);
			// ------------------------------------------------------ 1200 instead of 1000 to wait wait 20% more
			Sleep((1200 * N_BUFOUT * OUT_BUF_LEN / 2) / SAMPLES_PER_SEC); 
			// ------------------------------------------------------
			double sum1 = 0;
			double sum2 = 0;
            for (int i = 0; i < 10; i++)
            {
				calib_vmax1 = -DOUBLEMAX;
				calib_vmin1 = DOUBLEMAX;
				calib_vmax2 = -DOUBLEMAX;
				calib_vmin2 = DOUBLEMAX;
                ledcal.Update(pDC, 3);
				Sleep(150);               
                ledcal.Update(pDC, 0);
                Sleep(150); 
				sum1 += (calib_vmax1 - calib_vmin1);
				sum2 += (calib_vmax2 - calib_vmin2);
            }
			double v1 = gain1 * sum1 / 10.0 / 32768.0;
			double v2 = gain2 * sum2 / 10.0 / 32768.0;
			// ------------------------------------------------------ restore normal values
			freq = oldfreq;
			outlevel = oldlevel;
			Calibrating = false;
			// ------------------------------------------------------ set deltalevel
			deltalevel1 = testlevel - mVppToDB(1000 * v1);
			deltalevel2 = testlevel - mVppToDB(1000 * v2);
			// ------------------------------------------------------ compensate a little to get 0.707V for -3dB
			deltalevel1 += 0.01; 
			deltalevel2 += 0.01; 
			// ------------------------------------------------------ set max range for outlevel
			int max1 = -int(ceil(deltalevel1));
			int max2 = -int(ceil(deltalevel2));
			int max = min(max1,max2);
            dialer.InitRange(-99, max, 1.2, .05, 1, &outlevel); 
			if (outlevel > max) 
			{
				outlevel = max; 
				DAA_DrawIndicator(pDC, regulationType);
			}
			// ------------------------------------------------------ update the wavetable
			DAA_FillWaveTable(wavetype);
			// ------------------------------------------------------ save calibrations to Main Props
            InitTime();
            DAA_WriteMainProps();
            while (GetTime() < 50000);
		}
		keycalOut.PressKey(pDC, 0);
	}

	else if (kbInOnOff.ClickInside(pDC, point))
    {
		if (kbInOnOff.keyPressed == 1)
		{ 
			if (!DAA_InputOn()) kbInOnOff.PressKey(pDC, 0);
		}
		else
		{
			DAA_InputOff();
		}

        if (analysisType >= ANTYPE_SPECTR) 
        {
            DAA_ResetSweep(TRUE);
            calibratedResponse = FALSE;
            ledcal.Update(pDC, 0);
        }
    }
    else if (kbOutOnOff.ClickInside(pDC, point))
    {
		if (kbOutOnOff.keyPressed == 1)
		{ 
			if (!DAA_OutputOn()) kbOutOnOff.PressKey(pDC, 0);
		}
		else
		{
			DAA_OutputOff();
		}

        if (analysisType >= ANTYPE_SPECTR)
        {
            DAA_ResetSweep(TRUE);
            calibratedResponse = FALSE;
            ledcal.Update(pDC, 0);
        }
    }
    else if (kbCurs.ClickInside(pDC, point)) 
	{
		if ((selectCH == 3 || selectCH == 4) && kbCurs.keyPressed == 1) 
		{	
			theApp.m_pMainWnd->MessageBox("In ADD and SUB modes, the CH2 is not valid", "Warning from DAA", MB_SYSTEMMODAL);
			kbCurs.PressKey(pDC, kbCurs.OldKeyPressed);
		}
		curstype = kbCurs.keyPressed;
	}
	else if (kbTime.ClickInside(pDC, point)) timetype = kbTime.keyPressed;
    else if (kbVolt.ClickInside(pDC, point)) volttype = kbVolt.keyPressed;
    else if (kbXlog.ClickInside(pDC, point))
    {
        xlogtype = kbXlog.keyPressed;
        if (analysisType >= ANTYPE_SPECTR) display.CreateGrid();
        DAA_ResetSweep(TRUE);
        calibratedResponse = FALSE;
        ledcal.Update(pDC, 0);
    }
    else if (kbYlog.ClickInside(pDC, point))
    {
        ylogtype = kbYlog.keyPressed;
        if (analysisType >= ANTYPE_SPECTR) display.CreateGrid();
    }

	else if (indicator.ClickInside(pDC, point))
    {
		if (!indicator.editing)
		{
			double value;
			value = DAA_GetIndicatorValue(regulationType);
			CString str;

			switch (regulationType)
			{
				case REGTYPE_DBMAX:
				case REGTYPE_DBMIN:
				case REGTYPE_DUTY:
				case REGTYPE_OUTLEV:
					str.Format("%0.1f", value);
					break;
				case REGTYPE_SLOT:
				case REGTYPE_BURST:
				case REGTYPE_PAUSE:
					str.Format("%0.0f", value);
					break;
				default:
					str.Format("%.2f", value);
					break;
			}

			indicator.strValue = str;

			if (indicator.selectionStart > str.GetLength())
			{
				indicator.selectionStart = str.GetLength() + 1;
				indicator.selectionEnd = indicator.selectionStart;
			}

			indicator.editing = true;
			DAA_DrawIndicator(pDC, regulationType);
		}
    }
}

double GetTrigDialerDefaults()
{ 
	switch (trigType)
	{
		case 0: return -1;
		case 1: return 0.1;
		case 2: return 0;
		case 3: return 0.2;
		case 4: return 0;
		case 5: return 0;
	}
	return 0;
}

double GetMainDialerDefaults()
{ 
	switch (regulationType)
	{
		case REGTYPE_FREQ: return 100;
		case REGTYPE_FMAX: return 20000;
		case REGTYPE_FMIN: return 10;
		case REGTYPE_DBMAX: return 60;
		case REGTYPE_DBMIN: return -120;
		case REGTYPE_SLOT: return 0;
		case REGTYPE_CALIB: return 1.4;

		case REGTYPE_DUTY: return 50;
		case REGTYPE_BURST: return 10;
		case REGTYPE_PAUSE: return 10;
		case REGTYPE_BEGIN: return 0;
		case REGTYPE_END: return 200;
		case REGTYPE_TIME: return 5;
		case REGTYPE_OUTLEV: return -3;
	}
	return 0;
}

void DAA_LButtonDoubleClick(CDC* pDC, CPoint point)
{
	// -------------------------------------------------------- TEST DIALERS
	CDialer* d = GetDialerControl(point);
	if (d != NULL)
	{
		if (d == &dialer1) 
		{
			d->SetValue(180); 
			SetDialersAccessoryOperations(pDC, 2);
		}
		if (d == &dialer2) 
		{
			d->SetValue(180); 
			SetDialersAccessoryOperations(pDC, 3);
		}
		if (d == &dialer3) 
		{
			d->SetValue(255); 
		}
		if (d == &dialer4 || d == &dialer5) 
		{
			d->SetValue(1000); 
			d->SetValueS(0);
		}
		if (d == &dialer6) 
		{
			d->SetValue(-0.5); 
		}
		if (d == &dialer7) 
		{
			d->SetValue(0); 
		}
		if (d == &dialer8) 
		{
			d->SetValue(5); 
			d->SetValueS(0);
		}
		if (d == &dialer9 || d == &dialer10 || d == &dialer11 || d == &dialer12) 
		{
			d->SetValue(0); 
		}
		if (d == &dialer13) 
		{
			d->SetValue(0.5); 
		}
		if (d == &dialerTrig) 
		{
			d->SetValue(GetTrigDialerDefaults()); 
		}
		if (d == &dialer) 
		{
			d->SetValue(GetMainDialerDefaults()); 
			SetDialersAccessoryOperations(pDC, 1);
		}
		d->UpdatePosition(pDC);
		return;
	}
	// -------------------------------------------------------- TEST TRIGGER KEYBOARD
	if (kbTrig.Inside(point))
	{
		dialerTrig.SetValue(GetTrigDialerDefaults()); 
		dialerTrig.UpdatePosition(pDC);
	}
	// -------------------------------------------------------- TEST MAIN DIALER KEYBOARD
	if (kbRtype.Inside(point) || kbRtype2.Inside(point))
	{
		dialer.SetValue(GetMainDialerDefaults()); 
		dialer.UpdatePosition(pDC);
		SetDialersAccessoryOperations(pDC, 1);
	}
	// -------------------------------------------------------- INDICATOR DOUBLE CLICK
	if (indicator.Inside(point))
		if (indicator.editing) indicator.SelectAll(pDC);
}


// ================================================================================================
// ================================================================================================
//   DAA - SET LIGHTED KEYS
// ================================================================================================
// ================================================================================================ 
void DAA_SetLightedKeys(CDC* pDC)
{
    kbRtype.UnlightAllKeys(pDC);
    kbRtype2.UnlightAllKeys(pDC);

    switch (analysisType)
    {
        case ANTYPE_WAVE: 
            kbRtype.LightKey(pDC, REGTYPE_FREQ);
			kbRtype.LightKey(pDC, REGTYPE_SLOT);
			kbRtype.LightKey(pDC, REGTYPE_CALIB);
            kbRtype2.LightKey(pDC, REGTYPE_OUTLEV - REGTYPE_KB2_FIRST);
			break;  

        case ANTYPE_BURST: 
            kbRtype.LightKey(pDC, REGTYPE_FREQ);
			kbRtype.LightKey(pDC, REGTYPE_SLOT);
			kbRtype.LightKey(pDC, REGTYPE_CALIB);
            kbRtype2.LightKey(pDC, REGTYPE_DUTY - REGTYPE_KB2_FIRST);
            kbRtype2.LightKey(pDC, REGTYPE_BURST - REGTYPE_KB2_FIRST);
            kbRtype2.LightKey(pDC, REGTYPE_OUTLEV - REGTYPE_KB2_FIRST);
            burstcounter = 0;
            burstflag = TRUE;
			break;

		case ANTYPE_SPECTR:
            kbRtype.LightKey(pDC, REGTYPE_FREQ);
            kbRtype.LightKey(pDC, REGTYPE_FMAX);
            kbRtype.LightKey(pDC, REGTYPE_FMIN);
            kbRtype.LightKey(pDC, REGTYPE_DBMAX);
            kbRtype.LightKey(pDC, REGTYPE_DBMIN);
			kbRtype.LightKey(pDC, REGTYPE_SLOT);
			kbRtype.LightKey(pDC, REGTYPE_CALIB);
            kbRtype2.LightKey(pDC, REGTYPE_OUTLEV - REGTYPE_KB2_FIRST); 
			break;
        
		case ANTYPE_SWEEP:
            kbRtype.LightKey(pDC, REGTYPE_FMAX);
            kbRtype.LightKey(pDC, REGTYPE_FMIN);
            kbRtype.LightKey(pDC, REGTYPE_DBMAX);
            kbRtype.LightKey(pDC, REGTYPE_DBMIN);
			kbRtype.LightKey(pDC, REGTYPE_SLOT);
            kbRtype2.LightKey(pDC, REGTYPE_TIME - REGTYPE_KB2_FIRST);
            kbRtype2.LightKey(pDC, REGTYPE_OUTLEV - REGTYPE_KB2_FIRST);
			break;

        case ANTYPE_FASTSW:
			kbRtype.LightKey(pDC, REGTYPE_FMAX);
            kbRtype.LightKey(pDC, REGTYPE_FMIN);
            kbRtype.LightKey(pDC, REGTYPE_DBMAX);
            kbRtype.LightKey(pDC, REGTYPE_DBMIN);
			kbRtype.LightKey(pDC, REGTYPE_SLOT);
            kbRtype2.LightKey(pDC, REGTYPE_BEGIN - REGTYPE_KB2_FIRST);
            kbRtype2.LightKey(pDC, REGTYPE_OUTLEV - REGTYPE_KB2_FIRST);
			break;

        case ANTYPE_PULSE:
            kbRtype.LightKey(pDC, REGTYPE_FMAX);
            kbRtype.LightKey(pDC, REGTYPE_FMIN);
            kbRtype.LightKey(pDC, REGTYPE_DBMAX);
            kbRtype.LightKey(pDC, REGTYPE_DBMIN);
			kbRtype.LightKey(pDC, REGTYPE_SLOT);
            kbRtype2.LightKey(pDC, REGTYPE_BEGIN - REGTYPE_KB2_FIRST);
            kbRtype2.LightKey(pDC, REGTYPE_END - REGTYPE_KB2_FIRST);
            kbRtype2.LightKey(pDC, REGTYPE_OUTLEV - REGTYPE_KB2_FIRST);
			break;
    }
    if (wavetype == WAVETYPE_SQUARE && (analysisType == ANTYPE_WAVE ||
										analysisType == ANTYPE_BURST || 
										analysisType == ANTYPE_SWEEP)) 
	{
		kbRtype2.LightKey(pDC, REGTYPE_DUTY - REGTYPE_KB2_FIRST);
	}
}


// ================================================================================================
// ================================================================================================
//   DAA - SET REGULATION TYPE
// ================================================================================================
// ================================================================================================ 
void DAA_SetRegulationType(CDC* pDC, int type)
{    
    switch (type)
    {
        case REGTYPE_FREQ:
            dialer.InitRange(0, 100000, 3, .02, 1, &freq); 
			dialer.SetMouseWheelParams(100, FALSE);
			break;
        case REGTYPE_FMAX:
            dialer.InitRange(1, 100000, 3, .02, 1, &freqMax);
			dialer.SetMouseWheelParams(100, FALSE);
			break;
        case REGTYPE_FMIN:
			dialer.InitRange(1, 100000, 3, .02, 1, &freqMin);
			dialer.SetMouseWheelParams(100, FALSE);
			break;
        case REGTYPE_DBMAX:
            dialer.InitRange(-100, 60, 1.2, .05, .1, &dbmax);
			dialer.SetMouseWheelParams(10, FALSE);
			break;
        case REGTYPE_DBMIN:
            dialer.InitRange(-120, 40, 1.2, .05, .1, &dbmin);
			dialer.SetMouseWheelParams(10, FALSE);
			break;
        case REGTYPE_SLOT:
            dialer.InitRange(0, 990, 1.3, .1, 1, &FirstSlot);  
			dialer.SetMouseWheelParams(1, FALSE);
			break;
		case REGTYPE_CALIB:
            dialer.InitRange(0.1, 9999.999, 2, .0005, .001, &CalibrationVoltage);
			dialer.SetMouseWheelParams(0.1, FALSE);
			break;

        case REGTYPE_DUTY:
            dialer.InitRange(0, 100, 1.3, .02, .1, &duty);  
			dialer.SetMouseWheelParams(10, FALSE);
			break;
        case REGTYPE_BURST:
            dialer.InitRange(1, 999, 1.3, .1, 1, &burstCycles);
			dialer.SetMouseWheelParams(1, FALSE);
			break;
        case REGTYPE_PAUSE:
            dialer.InitRange(1, 999, 1.3, .1, 1, &pauseCycles);
			dialer.SetMouseWheelParams(1, FALSE);
			break;
        case REGTYPE_BEGIN:
            dialer.InitRange(-50, 50, 1.9, .01, .01, &start_sampling_ms);
			dialer.SetMouseWheelParams(1, FALSE);
			break;
		case REGTYPE_END:
            dialer.InitRange(10, out_pulse_millisec, 1.9, .01, .01, &sampling_ms);
			dialer.SetMouseWheelParams(1, FALSE);
			break;
		case REGTYPE_TIME:
            dialer.InitRange(1, 99, 1.2, .1, .5, &sweepTime);
			dialer.SetMouseWheelParams(1, FALSE);
			break;
        case REGTYPE_OUTLEV:
			int max1 = -int(ceil(deltalevel1));
			int max2 = -int(ceil(deltalevel2));
			int max = min(max1, max2);
            dialer.InitRange(-99, max, 1.2, .05, 1, &outlevel); 
			dialer.SetMouseWheelParams(1, FALSE);
			break;
    }
	if (pDC) dialer.UpdatePosition(pDC);
}


// ================================================================================================
// ================================================================================================
//   DAA - SET TRIG TYPE
// ================================================================================================
// ================================================================================================ 
void DAA_SetTrigType(int type)
{    
    switch (type)
    {
        case 0:
            dialerTrig.InitRange(-1, 1, 1, 1, .000001, &trigvoid);
        break;
        case 1:
            dialerTrig.InitRange(0, 1, 1, 1, .000001, &trigpos);
        break;
        case 2:
            dialerTrig.InitRange(-1, 1, 1, 1, .000001, &triglev);
        break;
        case 3:
            dialerTrig.InitRange(0, 1, 1, 1, .000001, &trigist);
        break;
        case 4:
            dialerTrig.InitRange(0, 1, 1, 1, .000001, &trigstab);
        break;
		case 5:
            dialerTrig.InitRange(-1, 1, 1, 1, .000001, &trigstop);
        break;
    }
    dialerTrig.InitScale(40, 320, 2);
}


// ================================================================================================
// ================================================================================================
//   DAA - DRAW INDICATOR
// ================================================================================================
// ================================================================================================ 
void DAA_DrawIndicator(CDC* pDC, int type)
{
    switch (type)
    {
        case REGTYPE_FREQ : indicator.Draw(pDC, freq, type); break;
        case REGTYPE_FMAX : indicator.Draw(pDC, freqMax, type); break;
        case REGTYPE_FMIN : indicator.Draw(pDC, freqMin, type); break;
        case REGTYPE_DBMAX: indicator.Draw(pDC, dbmax, type); break;
        case REGTYPE_DBMIN: indicator.Draw(pDC, dbmin, type); break;
		case REGTYPE_SLOT : indicator.Draw(pDC, FirstSlot, type); break;
		case REGTYPE_CALIB: indicator.Draw(pDC, CalibrationVoltage, type); break;
        
        case REGTYPE_DUTY : indicator.Draw(pDC, duty, type); break;
        case REGTYPE_BURST: indicator.Draw(pDC, burstCycles, type); break;
        case REGTYPE_PAUSE: indicator.Draw(pDC, pauseCycles, type); break;
        case REGTYPE_BEGIN: indicator.Draw(pDC, start_sampling_ms, type); break;
        case REGTYPE_END  : indicator.Draw(pDC, sampling_ms, type); break;  
		case REGTYPE_TIME : indicator.Draw(pDC, sweepTime, type); break;
        case REGTYPE_OUTLEV : indicator.Draw(pDC, outlevel, type); break;
    }
}

// ================================================================================================
// ================================================================================================
//   DAA - GET INDICATOR VALUE
// ================================================================================================
// ================================================================================================ 
double DAA_GetIndicatorValue(int type)
{
    switch (type)
    {
        case REGTYPE_FREQ : return freq; break;
        case REGTYPE_FMAX : return freqMax; break;
        case REGTYPE_FMIN : return freqMin; break;
        case REGTYPE_DBMAX: return dbmax; break;
        case REGTYPE_DBMIN: return dbmin; break;
		case REGTYPE_SLOT : return FirstSlot; break;
		case REGTYPE_CALIB: return CalibrationVoltage; break;
       
        case REGTYPE_DUTY : return duty; break;
        case REGTYPE_BURST: return burstCycles; break;
        case REGTYPE_PAUSE: return pauseCycles; break;
        case REGTYPE_BEGIN: return start_sampling_ms; break;
        case REGTYPE_END  : return sampling_ms; break; 
		case REGTYPE_TIME : return sweepTime; break;
        case REGTYPE_OUTLEV : return outlevel; break;
    }
	return 0;
}


// ================================================================================================
// ================================================================================================
//   DAA - LBUTTON UP
// ================================================================================================
// ================================================================================================ 
void DAA_LButtonUp(CDC* pDC, CPoint point)
{  
	pDC; point;
	//
    //if (clickedDialerID) ShowCursor(TRUE);
	StopDelayChanges = 0;
    clickedDialerID = 0;
    ClipCursor(NULL);
	displayEdit = false;
}



// ================================================================================================
// ================================================================================================
//   DAA - MOUSE MOVE
// ================================================================================================
// ================================================================================================ 
void SetDialersAccessoryOperations(CDC* pDC, int dialerIndex)
{
    switch (dialerIndex)
    {
		case 1:           
            if (regulationType == REGTYPE_FMAX && freqMax < freqMin + .1) dialer.SetValue(freqMin + .1);
            if (regulationType == REGTYPE_FMIN && freqMin > freqMax - .1) dialer.SetValue(freqMax - .1);  
            if (regulationType == REGTYPE_DBMAX && dbmax < dbmin + 1) dialer.SetValue(dbmin + 1);
            if (regulationType == REGTYPE_DBMIN && dbmin > dbmax - 1) dialer.SetValue(dbmax - 1); 
            if (regulationType == REGTYPE_DUTY && wavetype == WAVETYPE_SQUARE) DAA_FillWaveTable(wavetype);     
            if (regulationType == REGTYPE_OUTLEV) DAA_FillWaveTable(wavetype);

			if (regulationType == REGTYPE_BEGIN)
            {
                CString s;
				s.Format("Start sampling correction: %5.2f mS", start_sampling_ms);
				frame6.SetText(pDC, s);
            }

            if (regulationType == REGTYPE_END)
            {
                CString s;
				double ms = sampling_ms;
                double m = 0.341 * ms;
                int hz = int(1000 / ms);
				s.Format("Sampling time:%5.0f mS  -  Lower bandpass: %i Hz  -  Sound travels: %5.1f m", ms, hz, m);
				frame6.SetText(pDC, s);
            }
            
            if (analysisType >= ANTYPE_SPECTR)
            {              
                if (regulationType == REGTYPE_FMAX || regulationType == REGTYPE_FMIN
                    || regulationType == REGTYPE_TIME)
                {
                    DAA_ResetSweep(TRUE);
                    calibratedResponse = FALSE;
                    ledcal.Update(pDC, 0);
                }
          
                if (regulationType == REGTYPE_FMAX || regulationType == REGTYPE_FMIN ||
                    regulationType == REGTYPE_DBMAX || regulationType == REGTYPE_DBMIN) 
				{
					display.CreateGrid();
				}
            }

            DAA_DrawIndicator(pDC, regulationType);

        break;
        case 2:
            display.CreateGrid();
        break;
        case 3:
            if (analysisType >= ANTYPE_SPECTR) display.CreateGrid();
        break;
	}
}



void DAA_MouseMove(CDC* pDC, CPoint point)
{
	// --------------------------------------------------------------- INDICATOR EDIT SELECTION with MOUSE
	if (indicator.editing)
	{
		if (indicator.Inside(point) && LButtonPressed())
		{
			indicator.MouseMove(pDC, point);
			return;
		}
	}

	// --------------------------------------------------------------- DISPLAY EDIT
	if (displayEdit)
	{
		if (displayEdit_EditTriggerPos)
		{
			double pos = display.NormX(point) + 0.005;
			if (pos < 0) pos = 0;
			if (pos > 1) pos = 1;
			trigpos = pos;
			if (trigType == 1) dialerTrig.UpdatePosition(pDC);
			return;
		}
		else if (displayEdit_EditCursor)
		{
			// ------------------------------------------------------- SPECTRUM - EDIT CURSOR 1 POSITION
			// ------------------------------------------------------- calc cursor position (0 to 1)
			double pos;
			if (analysisType < 2) pos = display.NormX(point);
			else pos = display.NormX_Spectrum(point);
			// ------------------------------------------------------- update and return
			if (displayEdit_EditCursor == 1)
			{
				dialer11.SetValue(pos);
				dialer11.UpdatePosition(pDC);
			}
			else
			{
				dialer12.SetValue(pos);
				dialer12.UpdatePosition(pDC);
			}
			return;
		}
		else
		{
			// ------------------------------------------------------- WAVE ande BURST - EDIT DELAY
			// ------------------------------------------------------- calc delta
			double delta;
			delta = (point.x - displayEdit_InitialPixel) / double(dispdx);
			delta = CorrectByControKeys(delta);
			// ------------------------------------------------------- kscale and new delaypos 
			double kscale = SAMPLES_PER_SEC / 100 * scaleX / regX;
			double newdelaypos = displayEdit_InitialDelaypos - delta * kscale;
			// ------------------------------------------------------- stop delay changes when changing sign
			if (delaypos != 0 && sgn(delaypos) != sgn(newdelaypos))
			{
				StopDelayChanges = 20;
			}
			if (StopDelayChanges) newdelaypos = 0;
			delaypos = newdelaypos;
			// ------------------------------------------------------- update and return
			dialer9.UpdatePosition(pDC);
		}
		return;
	}

	// --------------------------------------------------------------- HELP and DIALERS ROTATION
    switch (clickedDialerID)
    {
        case 0:
            {
                helpindex = 0;

				if (display.Inside(point)) helpindex = -1;
                else if (dialer1.Inside(point)) helpindex = 1;
                else if (dialer2.Inside(point)) helpindex = 2;
                else if (dialer3.Inside(point)) helpindex = 3;
                else if (dialer4.Inside(point))
                {
                    if (dialer4.Inside(point) == 1) helpindex = 4;
                    else helpindex = 5;
                }
                else if (dialer5.Inside(point))
                {
                    if (dialer5.Inside(point) == 1) helpindex = 6;
                    else helpindex = 7;
                }
                else if (dialer6.Inside(point)) helpindex = 8;
                else if (dialer7.Inside(point)) helpindex = 9;
                else if (dialer8.Inside(point))
                {
                    if (dialer8.Inside(point) == 1) helpindex = 10;
                    else helpindex = 11;
                }
                else if (dialer9.Inside(point)) helpindex = 12;
                else if (dialer10.Inside(point)) helpindex = 13;
                else if (dialer11.Inside(point)) helpindex = 14;
                else if (dialer12.Inside(point)) helpindex = 15;
                else if (dialer13.Inside(point)) helpindex = 16;
                
                else if (keyTrigSlope.Inside(point)) helpindex = 17;
                else if (keyTrigBurst.Inside(point)) helpindex = 18;
				else if (keysamp.Inside(point)) helpindex = 201;
				else if (ledcal.Inside(point)) helpindex = 203;
                else if (keycal.Inside(point)) helpindex = 19;
				else if (keycalspectrum.Inside(point)) helpindex = 205;
				else if (keycalVolt.Inside(point)) helpindex = 204;
				else if (keycalOut.Inside(point)) helpindex = 206;

                else if (dialer.Inside(point)) helpindex = regulationType + 20;
                else if (indicator.Inside(point)) helpindex = regulationType + 20;
                else if (dialerTrig.Inside(point)) helpindex = trigType + 60;
                else if (kbRtype.Inside(point)) helpindex = kbRtype.PointedKey(point) + 20;
                else if (kbRtype2.Inside(point)) helpindex = kbRtype2.PointedKey(point) + 20 + REGTYPE_KB2_FIRST;
                else if (kbAtype.Inside(point)) helpindex = kbAtype.PointedKey(point) + 40;
                else if (kbWtype.Inside(point)) helpindex = kbWtype.PointedKey(point) + 50;
                else if (kbTrig.Inside(point)) helpindex = kbTrig.PointedKey(point) + 60;
                else if (kbChan.Inside(point)) helpindex = kbChan.PointedKey(point) + 70;

				else if (keyAc1.Inside(point)) helpindex = 80;
				else if (keyNeg1.Inside(point)) helpindex = 81;
				else if (keyMul1.Inside(point)) helpindex = 82;
				else if (keyAc2.Inside(point)) helpindex = 90;
				else if (keyNeg2.Inside(point)) helpindex = 91;
				else if (keyMul2.Inside(point)) helpindex = 92;
                				
				else if (kbChtrig.Inside(point)) helpindex = kbChtrig.PointedKey(point) + 100;
                else if (kbInOnOff.Inside(point)) helpindex = kbInOnOff.PointedKey(point) + 110;
                else if (kbOutOnOff.Inside(point)) helpindex = kbOutOnOff.PointedKey(point) + 115;
                else if (kbCurs.Inside(point)) helpindex = kbCurs.PointedKey(point) + 120;
                else if (kbTime.Inside(point)) helpindex = kbTime.PointedKey(point) + 130;
                else if (kbVolt.Inside(point)) helpindex = kbVolt.PointedKey(point) + 140;
                else if (kbXlog.Inside(point)) helpindex = kbXlog.PointedKey(point) + 150;
                else if (kbYlog.Inside(point)) helpindex = kbYlog.PointedKey(point) + 160;

                else helpindex = 0;

                if (helpindex == oldhelpindex && helpindex >= 0) break;

                oldhelpindex = helpindex;
                CString help;
						
                switch (helpindex)
                {
					case -1: 
						DAA_ShowStatusBarInfo(pDC, point); 
						return;
					case 0: help = READY_MESSAGE; break;
                    case 1: help = "Grid lightning"; break;
                    case 2: help = "Readout intensity"; break;
                    case 3: help = "Trace intensity"; break;
					case 4: help = "CH1 - Volts per division  ( Y-scale )"; break;
                    case 5: help = "CH1 - The central knob adjusts the channel amplitude or the filter frequency, depending on the ""Filters Menu"" settings."; break;
                    case 6: help = "CH2 - Volts per division  ( Y-scale )"; break;
                    case 7: help = "CH2 - The central knob adjusts the channel amplitude or the filter frequency, depending on the ""Filters Menu"" settings."; break;
                    case 8: help = "CH1 - Vertical position"; break;
                    case 9: help = "CH2 - Vertical position"; break;
                    case 10: help = "Time per division  ( X-scale )"; break;
                    case 11: help = "Time per division  ( regulation )"; break;
					case 202: help = "Delay negative"; break;
                    case 12: help = "Delay time  ( only when input is off )"; break;
                    case 13: help = "Delta time  ( from channel 1 and channel 2 )"; break;
                    case 14: help = "Cursor 1 position"; break;
                    case 15: help = "Cursor 2 position"; break;
                    case 16: help = "Response speed for SPECTRUM & PULSE"; break;
                 
                    case 17: help = "Trigger slope  ( press for negative slope )"; break;
					case 18: help = "Trigger for burst waveforms (when pressed set: Level=50%, Noise=50%, Stab=100%, then decrease Stab slowly, until the trigger led lights)"; break;

					case 201: help = "In SPECTRUM, SWEEP & PULSE modes, press this button to view samples and the sample window"; break;
                    case 203: help = "This led flashes during calibrations"; break;
					case 205: help = "In SPECTRUM, SWEEP & PULSE modes, this button sets a 'reference' ( flat frequency response )"; break;
					case 19:  help = "In WAVE or BURST modes, this button calibrate the zero voltage ( connect the inputs to ground before pressing this button )"; break;
					case 204: help = "In WAVE or BURST modes, this button calibrate the voltage ( open the inputs or connect them to a calibration voltage before pressing this button )"; break;
					case 206: help = "This button calibrate the output voltage ( before pressing set: Analysis = Wave, Waveform = Sine, and connect a cable from Output to Line input )"; break;

                    case 20: help = "Waveform frequency"; break;
                    case 21: help = "Maximum frequency for SPECTRUM SWEEP & PULSE X-scale"; break;
                    case 22: help = "Minimum frequency for SPECTRUM SWEEP & PULSE X-scale"; break;
                    case 23: help = "Maximum voltage for SPECTRUM SWEEP & PULSE Y-scale"; break;
                    case 24: help = "Minimum voltage for SPECTRUM SWEEP & PULSE Y-scale"; break;
                    case 25: help = "First Slot to write measured values ( the values shown in the top row of the display )"; break;
                    case 26: help = "Calibration voltage ( set the correct calibration voltage before to press 'CALIBRATE VOLT' )"; break;
            
                    case 27: help = "Duty cycle  ( for square waves only )"; break;
                    case 28: help = "Burst body  ( number of cycles )"; break;
                    case 29: help = "Burst pause  ( number of cycles )"; break;                    
                    case 30: help = "Begin sampling  ( each mS is about 3 meters of distance )"; break;
                    case 31: help = "End sampling  ( each mS is about 3 meters of distance )"; break;
					case 32: help = "Sweep time"; break;
                    case 33: help = "Output level"; break;
                    
                    case 40: help = "Simple wave generator and scope"; break;
                    case 41: help = "Burst generator and scope"; break;
                    case 42: help = "Wave generator with Fourier spectrum analisis"; break;
                    case 43: help = "Sweep generator with frequency response analyser"; break;
                    case 44: help = "Fast sweep generator with Fourier spectrum analisis"; break;
                    case 45: help = "Pulse generator with Fourier spectrum analisis"; break;

                    case 50: help = "Sinusoidal wave"; break;
                    case 51: help = "Triangular wave"; break;
                    case 52: help = "Positive sawtoot"; break;
                    case 53: help = "Negative sawtoot"; break;
                    case 54: help = "Square wave"; break;
                    case 55: help = "White noise"; break;

                    case 60: help = "Trigger disabled"; break;
                    case 61: help = "Trigger position on X-axis"; break;
                    case 62: help = "Trigger level"; break;
                    case 63: help = "Trigger noise  ( increase if waveform is noisy )"; break;
                    case 64: help = "Trigger stability  ( regulate for best triggering )"; break;
					case 65: help = "Stop level  ( regulate the stop level voltage ) --- When the input voltage crosses the stop level, the INPUT is set to OFF"; break;
                    
                    case 70: help = "Channel 1 only"; break;
                    case 71: help = "Channel 2 only"; break;
                    case 72: help = "Both channels"; break;
                    case 73: help = "Add channels  ( Y is CH1 + CH2 )"; break;
                    case 74: help = "Subtract channels  ( Y is CH1 - CH2 )"; break;
                    case 75: help = "XY display  ( CH1 is X / CH2 is Y )"; break;
                    
                    case 80: help = "Channel 1 AC (the DC component is software filtered)"; break;
                    case 81: help = "Channel 1 negative"; break;
                    case 82: help = "Channel 1 voltage range multiplied by 100"; break;
                   
                    case 90: help = "Channel 2 AC (the DC component is software filtered)"; break;
                    case 91: help = "Channel 2 negative"; break;
                    case 92: help = "Channel 2 voltage range multiplied by 100"; break;

                    case 100: help = "Trigger, Spectrum, Sweep, FastSweep and Pulse, connected to Channel 1"; break;
                    case 101: help = "Trigger, Spectrum, Sweep, FastSweep and Pulse, connected to Channel 2"; break;

                    case 110: help = "Input disabled"; break;
                    case 111: help = "Input enabled"; break;
                    case 115: help = "Output disabled"; break;
                    case 116: help = "Output enabled"; break;
                        
                    case 120: help = "All measurations off"; break;
                    case 121: help = "Continuous frequency-meter and volt-meter on channel 2"; break;
                    case 122: help = "Continuous frequency-meter and volt-meter on channel 1"; break;
                    case 123: help = "Distance and time between cursors"; break;

                    case 130: help = "Display measured time"; break;
                    case 131: help = "Display measured frequency"; break;

                    case 140: help = "Display measured voltage"; break;
                    case 141: help = "Display measured decibels"; break;

                    case 150: help = "X scale linear for SWEEP SPECTRUM & PULSE"; break;
                    case 151: help = "X scale logarithmic for SWEEP SPECTRUM & PULSE"; break;
                    case 160: help = "Y scale linear for SWEEP SPECTRUM & PULSE"; break;
                    case 161: help = "Y scale logarithmic for SWEEP SPECTRUM & PULSE"; break;

                    default: help = "-----";
                } 

				if (helpindex == 110 || helpindex == 111)
				{
					double CH1min = RoundToNdigits_Floor(((32768 * -1 + calY1) * polarity1 * gain1) / 32768, 1);
					double CH2min = RoundToNdigits_Floor(((32768 * -1 + calY2) * polarity2 * gain2) / 32768, 1);
					double CH1max = RoundToNdigits_Floor(((32768 * 1 + calY1) * polarity1 * gain1) / 32768, 1);
					double CH2max = RoundToNdigits_Floor(((32768 * 1 + calY2) * polarity2 * gain2) / 32768, 1);
					CString s;
					s.Format("   - - -   CH1 voltage range = %3.1f to %3.1f volt ", CH1min, CH1max);
					help += s; 
					s.Format("   - - -   CH2 voltage range = %3.1f to %3.1f volt ", CH2min, CH2max);
					help += s; 
				}

				frame6.SetText(pDC, help);
            }
        break;
        case 1:
            dialer.Rotation(pDC, point);              
        break;
        case 2:
            dialer1.Rotation(pDC, point);
        break;
        case 3:
            dialer2.Rotation(pDC, point);
        break;
        case 4:
            dialer3.Rotation(pDC, point);
        break; 
        case 5:
            dialer4.Rotation(pDC, point);
        break; 
        case 6:
            dialer5.Rotation(pDC, point);
        break; 
        case 7:
            dialer6.Rotation(pDC, point);
        break; 
        case 8:
            dialer7.Rotation(pDC, point);
        break; 
        case 9:
            dialer8.Rotation(pDC, point);
        break; 
        case 10:
            dialer9.Rotation(pDC, point);
			// ------------------------------------------- stop the DELAY changes for some time or until clicked 
			{
				static double olddelaypos = delaypos;
				if (olddelaypos != 0 && sgn(delaypos) != sgn(olddelaypos) && StopDelayChanges == 0) 
				{
					StopDelayChanges = 8;
				}
				if (StopDelayChanges)
				{
					delaypos = 0;
					dialer9.SetValue(0);
				}
				olddelaypos = delaypos;
			}

        break;
        case 11:
            dialer10.Rotation(pDC, point);
        break;
        case 12:
            dialer11.Rotation(pDC, point);
        break;
        case 13:
            dialer12.Rotation(pDC, point);
        break;
        case 14:
            dialer13.Rotation(pDC, point);
        break;
        case 15:
            dialerTrig.Rotation(pDC, point);
        break; 
    }

	if (clickedDialerID >= 1) SetDialersAccessoryOperations(pDC, clickedDialerID);

    if (clickedDialerID && !spectrum3D) display.DisplayAll(pDC); 
}


// ================================================================================================
// ================================================================================================
//   MOUSE WHEEL - FUNCTIONS
// ================================================================================================
// ================================================================================================
CDialer* GetDialerControl(CPoint point)
{
	if (dialer.Inside(point)) return &dialer;
	else if (dialer1.Inside(point)) return &dialer1;
    else if (dialer2.Inside(point)) return &dialer2;
    else if (dialer3.Inside(point)) return &dialer3;
    else if (dialer4.Inside(point)) return &dialer4;
    else if (dialer5.Inside(point)) return &dialer5;
    else if (dialer6.Inside(point)) return &dialer6;
    else if (dialer7.Inside(point)) return &dialer7;
    else if (dialer8.Inside(point)) return &dialer8;
    else if (dialer9.Inside(point)) return &dialer9;
    else if (dialer10.Inside(point)) return &dialer10;
    else if (dialer11.Inside(point)) return &dialer11;
    else if (dialer12.Inside(point)) return &dialer12;
    else if (dialer13.Inside(point)) return &dialer13;
	else if (dialerTrig.Inside(point)) return &dialerTrig;
	else if (display.Inside(point)) 
	{
		if (analysisType < 2) return &dialer8;
		else return &dialer11;
	}
	return NULL;
}


// ================================================================================================
// ================================================================================================
//   DAA - MOUSE WHEEL
// ================================================================================================
// ================================================================================================ 
void DAA_MouseWheel(CDC* pDC, short zDelta, CPoint point)
{
	// ---------------------------------------------------- convert the point to window coordinates
	CWnd* pWnd = pDC->GetWindow();
	pWnd->ScreenToClient(&point);
	// ---------------------------------------------------- find the dialer pointed by the cursor 
	CDialer* dialerSelected = GetDialerControl(point);
	if (dialerSelected == NULL) return;
	// ---------------------------------------------------- correction for Microsoft micrometric mouse
	double n;
	if (dialerSelected->allowMicrometricMouse)
		n = zDelta / 120.0;
	else
		n = CorrectMicrometricMouse(zDelta);
	// ---------------------------------------------------- do not correct if using the display touch screen (zoom + CTRL)
	if (!display.Inside(point)) 
	{
		// ------------------------------------------------ correct with keys: CTRL / SHIFT / ALT
		n = CorrectByControKeys(n);
	}
	// ---------------------------------------------------- change the dialer value 
	dialerSelected->ChangeValue(n);

	// ---------------------------------------------------- stop the DELAY changes for some time or until clicked 
	if (dialerSelected == &dialer9)
	{
		static double olddelaypos = delaypos;
		if (olddelaypos != 0 && sgn(delaypos) != sgn(olddelaypos)) StopDelayChanges = 10;
		if (StopDelayChanges) delaypos = 0;
		olddelaypos = delaypos;
	}

	// ---------------------------------------------------- accessory operations for some dialers
	if (dialerSelected == &dialer) SetDialersAccessoryOperations(pDC, 1);
	if (dialerSelected == &dialer1) SetDialersAccessoryOperations(pDC, 2);
	if (dialerSelected == &dialer2) SetDialersAccessoryOperations(pDC, 3);
	// ---------------------------------------------------- update the knob
	dialerSelected->UpdatePosition(pDC);
}

void MouseWheelFromKeys(CDC* pDC, short delta)
{
    CPoint point;
    GetCursorPos(&point);
	DAA_MouseWheel(pDC, delta, point);
}

// ================================================================================================
// ================================================================================================
//   DAA - KEY DOWN
// ================================================================================================
// ================================================================================================ 
void DAA_CTRL_XCV_Keys( UINT nChar)
{
	if (indicator.editing)
	{
		CMainFrame *wnd = (CMainFrame *) theApp.m_pMainWnd;
	    CDaaView *viewwnd = (CDaaView *) wnd->GetActiveView ();	    
        CDC* pDC = viewwnd->GetDC();
		switch (nChar)
		{
			case int('X'):
				SendTextToClipBoard(0, indicator.GetSelectedText());
				indicator.ClearSelectedText(pDC);
				break;

			case int('C'):
				SendTextToClipBoard(0, indicator.GetSelectedText());
				break;

			case int('V'):
				indicator.AddText(pDC, GetTextFromClipBoard(0));
				break;
		}
		viewwnd->ReleaseDC(pDC);
	}
}


void DAA_KeyDown(CDC* pDC, UINT nChar)
{
	if (indicator.editing)
	{
		switch (nChar)
		{
			case 48: indicator.AddText(pDC, "0"); break;
			case 49: indicator.AddText(pDC, "1"); break;
			case 50: indicator.AddText(pDC, "2"); break;
			case 51: indicator.AddText(pDC, "3"); break;
			case 52: indicator.AddText(pDC, "4"); break;
			case 53: indicator.AddText(pDC, "5"); break;
			case 54: indicator.AddText(pDC, "6"); break;
			case 55: indicator.AddText(pDC, "7"); break;
			case 56: indicator.AddText(pDC, "8"); break;
			case 57: indicator.AddText(pDC, "9"); break;
			case 188: case 190: indicator.AddText(pDC, "."); break;
			case 189: case 109: indicator.AddText(pDC, "-"); break;

			case VK_LEFT: indicator.KeyLeft(pDC); break;
			case VK_RIGHT: indicator.KeyRight(pDC); break;
			case VK_BACK: indicator.Backspace(pDC); break;
			case VK_DELETE: indicator.Delete(pDC); break;

			case VK_ESCAPE:
				indicator.editing = false;
				DAA_DrawIndicator(pDC, regulationType);
				break;
				
			case VK_RETURN:
				dialer.SetValue(atof(indicator.strValue));
				indicator.editing = false;
				DAA_DrawIndicator(pDC, regulationType);
				display.CreateGrid();
				DAA_FillWaveTable(wavetype);
				break;

			case int('A'):
				if (KeyPressed(VK_CONTROL)) indicator.SelectAll(pDC);
				break;

			default:
		    	break;
		}
		
	}
	else
	{
		switch (nChar)
		{
			case VK_PRIOR: 
				MouseWheelFromKeys(pDC, 12000);
			break;
			case VK_NEXT:
				MouseWheelFromKeys(pDC, -12000);
			break;
			case VK_LEFT:
			case VK_DOWN:
				MouseWheelFromKeys(pDC, -120);
			break;
			case VK_RIGHT:
			case VK_UP:
				MouseWheelFromKeys(pDC, 120);
			break;
		}
	}
}




// ================================================================================================
// ================================================================================================
//   DAA - SAVE
// ================================================================================================
// ================================================================================================ 
void DAA_Save(CArchive& ar)
{
    CString str("DAA_REG 4.0 ");
    ar.Write(str, 12);

    ar.Write(&freq,sizeof(freq));
	ar.Write(&freqMax,sizeof(freqMax));
    ar.Write(&freqMin,sizeof(freqMin));
	ar.Write(&dbmax,sizeof(dbmax));
	ar.Write(&dbmin,sizeof(dbmin));
	ar.Write(&FirstSlot,sizeof(FirstSlot));
	ar.Write(&CalibrationVoltage,sizeof(CalibrationVoltage));

	ar.Write(&duty,sizeof(duty));
    ar.Write(&burstCycles,sizeof(burstCycles));
    ar.Write(&pauseCycles,sizeof(pauseCycles));
    ar.Write(&start_sampling_ms,sizeof(start_sampling_ms));
    ar.Write(&sampling_ms,sizeof(sampling_ms));
    ar.Write(&sweepTime,sizeof(sweepTime));
    ar.Write(&outlevel,sizeof(outlevel));

    ar.Write(&scaleX,sizeof(scaleX));
    ar.Write(&scaleY1,sizeof(scaleY1));
    ar.Write(&scaleY2,sizeof(scaleY2));
    ar.Write(&regX,sizeof(regX));
    ar.Write(&regY1,sizeof(regY1));
    ar.Write(&regY2,sizeof(regY2));
	ar.Write(&filterFrequency1,sizeof(filterFrequency1));
    ar.Write(&filterFrequency2,sizeof(filterFrequency2));
	
    ar.Write(&posY1,sizeof(posY1));
    ar.Write(&posY2,sizeof(posY2));

    ar.Write(&selectCH,sizeof(selectCH));
    ar.Write(&ac1,sizeof(ac1));
    ar.Write(&ac2,sizeof(ac2));
    ar.Write(&neg1,sizeof(neg1));
    ar.Write(&neg2,sizeof(neg2));
    ar.Write(&mul1,sizeof(mul1));
    ar.Write(&mul2,sizeof(mul2));

    ar.Write(&trigCH,sizeof(trigCH));
    ar.Write(&inputState,sizeof(inputState));
    ar.Write(&outputState,sizeof(outputState));

    ar.Write(&wavetype,sizeof(wavetype));
    ar.Write(&analysisType,sizeof(analysisType));
    ar.Write(&regulationType,sizeof(regulationType));

    ar.Write(&gridLight,sizeof(gridLight));
    ar.Write(&osdIntensity,sizeof(osdIntensity));
    ar.Write(&traceIntensity,sizeof(traceIntensity));

    ar.Write(&trigType,sizeof(trigType));
    ar.Write(&trigpos,sizeof(trigpos));
    ar.Write(&triglev,sizeof(triglev));
    ar.Write(&trigist,sizeof(trigist));
    ar.Write(&trigstab,sizeof(trigstab));
	ar.Write(&trigstop,sizeof(trigstop));
    ar.Write(&trigslope,sizeof(trigslope));
    ar.Write(&trigburst,sizeof(trigburst));

    ar.Write(&delaypos,sizeof(delaypos));
    ar.Write(&deltapos,sizeof(deltapos));

    ar.Write(&curs1,sizeof(curs1));
    ar.Write(&curs2,sizeof(curs2));
    ar.Write(&responsespeed,sizeof(responsespeed));
    ar.Write(&curstype,sizeof(curstype));
    ar.Write(&timetype,sizeof(timetype));
    ar.Write(&volttype,sizeof(volttype));
    ar.Write(&xlogtype,sizeof(xlogtype));
    ar.Write(&ylogtype,sizeof(ylogtype));

    ar.Write(&bandwidth,sizeof(bandwidth));
	ar.Write(&fhtwindow,sizeof(fhtwindow));
    ar.Write(&spectrum3D,sizeof(spectrum3D));

	ar.Write(&Filter_CH1,sizeof(Filter_CH1));
	ar.Write(&Filter_CH2,sizeof(Filter_CH2));
	ar.Write(&Filters_Npoles,sizeof(Filters_Npoles));
}


// ================================================================================================
// ================================================================================================
//   DAA - LOAD
// ================================================================================================
// ================================================================================================ 
void DAA_Load(CArchive& ar)
{
    CString str;
    ar.Read(str.GetBuffer(12), 12); 
    if (str == "DAA_REG 4.0 ")
    {
		int newinputState = 0;
		int newoutputState = 0;

        ar.Read(&freq,sizeof(freq));
		ar.Read(&freqMax,sizeof(freqMax));
        ar.Read(&freqMin,sizeof(freqMin));
        ar.Read(&dbmax,sizeof(dbmax));
        ar.Read(&dbmin,sizeof(dbmin));
		ar.Read(&FirstSlot,sizeof(FirstSlot));
		ar.Read(&CalibrationVoltage,sizeof(CalibrationVoltage));

		ar.Read(&duty,sizeof(duty));
	    ar.Read(&burstCycles,sizeof(burstCycles));
        ar.Read(&pauseCycles,sizeof(pauseCycles));
        ar.Read(&start_sampling_ms,sizeof(start_sampling_ms));
        ar.Read(&sampling_ms,sizeof(sampling_ms));
		ar.Read(&sweepTime,sizeof(sweepTime));
        ar.Read(&outlevel,sizeof(outlevel));
    
        ar.Read(&scaleX,sizeof(scaleX));
        ar.Read(&scaleY1,sizeof(scaleY1));
        ar.Read(&scaleY2,sizeof(scaleY2));
        ar.Read(&regX,sizeof(regX));
        ar.Read(&regY1,sizeof(regY1));
        ar.Read(&regY2,sizeof(regY2));
		ar.Read(&filterFrequency1,sizeof(filterFrequency1));
		ar.Read(&filterFrequency2,sizeof(filterFrequency2));
                                             
        ar.Read(&posY1,sizeof(posY1));
        ar.Read(&posY2,sizeof(posY2));  
              
        ar.Read(&selectCH,sizeof(selectCH));
		ar.Read(&ac1,sizeof(ac1));
		ar.Read(&ac2,sizeof(ac2));
		ar.Read(&neg1,sizeof(neg1));
		ar.Read(&neg2,sizeof(neg2));
		ar.Read(&mul1,sizeof(mul1));
		ar.Read(&mul2,sizeof(mul2));

        ar.Read(&trigCH,sizeof(trigCH));
        ar.Read(&newinputState,sizeof(newinputState));
        ar.Read(&newoutputState,sizeof(newoutputState));

        ar.Read(&wavetype,sizeof(wavetype));
        ar.Read(&analysisType,sizeof(analysisType));
        ar.Read(&regulationType,sizeof(regulationType));
    
        ar.Read(&gridLight,sizeof(gridLight));
        ar.Read(&osdIntensity,sizeof(osdIntensity));
        ar.Read(&traceIntensity,sizeof(traceIntensity));
    
        ar.Read(&trigType,sizeof(trigType));
        ar.Read(&trigpos,sizeof(trigpos));
        ar.Read(&triglev,sizeof(triglev));
        ar.Read(&trigist,sizeof(trigist));
        ar.Read(&trigstab,sizeof(trigstab));
		ar.Read(&trigstop,sizeof(trigstop));
        ar.Read(&trigslope,sizeof(trigslope));
        ar.Read(&trigburst,sizeof(trigburst));

        ar.Read(&delaypos,sizeof(delaypos));
        ar.Read(&deltapos,sizeof(deltapos));

        ar.Read(&curs1,sizeof(curs1));
        ar.Read(&curs2,sizeof(curs2));
        ar.Read(&responsespeed,sizeof(responsespeed));
        ar.Read(&curstype,sizeof(curstype));
        ar.Read(&timetype,sizeof(timetype));
        ar.Read(&volttype,sizeof(volttype));
        ar.Read(&xlogtype,sizeof(xlogtype));
        ar.Read(&ylogtype,sizeof(ylogtype));

        ar.Read(&bandwidth,sizeof(bandwidth));
		ar.Read(&fhtwindow,sizeof(fhtwindow));
        ar.Read(&spectrum3D,sizeof(spectrum3D));

		ar.Read(&Filter_CH1,sizeof(Filter_CH1));
		ar.Read(&Filter_CH2,sizeof(Filter_CH2));
		ar.Read(&Filters_Npoles,sizeof(Filters_Npoles));

		if (newinputState) DAA_InputOn(); 
		else DAA_InputOff();
		if (newoutputState) DAA_OutputOn(); 
		else DAA_OutputOff();
    }
    else
    {   
        CFile* fp = ar.GetFile();
        CString str1;
        str1.Format("%s", fp->GetFileName());
        str1 += " is not a valid DAA 1.1 regulations file";
        theApp.m_pMainWnd->MessageBox(str1, "DAA", MB_ICONEXCLAMATION); 
    }

	DAA_InitAfterLoad();
}

void DAA_InitAfterLoad()
{
	DAA_Filters_Init();
    DAA_SetBandwidth(bandwidth);
    DAA_SetRegulationType(NULL, regulationType);
    DAA_SetTrigType(trigType);
    DAA_SetLightedKeys(&MemDC);

    if (analysisType == ANTYPE_SPECTR && spectrum3D && !DisplaySamples) display.Clear();
    display.CreateGrid();

    DAA_FillWaveTable(wavetype);

    DAA_ResetSweep(TRUE);
    calibratedResponse = FALSE;
    ledcal.Update(&MemDC, 0);

	DAA_PressKeys(&MemDC);
}


// ================================================================================================
// ================================================================================================
//   DAA - DRAW UPDATED DIALERS
// ================================================================================================
// ================================================================================================ 
void DAA_DrawUpdatedDialers(CDC* pDC)
{
    DAA_SetLightedKeys(pDC);

    dialer.UpdatePosition(pDC);
    dialer1.UpdatePosition(pDC);
    dialer2.UpdatePosition(pDC);
    dialer3.UpdatePosition(pDC);
    dialer4.UpdatePosition(pDC);
    dialer5.UpdatePosition(pDC);
    dialer6.UpdatePosition(pDC);
    dialer7.UpdatePosition(pDC);
    dialer8.UpdatePosition(pDC);
    dialer9.UpdatePosition(pDC);
    dialer10.UpdatePosition(pDC);
    dialer11.UpdatePosition(pDC);
    dialer12.UpdatePosition(pDC);
    dialer13.UpdatePosition(pDC);
	dialerTrig.Update(pDC);
}

// ================================================================================================
// ================================================================================================
//   DAA - PRESS KEYS
// ================================================================================================
// ================================================================================================ 
void DAA_PressKeys(CDC* pDC)
{
    kbInOnOff.PressKey(pDC, inputState);
    kbOutOnOff.PressKey(pDC, outputState);

    kbChan.PressKey(pDC, selectCH);

    keyAc1.PressKey(pDC, ac1);
    keyAc2.PressKey(pDC, ac2);
	keyNeg1.PressKey(pDC, neg1);
    keyNeg2.PressKey(pDC, neg2);
	keyMul1.PressKey(pDC, (mul1 != 1));
    keyMul2.PressKey(pDC, (mul2 != 1));

    kbChtrig.PressKey(pDC, trigCH);
    kbTrig.PressKey(pDC, trigType);
    kbAtype.PressKey(pDC, analysisType);
    kbWtype.PressKey(pDC, wavetype);

    kbCurs.PressKey(pDC, curstype);
    kbTime.PressKey(pDC, timetype);
    kbVolt.PressKey(pDC, volttype);
    kbXlog.PressKey(pDC, xlogtype);   
    kbYlog.PressKey(pDC, ylogtype);

    if (regulationType < REGTYPE_KB2_FIRST)
    {
        kbRtype.PressKey(pDC, regulationType);
        kbRtype2.PressKey(pDC, -1);
    }
    else
    {
        kbRtype.PressKey(pDC, -1);
        kbRtype2.PressKey(pDC, regulationType - REGTYPE_KB2_FIRST);
    }

    keyTrigSlope.PressKey(pDC, trigslope);
    keyTrigBurst.PressKey(pDC, trigburst);
}


// ================================================================================================
// ================================================================================================
//   DAA - GET MULTI DRAW
// ================================================================================================
// ================================================================================================ 
BOOL DAA_GetMultiDraw()
{
    return multiDraw;
}

// ================================================================================================
// ================================================================================================
//   DAA - GET DISPLAY SAMPLES
// ================================================================================================
// ================================================================================================ 
BOOL DAA_GetDisplaySamples()
{
    return DisplaySamples;
}

// ================================================================================================
// ================================================================================================
//   DAA - SPECTRUM 3D
// ================================================================================================
// ================================================================================================ 
BOOL DAA_GetSpectrum3D()
{
    return spectrum3D;
}

void DAA_ToggleSpectrum3D()
{
    spectrum3D = !spectrum3D;
    if (analysisType == ANTYPE_SPECTR && spectrum3D && !DisplaySamples) display.Clear();
    display.CreateGrid();
}

// ================================================================================================
// ================================================================================================
//   DAA - SET REFERENCE - GET REFERENCE
// ================================================================================================
// ================================================================================================ 
void DAA_SetReference()
{
    if (referenceFlag)
    {
        display.CreateGrid();
        referenceFlag = FALSE;
    }
    else
    {
        if (!spectrum3D && !DisplaySamples)
        {
            display.dcGrid.BitBlt(0, 0,
                                  dispx + leftborder,
                                  dispy + downborder,
                                  &display.dcScreen,
                                  0, 0, SRCCOPY);
            referenceFlag = TRUE;
        }
    }
}

BOOL DAA_GetReference()
{
    return referenceFlag;
}

// ================================================================================================
// ================================================================================================
//   DAA - BANDWIDTH
// ================================================================================================
// ================================================================================================ 
void DAA_SetBandwidth(int bw)
{
    bandwidth = bw;
    double b = 1;
    if (bandwidth == 0) b = 1; // max
    /*
    if (bandwidth == 1) b = 1.05946309;  // 1/12
    if (bandwidth == 2) b = 1.12246205;  // 1/6
    */
    if (bandwidth == 1) b = 1.02337389; //  1/30
    if (bandwidth == 2) b = 1.07177346; //  1/10
    if (bandwidth == 3) b = 1.25992105; //  1/3
    if (bandwidth == 4) b = 2;          //  1
    band = float(b);
    if (calibratedResponse)
    {
        CMainFrame *wnd = (CMainFrame *) theApp.m_pMainWnd;
	    CDaaView *viewwnd = (CDaaView *) wnd->GetActiveView ();	    
        CDC* pDC = viewwnd->GetDC();
        ledcal.Update(pDC, 0);
        viewwnd->ReleaseDC(pDC);
        calibratedResponse = FALSE;   
    }
}

int  DAA_GetBandwidth()
{
    return bandwidth;
}

// ================================================================================================
// ================================================================================================
//   DAA - FHT WINDOW
// ================================================================================================
// ================================================================================================ 
void DAA_SetFhtWindow(int w)
{
	fhtwindow = w;
	FHTinit(fht_samples, fhtwindow);
}

int DAA_GetFhtWindow()
{
    return fhtwindow;
}

void DAA_ToggleMultiDraw()
{
    if (multiDraw) multiDraw = FALSE;
    else multiDraw = TRUE;
}


// ================================================================================================
// ================================================================================================
//   DAA - FILTERS
// ================================================================================================
// ================================================================================================ 
void DAA_Filters_Init()
{
	filterCH1.SetSampleFrequency(SAMPLES_PER_SEC);
	filterCH2.SetSampleFrequency(SAMPLES_PER_SEC);
	if (Filters_Npoles <= 0) Filters_Npoles = 2;
	filterCH1.SetNpoles(Filters_Npoles);
	filterCH2.SetNpoles(Filters_Npoles);
	if (Filter_CH1 == 0) filterCH1.SetNpoles(0);
	if (Filter_CH1 == 1) filterCH1.SetHiPass(false);
	if (Filter_CH1 == 2) filterCH1.SetHiPass(true);
	if (Filter_CH2 == 0) filterCH2.SetNpoles(0);
	if (Filter_CH2 == 1) filterCH2.SetHiPass(false);
	if (Filter_CH2 == 2) filterCH2.SetHiPass(true);
	// ----------------------------------------------------------- update knobs 
	if (Filter_CH1 == 0) 
	{
		dialer4.InitRangeDual(1, 2, 1, .001, .001, &regY1);
		dialer4.SetFilterKnob(false);
	}
	else 
	{
		dialer4.InitRangeDual(0, 1, 1, .0001, .0001, &filterFrequency1);
		dialer4.SetFilterKnob(true);
	}
	if (Filter_CH2 == 0) 
	{
		dialer5.InitRangeDual(1, 2, 1, .001, .001, &regY2);
		dialer5.SetFilterKnob(false);
	}
	else 
	{
		dialer5.InitRangeDual(0, 1, 1, .0001, .0001, &filterFrequency2);
		dialer5.SetFilterKnob(true);
	}
	// ----------------------------------------------------------- update knobs with "FILTER" or "CAL"
	CMainFrame *wnd = (CMainFrame *) theApp.m_pMainWnd;
	if (wnd)
	{
		CDaaView *viewwnd = (CDaaView *) wnd->GetActiveView ();	    
		CDC* pDC = viewwnd->GetDC();
		dialer4.Update(pDC);
		dialer4.UpdatePosition(pDC);
		dialer5.Update(pDC);
		dialer5.UpdatePosition(pDC);
		viewwnd->ReleaseDC(pDC);
	}
}

void DAA_SetCh1Filter(int n)
{
	Filter_CH1 = n;
	DAA_Filters_Init();
}
int DAA_GetCh1Filter()
{
    return Filter_CH1;
}

void DAA_SetCh2Filter(int n)
{
	Filter_CH2 = n;
	DAA_Filters_Init();
}
int DAA_GetCh2Filter()
{
    return Filter_CH2;
}

void DAA_SetFiltersPoles(int n)
{
	Filters_Npoles = n;
	DAA_Filters_Init();
}
int DAA_GetFiltersPoles()
{
    return Filters_Npoles;
}




// ================================================================================================
// ================================================================================================
//   DAA - GET DIPLAY BITMAP
// ================================================================================================
// ================================================================================================ 
CBitmap* DAA_GetDisplayBitmap()
{
	return &display.bmpScreen;
}



// ================================================================================================
// ================================================================================================
//   INPUT OUTPUT / ON - OFF
// ================================================================================================
// ================================================================================================ 
BOOL DAA_InputOn()
{
    if (inputState) return TRUE;
    inputState = 1;

	// -------------------------------------------------------------- open
    numCH = 2;
    int result;
    WAVEFORMATEX wfx;
    wfx.wFormatTag = WAVE_FORMAT_PCM;
	wfx.nChannels = WORD(numCH);
	wfx.nSamplesPerSec = SAMPLES_PER_SEC;
	wfx.nAvgBytesPerSec	= SAMPLES_PER_SEC * 2 * numCH;
	wfx.nBlockAlign = WORD(2 * numCH);
	wfx.wBitsPerSample = 16;
	wfx.cbSize = 0;

    result = waveInOpen(
                        &hwIn,
                        inputDevice,
                        &wfx, 
                        (DWORD)waveInProc,
                        NULL,
                        CALLBACK_FUNCTION //| WAVE_MAPPED
                        ); 

    if (result != MMSYSERR_NOERROR)
    {
        inputState = 0;
        return FALSE;
    }
    
	// -------------------------------------------------------------- PREPARE HEADERS
	WAVEHDR* pwh;
    __int16* pbuf;
	for (int i = 0; i < N_BUFIN; i++)
    {
		pwh = &pwhIn[i];
		pbuf = pbufIn[i];        
		//
		pwh->lpData = (CHAR*)pbuf;
		pwh->dwBufferLength = IN_BUF_LEN * 2;
		pwh->dwFlags = 0;
		pwh->dwLoops = 0;	
		pwh->lpNext = 0;
		pwh->reserved = 0;
		//
		waveInPrepareHeader(hwIn, pwh, sizeof(WAVEHDR));
	}
	// -------------------------------------------------------------- INIT VARS
    readpos = 0;
    mVpp = 0;
	mVdc = 0;
    BufInIndex = 0;
    vmax1 = vmax2 = DOUBLEMIN;
	vmin1 = vmin2 = DOUBLEMAX;
	cbufPos = 0;
	// -------------------------------------------------------------- ADD BUFFERS
    for (int i = 0; i < N_BUFIN; i++) DAA_AddBuffer();
	// -------------------------------------------------------------- START
    result = waveInStart(hwIn);
    if (result != MMSYSERR_NOERROR)
    {
        char c [100];
        waveInGetErrorText(result, c, 99);
        ClipCursor(NULL);
        theApp.m_pMainWnd->MessageBox(c,"WaveInStart", MB_SYSTEMMODAL);
        inputState = 0;
        return FALSE;
    } 

	// -------------------------------------------------------------- InitVmaxVminVmidAndCircularBuffer
	InitVmaxVminVmidAndCircularBuffer();

	// -------------------------------------------------------------- 
    return TRUE;
}


BOOL DAA_OutputOn()
{   
	if (outputState) return TRUE;
    outputState = 1;
	// -------------------------------------------------------------- prepare WAVEFORMATEX
    int result;
    WAVEFORMATEX wfx;
    wfx.wFormatTag = WAVE_FORMAT_PCM;
	wfx.nChannels = 2;
	wfx.nSamplesPerSec = SAMPLES_PER_SEC;
	wfx.nAvgBytesPerSec	= SAMPLES_PER_SEC * 4;
	wfx.nBlockAlign = 4;
	wfx.wBitsPerSample = 16;
	wfx.cbSize = 0;
    // -------------------------------------------------------------- OPEN
    result = waveOutOpen(
                         &hwOut,                
		                 outputDevice, 
		                 &wfx,
		                 (DWORD)waveOutProc,
		                 NULL,
		                 CALLBACK_FUNCTION | WAVE_ALLOWSYNC //| WAVE_MAPPED
                        );

    if (result != MMSYSERR_NOERROR)
    {
        outputState = 0;
        return FALSE;
    }
	// -------------------------------------------------------------- prepare headers 
	WAVEHDR* pwh;
	__int16* pbuf;
	//
	for (int i = 0; i < N_BUFOUT; i++)
	{
		pwh = &pwhOut[i];
		pbuf = pbufOut[i];
		//
		pwh->lpData = (CHAR*)pbuf;
		pwh->dwBufferLength = OUT_BUF_LEN * 2;
		pwh->dwFlags = 0;
		pwh->dwLoops = 0;
		pwh->lpNext = 0;
		pwh->reserved = 0;			
	    //
		waveOutPrepareHeader(hwOut, pwh, sizeof(WAVEHDR));
	}
	// -------------------------------------------------------------- INIT VARS
    oldfreq = freq;
    phase = 0;
    BufOutIndex = 0;
	// -------------------------------------------------------------- PAUSE / ADD BUFFERS / START
	waveOutPause(hwOut);
    for (int i = 0; i < N_BUFOUT; i++) DAA_FillBuffer(); 
	waveOutRestart(hwOut);
	// -------------------------------------------------------------- 
    return TRUE;
}

void DAA_InputOff()
{
    if (inputState == 0) return;
    inputState = 0; 
	// -------------------------------------------------------------- wait all the buffers
	//    1200 instead of 1000 to wait 20% more
	Sleep((1200 * N_BUFOUT * OUT_BUF_LEN / 2) / SAMPLES_PER_SEC); 
	// -------------------------------------------------------------- stop and reset
	waveInStop(hwIn);
    waveInReset(hwIn);
	// -------------------------------------------------------------- unprepare all the headers 
	for (int i = 0; i < N_BUFIN; i ++)
    {
		waveInUnprepareHeader(hwIn, &pwhIn[i], sizeof(WAVEHDR));
	}
	// --------------------------------------------------------------- close
    waveInClose(hwIn);
}

void DAA_OutputOff()
{
	if (outputState == 0) return;
    outputState = 0;  
	// --------------------------------------------------------------- wait all the buffers
	//    1200 instead of 1000 to wait 20% more
	Sleep((1200 * N_BUFIN * IN_BUF_LEN / 2) / SAMPLES_PER_SEC); 
	// --------------------------------------------------------------- pause and reset
	waveOutPause(hwOut);
	waveOutReset(hwOut);
	// --------------------------------------------------------------- unprepare all the headers 
	for (int i = 0; i < N_BUFOUT; i ++)
    {
		waveOutUnprepareHeader(hwOut, &pwhOut[i], sizeof(WAVEHDR));
	}
	// --------------------------------------------------------------- close
    waveOutClose(hwOut);
}


// ================================================================================================
// ================================================================================================
//   SET WINDOW CLIENT-RECT and POSITION 
// ================================================================================================
// ================================================================================================ 
void SetWindowClientRect(int ClientX, int ClientY)
{
	if (!AfxGetApp()->m_pMainWnd) return;
	// --------------------------------------------------------------------------------------------
	//  TRY A WINDOW SIZE - TEST and CORRECT
	// --------------------------------------------------------------------------------------------
	HWND hWnd = AfxGetApp()->m_pMainWnd->m_hWnd;
	// -------------------------------------------------------------------------- first try
	SetWindowPos(hWnd, HWND_TOP, 0, 0, ClientX, ClientY, SWP_NOMOVE);
	// -------------------------------------------------------------------------- test
	RECT r;
	GetClientRect(hWnd, &r);
	// -------------------------------------------------------------------------- final correction
	ClientX += ClientX - r.right + 4;
	ClientY += ClientY - r.bottom - 10;
	SetWindowPos(hWnd, HWND_TOP, 0, 0, ClientX, ClientY, SWP_NOMOVE);
}

// ================================================================================================
// ================================================================================================
//   DAA - RESIZE
// ================================================================================================
// ================================================================================================

int displayUpdateDelayCounter = 10;

void DAA_Resize(CDC* pDC, UINT nType, int cx, int cy)
{
	// ------------------------------------------------------------------------
	//  when resizing stop the display update for 100 mS
	// ------------------------------------------------------------------------
	displayUpdateDelayCounter = 10;

	// ------------------------------------------------------------------------
	// This function is called when Maximizing 
	// This function is called when Restoring from maximized
	// This function is NOT called when minimizing and restoring from minimize 
	// ------------------------------------------------------------------------
	// nType is always = 0 
	// ------------------------------------------------------------------------
	/*CString s;
	s.Format(" %d ", nType);
	OutputDebugString(s);*/
	// ------------------------------------------------------------------------
	if (cx < 1 || cy <1) return;
	if (!pDC) return;
	nType;

	// ------------------------------------------------------------------------
	// RESIZE (why + 14 ???)
	resizedClientX = cx;
	resizedClientY = cy + 14;
}

// ================================================================================================
// ================================================================================================
//   ON IDLE 
// ================================================================================================
// ================================================================================================ 
void DAA_OnIdle(CDC* pDC)
{
	// ---------------------------------------------------------------- RESIZE
	if (resizedClientX != CLIENT_X || resizedClientY != CLIENT_Y)
	{
		if (!LButtonPressed())
		{
			// -------------------------------------------------------- limit dimensions
			if (resizedClientX < 873) resizedClientX = 873;
			if (resizedClientY < 610) resizedClientY = 610;
			if (resizedClientX > 9000) resizedClientX = 9000;
			if (resizedClientY > 9000) resizedClientY = 9000;
			// -------------------------------------------------------- resize all
			CLIENT_X = resizedClientX;
			CLIENT_Y = resizedClientY;
			DAA_CreateInstrument(pDC);
			// -------------------------------------------------------- resize window
			SetWindowClientRect(resizedClientX, resizedClientY);
		}
	}

	// ---------------------------------------------------------------- UPDATE DISPLAY (eventually delayed)
	if (displayUpdateDelayCounter-- > 0) 
	{
		Sleep(10); 
		return;
	}
	else
	{
		if (!Calibrating)
		{
			// -------------------------------------------------- STOP DELAY CHANGES timed reset
			if (StopDelayChanges > 0) StopDelayChanges--;

			// -------------------------------------------------- STOP LEVEL CROSSED TEST
			if (StopLevelCrossed)
			{
				//Beep(1000, 50);
				Sleep(40);
				DAA_InputOff();
				kbInOnOff.PressKey(pDC, 0);
				trigsample = StopLevelCircularBufferPos;
				StopLevelCrossed = false; // <-- this line must be at the end
			}

			// --------------------------------------------------- TIMED DISPLAY
			display.DisplayAll(pDC);  
		}
	}

}

BOOL CDaaApp::OnIdle(LONG lCount) 
{ 
	lCount;
	//
    InitTime();

    CMainFrame *wnd = (CMainFrame *) m_pMainWnd;
	CDaaView *viewwnd = (CDaaView *) wnd->GetActiveView ();
    CDC* pDC = viewwnd->GetDC();
	DAA_OnIdle(pDC);
    viewwnd->ReleaseDC(pDC);

	// --------------------------------------------------------- 20000 uS = 50 Hz refresh
    while (GetTime() < 20000) Sleep(5);
	Sleep(1);

	// --------------------------------------------------------- Detect if the window is minimized
	WINDOWPLACEMENT wpl;
	m_pMainWnd->GetWindowPlacement(&wpl);
	WindowMinimized = wpl.showCmd == 2; 

	// --------------------------------------------------------- Update menu for InputDevices
	static int oldInDevice = inputDevice;
	CMenu* pInSubMenu;
	pInSubMenu = m_pMainWnd->GetMenu()->GetSubMenu(IN_DEVICES_SUBMENU);
	if (pInSubMenu->GetMenuItemCount() != waveInGetNumDevs() || oldInDevice != inputDevice)
	{
		AddInputDevicesMenu();
		theApp.m_pMainWnd->DrawMenuBar(); // refresh menu
	}
	oldInDevice = inputDevice;

	// --------------------------------------------------------- Update menu for OutputDevices
	static int oldOutDevice = outputDevice;
	CMenu* pOutSubMenu;
	pOutSubMenu = m_pMainWnd->GetMenu()->GetSubMenu(OUT_DEVICES_SUBMENU);
	if (pOutSubMenu->GetMenuItemCount() != waveOutGetNumDevs() || oldOutDevice != outputDevice)
	{
		AddOutputDevicesMenu();
		theApp.m_pMainWnd->DrawMenuBar(); // refresh menu
	}
	oldOutDevice = outputDevice;

    return true;
}







